<%@ page info="HP Systems Insight Manager"
    import="com.hp.mx.database.*,
            java.sql.Connection,
            java.sql.ResultSet,
            java.sql.ResultSetMetaData,
            java.sql.DatabaseMetaData,
            java.sql.Statement"%>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.MxCMS" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
%>

<HTML>
<HEAD>




<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>
<script>
    <%-- // This doesn't work in Mozilla
    //document.styleSheets[0].addRule("TD", "{font-family:verdana; font-size:8pt}");
    --%>
    function getEventSrc(e)
    {
        if (document.all)
            return event.srcElement;

        var src = e.target;
        while (src.nodeType != src.ELEMENT_NODE)
            src = src.parentNode;

        return src;
    }

    function addKeyword(e)
    {
        // Give focus to the text area and update the text
        document.getElementById("txtSqlQuery").focus();
        document.getElementById("txtSqlQuery").value += getEventSrc(e).value;
        document.getElementById("txtSqlQuery").value += " ";
    }

    function cannedQuery(query)
    {
        // Give focus to the text area and update the text
        document.getElementById("txtSqlQuery").focus();
        document.getElementById("txtSqlQuery").value = query;
        document.getElementById("sqlForm").submit();
    }

    // Define canned queries
    var qAllDevices = "SELECT devices.OverallStatus, devices.Name, devices.ProductType,  devices.DeviceKey ";
    qAllDevices += "FROM  devices  ";
    qAllDevices += "ORDER BY OverallStatus DESC ";

    var qCriticalDevices = "SELECT  notices.noticeId, devices.overallStatus, associated_device_data.associatedDeviceStatus, ";
        qCriticalDevices += "case when DeviceStatusValue.StatusValue is null and (devices.ProductType=1 and (lower(DB_DeviceInfoEx.OSType) = 'WINNT' or lower(DB_DeviceInfoEx.OSType) = 'LINUX')) then 13 else DeviceStatusValue.StatusValue end as StatusValue, ";
        qCriticalDevices += "LockdownStatus.ldStatus, devices.Name, devices.ProductType, ipAddress.ipAddress, devices.productName, DB_DeviceInfoEx.OSName, devices.deviceKey, devices.fullDNSName, associated_device_data.associatedDeviceKey, ";
        qCriticalDevices += "associated_device_data.associatedDeviceName, ipxAddress.ipxAddress, associated_device_data.associatedDeviceType, devices.timeStamp, notices.timeStamp ";
        qCriticalDevices += "FROM devices  JOIN notices ON devices.deviceKey = notices.deviceKey and notices.NoticeType = 1 ";
        qCriticalDevices += "LEFT OUTER JOIN DB_deviceInfoEx ON devices.deviceKey = DB_deviceInfoEx.deviceKey LEFT OUTER JOIN IPAddress ON devices.deviceKey = IPAddress.deviceKey and IPAddress.ipIndex = 0 ";
        qCriticalDevices += "LEFT OUTER JOIN IPXAddress ON devices.deviceKey = IPXAddress.deviceKey and IPXAddress.ipxIndex = 0 LEFT OUTER JOIN associated_device_data ON devices.deviceKey = associated_device_data.deviceKey  ";
        qCriticalDevices += "LEFT OUTER JOIN deviceProtocolInfo ON devices.deviceKey = deviceProtocolInfo.deviceKey LEFT OUTER JOIN LockdownStatus ON devices.deviceKey = LockdownStatus.deviceKey  ";
        qCriticalDevices += "LEFT OUTER JOIN DeviceStatusValue ON devices.deviceKey = DeviceStatusValue.deviceKey and DeviceStatusValue.StatusSourceId= 6 ";
//      JOIN consolidatedNodeAuths ON devices.mxGuid = consolidatedNodeAuths.NodeId and consolidatedNodeAuths.userID = '00000000864162de0000000400000007'
        qCriticalDevices += " WHERE (  devices.OverallStatus = 5 ) ";
        qCriticalDevices += "ORDER BY Name ";

    var qSMIDevices = "SELECT devicekey, name, fulldnsname, discoveredname, durablename, producttypestr, producttype, productSubType, subtype2, subtype3, subtype4, subtype5, subtype6, subtype7, subtype8 " +
                      "FROM devices WHERE productSubType='SMI' or subtype2='SMI' or subtype3='SMI' or subtype4='SMI' or subtype5='SMI' or subtype6='SMI' or subtype7='SMI' or subtype8='SMI' " +
                      "ORDER BY deviceKey";

    var qCIMComputerSystems = "SELECT * from CIM_ComputerSystem "+
                              "ORDER BY nodeId";

    var qCIMNetworkPorts = "SELECT d.devicekey, d.name, np.deviceid, np.portnumber, np.permanentaddress FROM cim_networkport np, devices d WHERE np.nodeid=d.devicekey ORDER BY d.devicekey, np.permanentaddress";

    var qMatchedDevices = "select cs.nodeid, cs.name, d.name, d.producttypestr from cim_computersystem cs, devices d where d.devicekey=cs.nodeid and cs.name=d.durableName";

    var qPortCount = "select count(*), d.name from cim_networkport np, devices d where np.nodeid=d.devicekey group by d.name";

    var qStorageVolumeCount = "select count(*), d.name from cim_storagevolume sv, devices d where sv.nodeid=d.devicekey group by d.name";

    var qCIMProductInfo = "select d.devicekey, d.name, p.elementname, p.identifyingnumber, p.name, p.vendor, p.version from cim_product p, devices d where d.devicekey=p.nodeid";

    var qCIMSoftwareInfo = "select d.devicekey, d.name, si.manufacturer, si.versionstring, si.instanceid from cim_softwareidentity si, devices d where d.devicekey=si.nodeid";
    var qCIMSoftwareClassificationInfo = "SELECT d.devicekey, d.name, d.producttypestr, cv.classificationsvalue, si.versionstring, si.manufacturer FROM devices d INNER JOIN cim_softwareidentity si ON d.devicekey = si.nodeid LEFT OUTER JOIN classifications_values cv ON si.SoftwareIdentity_LUID = cv.classificationsid ORDER BY d.devicekey, cv.classificationsvalue";

    var qSEManaged = "SELECT name, durablename, productname, producttypestr, productsubtype, subtype2, MxGUID FROM devices WHERE productSubType='StorageEssentials' or subtype2='StorageEssentials' or subtype3='StorageEssentials' or subtype4='StorageEssentials' or subtype5='StorageEssentials' or subtype6='StorageEssentials' or subtype7='StorageEssentials' or subtype8='StorageEssentials' ORDER BY name";
    var qHasSEID = "SELECT d.name, d.durablename, d.productname, d.producttypestr, d.productsubtype, d.subtype2, d.MxGUID, dp.propertyvalue FROM devices d, deviceProperties dp WHERE (d.devicekey=dp.devicekey) AND (dp.propertyname='SEID') ORDER BY d.name";
    var qSEEvents = "SELECT n.noticeid, d.name, nt.typeidstr, n.cleared FROM noticeType nt, notices n, devices d WHERE (nt.noticetype=n.noticetype) AND (n.devicekey=d.devicekey) AND (nt.category='Storage Essentials') ORDER BY n.noticeid";
    var qSEAssociatedEvents = "SELECT n.noticeid, d.name, dp.propertyvalue, nt.typeidstr, n.cleared FROM noticeType nt, notices n, devices d, deviceProperties dp WHERE (nt.noticetype=n.noticetype) AND (n.devicekey=d.devicekey) AND (nt.category='Storage Essentials') AND (d.devicekey=dp.devicekey) AND (dp.propertyname='SEID') ORDER BY n.noticeid";
    var qSEEventXML = "SELECT n.noticeid, d.name, nt.typeidstr, n.cleared, nx.XMLData FROM noticeType nt, notices n, devices d, noticeXMLData nx WHERE (nt.noticetype=n.noticetype) AND (n.devicekey=d.devicekey) AND (nt.category='Storage Essentials') AND (n.noticeid=nx.noticeid) ORDER BY n.noticeid";

    var msSqlLocks = "use master;select * from dbo.sysprocesses  ";
</script>

</HEAD>
<BODY>


<%
    Connection myConnection = null;
    Statement p = null;
    ResultSet  rSet = null;
    try
    {
        // Begin Database setup
        myConnection = DatabaseManager.getDefaultDatabase().getConnection("JSP Page: dbgSqlQuery.jsp");

        // Get database metadata to display table names later
        DatabaseMetaData dbmd = myConnection.getMetaData();

        // Specifiy TABLE to prevent seeing system tables
        String[] tableTypes = {"TABLE"};
        ResultSet allTables = dbmd.getTables(null, null, null, tableTypes);
%>
    <form name="sqlForm" id="sqlForm" action="dbgSqlQuery.jsp" method="post">

        Type the SQL query in the text area (or use the helper buttons) then submit.<br><br>


        <input type="button" onClick="addKeyword(event)" value="SELECT">
        <input type="button" onClick="addKeyword(event)" value="FROM">
        <input type="button" onClick="addKeyword(event)" value="SELECT * FROM">
        <input type="button" onClick="addKeyword(event)" value="WHERE">
        <input type="button" onClick="addKeyword(event)" value="ORDER BY">
        <select name="tableNames" size="1" onChange="addKeyword(event)">
            <option value='none'>[select database table]</option>
<%
            // Display database table names
            while (allTables.next())
            {
                String tName = allTables.getString("TABLE_NAME");
                out.println("<option value='" + tName + "'>" + tName + "</option>");
            }

%>
        </select>

        <br>

        <textarea cols="100" rows="10" name="txtSqlQuery" id="txtSqlQuery"></textarea>

        <br>

    <input type="submit" value="Submit Query">
    </form>

    Select a pre-written query to execute.<br><br>
<%
if (MxCMS.isMsSQL())
{
%>
    <a href="javaScript: void cannedQuery(msSqlLocks)">MSSQL Server Locks</a><br>
<%
}
%>
    <a href="javaScript: void cannedQuery(qAllDevices)">All Devices</a> (Different than SELECT * FROM devices)<br>
    <a href="javaScript: void cannedQuery(qCriticalDevices)">Critical Devices</a><br>
    <a href="javaScript: void cannedQuery(qSMIDevices)">SMI Devices</a><br>
    <a href="javaScript: void cannedQuery(qCIMComputerSystems)">CIM_ComputerSystems</a><br>
    <a href="javaScript: void cannedQuery(qCIMNetworkPorts)">CIM_NetworkPorts</a><br>
    <a href="javaScript: void cannedQuery(qMatchedDevices)">CIM_ComputerSystems successfully matched with Devices</a><br>
    <a href="javaScript: void cannedQuery(qPortCount)">CIM_NetworkPort count per device</a><br>
    <a href="javaScript: void cannedQuery(qStorageVolumeCount)">CIM_StorageVolume count per device</a><br>
    <a href="javaScript: void cannedQuery(qCIMProductInfo)">CIM_Product information per device</a><br>
    <a href="javaScript: void cannedQuery(qCIMSoftwareInfo)">CIM_SoftwareIdentity information per device</a><br>
    <a href="javaScript: void cannedQuery(qCIMSoftwareClassificationInfo)">CIM_SoftwareIdentity information per device with classifications</a><br>
<%
if ("true".equals(GlobalSettings.getProperty("StorageEssentialsConnectorInstalled", "false")))
{
%>
    <h3>Storage Essentials</h3>
    <a href="javaScript: void cannedQuery(qSEManaged)">Systems with Storage Essentials Managed Subtype</a><br>
    <a href="javaScript: void cannedQuery(qHasSEID)">Systems with a SEID property</a><br>
    <a href="javaScript: void cannedQuery(qSEEvents)">Storage Essentials events</a><br>
    <a href="javaScript: void cannedQuery(qSEAssociatedEvents)">Storage Essentials events associated with an SEID</a><br>
    <a href="javaScript: void cannedQuery(qSEEventXML)">Storage Essentails events with related XML</a><br>

<%
}
%>




    <%
        String theSqlQuery = request.getParameter("txtSqlQuery");
        if (theSqlQuery != null)
        {
            // Replacx carriage returns with spaces to generate proper HTML after POST
            theSqlQuery = theSqlQuery.replace('\n', ' ');
            theSqlQuery = theSqlQuery.replace('\r', ' ');
    %>

<script>
        document.getElementById("txtSqlQuery").value += "<%= theSqlQuery %> "
</script>

    <div class=XePageTitle align="center">SQL QUERY RESULTS</div>
    <%
            // Continue accessing the database
            int dvcCount = 0;
            String bgColor = "#FFFFFF";

            p = myConnection.createStatement();

            if (theSqlQuery.toUpperCase().indexOf("SELECT") != -1 )
            {
            rSet = p.executeQuery(theSqlQuery);

            // Display the result set in a table
            out.println("<table width='100%' border='1' cellspacing='0' cellpadding='2' bordercolor='Black'>");

            // First, display the column headers
            out.println("<TR style='color:white; background:#006699'>");
            ResultSetMetaData rsmd = rSet.getMetaData();
            int columnCount = rsmd.getColumnCount();
            for (int col=1; col <= columnCount; col++)
            {
                out.println("<TD style=\"font-family:verdana; font-size:8pt\">" + rsmd.getColumnLabel(col) );
                out.println("("+rsmd.getColumnTypeName(col)+")");
                out.println("</td>");
            }
            out.println("</TR>");

            // Next, display the results
            while (rSet.next())
            {
                if ((dvcCount %2) == 0)
                    bgColor = "#CCCCCC";
                else
                    bgColor = "#FFFFFF";
                out.println("<TR bgColor='" + bgColor + "'>");
                for (int col=1; col <= columnCount; col++)
                {
                    Object obj = rSet.getString(col);
                    String val = "";
                    if (obj != null)
                        val = obj.toString().trim();
                    if (val.length() == 0)
                        out.println("<TD>&nbsp;</TD>");
                    else
                        out.println("<TD style=\"font-family:verdana; font-size:8pt\">" + val + "</TD>");

                }
                out.println("</TR>");
                dvcCount++;
            }
            out.println("</TABLE>");
            out.println("<BR><BR>ROW COUNT: " + dvcCount);

            }
            else
            {
                p.executeUpdate(theSqlQuery);
                out.println("<br> statement executed <br>");
            }


        }
    }
    catch (Exception ex)
    {
        out.println("<span class=errorText>Exception occurred while trying to access the database..Bummer!</span><BR>");
        out.println(ex +"<BR>");
    }
    finally
    {
        try
        {
            // Database cleanup
            if (rSet != null)
                rSet.close();
            if (p != null)
                p.close();
        }
        catch (Exception ex)
        {
        }
        DatabaseManager.getDefaultDatabase().releaseConnection(myConnection);
    }

%>


<script>
    // Give focus to the text area when document loads
    document.getElementById("txtSqlQuery").focus()
</script>
</BODY>
</HTML>

