<%--
/*-----------------------------------------------------------------------------
Copyright 1998,99 Compaq Computer Corporation
-------------------------------------------------------------------------------
$Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxdebug/debugMultiView.jsp,v 1.8 2005/05/19 19:57:09 gschunicht Exp $
----------------------------------------------------------------------------*/
--%>

<%@ page import="com.hp.mx.utilities.*"%>
<%@ page import="java.util.*"%>
<%@ page import="javax.swing.tree.*"%>

<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="XEUtil" scope="session" class="com.hp.mx.portal.applet.utilities.XeJspUtil"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="nodeResources" class="com.hp.mx.portal.res.MxResourceBean" scope="page" />
<jsp:useBean id="debugTreeView" class="com.hp.mx.utilities.DebugTreeTableView" scope="session"/>

<%!
    class DbgStringComparer implements com.hp.mx.utilities.ObjectArraySorter.SorterCompare
    {
        boolean descrSort = false;
        public DbgStringComparer(boolean sortDescr)
        {
            descrSort = sortDescr;
        }

        public int compare(Object n1, Object n2)
        {
            DebugSubsystem ds1 = (DebugSubsystem)n1;
            DebugSubsystem ds2 = (DebugSubsystem)n2;

            String s1;
            String s2;
            if (descrSort)
            {
                s1 = ds1.getDescription();
                s2 = ds2.getDescription();

            }
            else
            {
                s1 = ds1.getName();
                s2 = ds2.getName();
            }

            if (s1 == null && s2 == null)
            {
                return 0;
            }

            if (s1 == null)
            {
                return -1;
            }
            if (s2 == null)
            {
                return 1;
            }

            return s1.compareToIgnoreCase(s2);
        }
    }

    class DebugCheckBox
    {
        private JspWriter      jspWriter      = null;
        private Hashtable      subSystems     = null;
        private DebugSubsystem debugSubsystem = null;

        public DebugCheckBox( Hashtable subsystems , JspWriter out )
        {
            this.jspWriter  = out;
            this.subSystems = subsystems;
        }

        public DebugCheckBox setSubsystem( String id )
        {
            debugSubsystem = (DebugSubsystem)subSystems.get(id);
            return this;
        }

        public DebugSubsystem getSubsystem()
        {
            return debugSubsystem;
        }

        public void emit( String id , String description )
            throws java.io.IOException
        {
            setSubsystem(id);
            if( debugSubsystem == null )
            {
                debugSubsystem = DebugOutput.getAlternateDebugSubsystem(id, "");
            }

            boolean subsystemEnabled = debugSubsystem.getEnabled();
            String  color            = subsystemEnabled ? "red" : "black";

            HTMLTag checkboxTag = HTMLTag.CHECKBOX();
            checkboxTag
                .setId(id)
                .setName(id+"_enabled")
                .setChecked(subsystemEnabled)
                .setAttr("size","100")
                ;

            HTMLTag fontTag = HTMLTag.FONT();
            fontTag.setAttr("color",color);

            HTMLTag labelTag = HTMLTag.LABEL(id,description);

            checkboxTag.emit( jspWriter );
            jspWriter.println( fontTag.toString( labelTag.toString(description) ) );
        }
    }

%>

<%
    MxBean.jspInit(request, response);

    // set up the resource file
    nodeResources.init(loginBean, "DebugTreeView");

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // preset the expansion nodes
    debugTreeView.setResources(nodeResources);
    debugTreeView.setExpandedNodes("com;com.hp;",false);
    debugTreeView.setScrollHeight("80%");

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
%>

<html>
    <head>
        <%
        MxHtmlUtil.dumpLinkToScript(MxHtmlUtil.JS_MxDebug, MxHtmlUtil.INCLUDE_TAGS, out);
        MxHtmlUtil.dumpHeadBegin(out);
        %>

        <title>Debug Level Configuration</title>

        <script language="JavaScript" src="../javascript/XeGlobalFunctions.js" type=""></script>
        <script language="JavaScript" src="../javascript/XeHelp.js" type=""></script>
        <script language="JavaScript" src="../javascript/layout.js" type=""></script>

        <script language="javascript" type="">
        function setValues(val)
        {
            var elements = document.getElementsByTagName("input")
            for( var e = 0 ; e < elements.length ; e++ )
            {
                var element = elements[e];
                if( element.type== "text" )
                {
                    element.value = val;
                }
            }
        }

        function toggleCheckboxes(enableFlag)
        {
            var elements = document.getElementsByTagName("input")
            for( var e = 0 ; e < elements.length ; e++ )
            {
                var element = elements[e];
                if( element.type== "checkbox" )
                {
                    element.checked = enableFlag;
                }
            }

        }

        function getAlternateDebugs()
        {
            var altDebugStr = document.form1.AlternateDbgName.value;
            location.replace("debugMultiView.jsp?AlternateDebug="+ altDebugStr);
        }

        function getSelectedAlternateDbgName()
        {
            return document.form1.AlternateDbgName.value;
        }

        function getSelectedDebugView()
        {
            var select = document.getElementById('debugViewSelect');
            return select.value;
        }

        function repaintPage()
        {
            var newURL = 'debugMultiView.jsp?';
            newURL += 'debugViewSelect='+getSelectedDebugView();
            newURL += '&AlternateDebug='+getSelectedAlternateDbgName();
            location.replace(newURL);
        }

        function selectDebugView()
        {
            repaintPage();
        }

        function doEditBox( editBox )
        {
            var id = editBox.id;
            id = id.substr(4);  // remove the edt_ portion...

            var span = document.getElementById(id);
            if( span == null )
                return;

            var elts = span.getElementsByTagName("input");
            for( var x=0 ; x<elts.length ; x++ )
            {
                var element = elts[x];
                if (  element.type== "text" && ( element.id.indexOf(id) != -1 ) )
                {
                    element.value = editBox.value;
                }
            }
        }

        function doCheckBox( chkbox )
        {
            var id = chkbox.id;
            id = id.substr(4);  // remove the chk_ portion...

            var span = document.getElementById(id);
            if( span == null )
                return;

            var elts = span.getElementsByTagName("input");
            for( var x=0 ; x<elts.length ; x++ )
            {
                var element = elts[x];
                if (  element.type== "checkbox" && ( element.id.indexOf(id) != -1 ) )
                {
                    element.checked = chkbox.checked;
                }
            }
        }

        function isSpanExpanded( span )
        {
            return (span.style.display != "none");
        }

        function doExpand( id )
        {
            var span = document.getElementById(id);
            if( span == null )
                return;
            doSpanExpand( span , !isSpanExpanded(span) );   // toggle the expansion state
        }

        function doSpanExpand( span , do_expansion )
        {
            var id = span.id;

            var img = document.getElementById("img_"+id);
            if( img == null )
                return;

            // this is hacky -- testing for the disabled graphic to find out if we can expand it or not...
            if( img.src.indexOf("<%= DebugTreeTableView.MXHTML_LEAF_IMAGE %>") != -1 )
            {
                return;
            }
            if( do_expansion )
            {
                img.src = "<%= DebugTreeTableView.MXHTML_CONTRACT_IMAGE %>";
                span.style.display = "";
            }
            else
            {
                img.src = "<%= DebugTreeTableView.MXHTML_EXPAND_IMAGE %>";
                span.style.display = "none";
            }
        }

        function doExpandAll( expandAll )
        {
            // build a cache of the spans containing children nodes, but do it only the first time...
            if( nodeSpans.length == 0 )
            {
                var spans = document.getElementsByTagName("span");

                for( var s = 0 ; s < spans.length ; s++ )
                {
                    var span = spans[s];

                    if( span.id.indexOf("node_") == 0 )
                    {
                        nodeSpans[nodeSpans.length] = span;
                    }
                }
            }

            for( var s = 0 ; s < nodeSpans.length ; s++ )
            {
                doSpanExpand( spans[s] ,expandAll);
            }
        }

        var nodeSpans = [];     // the cache of the spans containing children nodes...

        function extractNodePath( spanId , spanIdPrefix , hiddenPrefix )
        {
            // since spans don't support a name attribute, a hidden input field was created to hold the package
            // path associated with the span, this function extract that path from the given span...
            if( spanIdPrefix.length > 0 )
            {
                if( spanId.indexOf(spanIdPrefix) != 0 )
                {
                    return "";
                }
            }

            var baseId = spanId.substr( spanIdPrefix.length );    // remove the prefix to get the base id
            var hidden = document.getElementById(hiddenPrefix+baseId);
            if( hidden == null )
            {
                return "";
            }

            return hidden.value;
        }

        function OnSubmit()
        {
            var expandedNodes = "";

            var spans = document.getElementsByTagName("span");
            for( var s = 0 ; s < spans.length ; s++ )
            {
                var span = spans[s];

                if( isSpanExpanded(span) )
                {
                    if( expandedNodes != "" )
                        expandedNodes += ";"

                    // get the associated pathname out of the hidden field...
                    expandedNodes += extractNodePath(span.id,"","nodepath_");
                }
            }

            document.form1.expandedNodes.value = expandedNodes;
            return true;
        }

        </script>

        <LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css"/>
        <STYLE TYPE="text/css">
            .myTd  {color:#000000; font-family:arial; font-size:10pt;}
            TH     { color:white; background:#006699;  font-family:arial;font-size:10pt; }
            .dbgSettingsTable{background:CCCCCC}
            .short{height:15px; font-family:verdana; line-height : 5pt;}
            .nodeNormal { color:#000000; font-weight:bold; font-style:normal }
            .leafNormal { color:#000000; font-weight:normal; font-style:italic }
            .nodeSelected { color:#ff0000; font-weight:bold; font-style:normal }
            .leafSelected { color:#ff0000; font-weight:normal; font-style:italic }
        </STYLE>
        <%
        MxHtmlUtil.dumpHeadEnd(out);
        %>

    </head>

    <body>
    <%
    // check to see if there are form variables for us to process.  if there are then process them now
    int DEBUGVIEW_TYPE_BRIEF   = 0;
    int DEBUGVIEW_TYPE_VERBOSE = 1;
    int DEBUGVIEW_TYPE_TREE    = 2;

    //int selectedDebugViewType  = DEBUGVIEW_TYPE_BRIEF;
    int selectedDebugViewType  = DEBUGVIEW_TYPE_TREE;

    String debugViewTypeParam = request.getParameter("debugViewSelect");
    if( debugViewTypeParam != null )
    {
        selectedDebugViewType = Integer.parseInt(debugViewTypeParam);
    }

    String  currentDebugSetting = "DomainManager";
    String  AlternateDebugs     = request.getParameter("AlternateDebug");
    boolean isAlternateDebug    = false;

    // are we on the ui settings page or standard server side debugs
    Hashtable subsystems = null;

    if (AlternateDebugs != null && AlternateDebugs.length() > 0)
    {
        isAlternateDebug = true;
        currentDebugSetting = AlternateDebugs;
        DebugOutput.setAlternateDebugSettingFile(AlternateDebugs);
        subsystems = DebugOutput.getAlternateSubSystems();
    }
    else
    {
        subsystems = DebugOutput.getSubSystems();
    }

    String checked = "";
    String color   = "black";

    DebugSubsystem debugSubsystem = null;

    Enumeration e          = subsystems.elements();
    int numDebugSubsystems = subsystems.size    () - 3; // Number of Settable Items, less the 3 globals

    if (request.getMethod().equalsIgnoreCase("post"))
    {
        if (request.getParameter("showConsole") != null)
        {
            if (com.hp.mx.startup.MainWbemFrame.getIsShowing() == false)
            {
                com.hp.mx.startup.MainWbemFrame myConsole = new com.hp.mx.startup.MainWbemFrame(" Stats Console");
                myConsole.init();
                myConsole.setVisible(true);
                myConsole.show();
            }
        }

        while (e.hasMoreElements())
        {
            debugSubsystem = (DebugSubsystem)e.nextElement();

            String name  = debugSubsystem.getName().toString();
            String query = request.getParameter(name + "_enabled");


            // look for debug enablement
            if (query != null)
            {
                debugSubsystem.setEnabled(true);
            }
            else
            {
                debugSubsystem.setEnabled(false);
            }

            // look for the debug level parameters
            query = request.getParameter(name + "_level");
            if (query != null)
            {
                try
                {
                    int level = Integer.parseInt(query);
                    debugSubsystem.setLevel(level);
                }
                catch (Exception ne)
                {
                }
            }


            // Update internal debug settings
            if (isAlternateDebug)
            {
                DebugOutput.addToAlternateProps(debugSubsystem);
            }
            else
            {
                DebugOutput.addToProps(debugSubsystem);
            }
        }

        DebugOutput.dumpEnabledDebugsToLog();

        // Update the debugsettings.props file
        if (isAlternateDebug)
        {
            DebugOutput.saveAlternateProps();
        }
        else
        {
            DebugOutput.saveProps();
        }

        String expandedNodes = (String)request.getParameter("expandedNodes");
        if( expandedNodes != null )
        {
            debugTreeView.setExpandedNodes(expandedNodes,true);
        }

        HTMLTag javascriptTag = HTMLTag.JAVASCRIPT();
        javascriptTag.emit(out,"window.history.go(-1);");

        MxHtmlUtil.dumpBodyEnd(out);
        out.println("</body></html>");

        return;
    }

    String formAction = "debugMultiView.jsp";
    if (isAlternateDebug)
    {
        formAction += "?AlternateDebug="+AlternateDebugs;
    }

    HTMLTag formTag = HTMLTag.FORM();
    formTag
        .setIdAndName("form1")
        .setAttr("method","post")
        .setAttr("action",formAction)
        .setAttr("onSubmit","return OnSubmit();")
        ;

    out.print( formTag.toString() );
    %>
        <table cellpadding="4" cellspacing="0">
            <tr align="left" valign="top">
                <td width="66%">
                    Set HP SIM debug settings for the selecte process below then click "Apply Changes" for those changes to take effect.
                    <br/>
                    <table>
                        <tr>
                            <td>Currently selected process is:</td>
                            <td>
                                <font color="blue">
                                    <b><%=currentDebugSetting %>. </b>
                                </font>
                            </td>
                        </tr>
                        <tr>
                            <td>Select other processes debug file: </td>
                            <td>
                                <select size="1" name="AlternateDbgName">

                                <%
                                    List allAlternates = DebugOutput.getListofAlternateDebugSettings();
                                    Iterator iter = allAlternates.iterator();
                                    while (iter.hasNext() )
                                    {
                                        String altFileName = (String)iter.next();
                                        String altFileNameDescr = altFileName;
                                        String selStr = "";
                                        if (currentDebugSetting.equals(altFileName))
                                        {
                                            selStr = "selected";
                                        }
                                %>
                                        <option value='<%=altFileName %>' <%=selStr %> >
                                            <%= altFileNameDescr %>
                                        </option>
                                <%
                                    }
                                %>
                                </select>
                                <input type="button" value="Go" onclick="getAlternateDebugs()" />
                            </td>
                        </tr>
                    </table>

                    <hr/>
                    Global Debug Settings for <%=currentDebugSetting %>:<br/>
                    <table>
                        <%
                            DebugCheckBox debugCheckBox = new DebugCheckBox(subsystems,out);
                        %>
                        <tr>
                            <td>
                                <% debugCheckBox.emit(DebugOutput.GLOBAL_FILEOUT_DEBUG,"Enable File output,"); %>
                                <br/>
                                <% debugCheckBox.emit(DebugOutput.GLOBAL_UNIQUE_FILEOUT_DEBUG,"Unique file names");%>
                            </td>
                            <td valign="top">

                                <%
                                if( debugCheckBox.getSubsystem().getEnabled() == false )
                                {
                                %>
                                    <a href="dbgLogFile.jsp?AlternateDebug=<%=currentDebugSetting %>">
                                        <%= MxPathProperty.getExpandedFilePath(MxPathProperty.LOG_EXP, currentDebugSetting).toString()+DebugOutput.DEFAULT_DEBUG_EXTENSION %>
                                    </a>

                                <%
                                }
                                else
                                {
                                %>

                                    Look for <%= MxPathProperty.getExpandedFilePath(MxPathProperty.LOG_EXP, currentDebugSetting).toString() +"<date>"+ DebugOutput.DEFAULT_DEBUG_EXTENSION%>

                                <%
                                }
                                %>

                            </td>
                        </tr>

                        <tr>
                            <td>
                                <% debugCheckBox.emit(DebugOutput.GLOBAL_ENABLEALL_DEBUG,"Enable All"); %>
                            </td>
                            <td>
                                <input type='Text'  class='short' name='<%=DebugOutput.GLOBAL_ENABLEALL_DEBUG %>_level'  value='<%= debugCheckBox.getSubsystem().getLevel() %>' size='3'/>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <% debugCheckBox.emit(DebugOutput.GLOBAL_TIMESTAMP_DEBUG,"Enable Timestamps"); %>
                            </td>
                            <td>
                                <input type='Text' class='short' name='<%=DebugOutput.GLOBAL_TIMESTAMP_DEBUG %>_level'  value='<%= debugCheckBox.getSubsystem().getLevel() %>' size='3'/> Set to 20 to see debug setting details
                            </td>
                        </tr>
                    </table>
                </td>
                <td width="33%">
                    <b>Default levels, click to set all debugs to selected level:</b>
                    <br/>
                    <a href="javascript:setValues(<%= 0 %>);" >Off</a> (<%= 0 %>),
                    <a href="javascript:setValues(<%= DebugSubsystem.DEBUG_LEVEL_SEVERE %>);" >Severe</a> (<%= DebugSubsystem.DEBUG_LEVEL_SEVERE %>),
                    <a href="javascript:setValues(<%= DebugSubsystem.DEBUG_LEVEL_ERROR %>);" >Error</a> (<%= DebugSubsystem.DEBUG_LEVEL_ERROR %>),
                    <a href="javascript:setValues(<%= DebugSubsystem.DEBUG_EXCEPTION %>);" >Exception</a> (<%= DebugSubsystem.DEBUG_EXCEPTION %>),
                    <a href="javascript:setValues(<%= DebugSubsystem.DEBUG_LEVEL_WARNING %>);" >Warning</a> (<%= DebugSubsystem.DEBUG_LEVEL_WARNING %>),
                    <a href="javascript:setValues(<%= DebugSubsystem.DEBUG_LEVEL_FINE %>);" >Fine</a> (<%= DebugSubsystem.DEBUG_LEVEL_FINE %>),
                    <a href="javascript:setValues(<%= DebugSubsystem.DEBUG_LEVEL_FINER %>);" >Finer</a> (<%= DebugSubsystem.DEBUG_LEVEL_FINER %>),
                    <a href="javascript:setValues(<%= DebugSubsystem.DEBUG_METHOD_ENTRY_LOGGING %>);" >Method enter and exit</a> (<%= DebugSubsystem.DEBUG_METHOD_ENTRY_LOGGING %>),
                    <a href="javascript:setValues(<%= DebugSubsystem.DEBUG_LEVEL_FINEST %>);" >Finest</a> (<%= DebugSubsystem.DEBUG_LEVEL_FINEST %>)
                    <br /><br />
                    Debug Setting View:
                    <br />
                    <%
                    String briefSelected   = (selectedDebugViewType == DEBUGVIEW_TYPE_BRIEF  ) ? "selected" : "";
                    String verboseSelected = (selectedDebugViewType == DEBUGVIEW_TYPE_VERBOSE) ? "selected" : "";
                    String treeSelected    = (selectedDebugViewType == DEBUGVIEW_TYPE_TREE   ) ? "selected" : "";
                    %>

                    <select name="debugViewSelect" id="debugViewSelect">
                        <option value="<%= DEBUGVIEW_TYPE_BRIEF   %>" <%= briefSelected   %> >Classic View (Brief)</option>
                        <option value="<%= DEBUGVIEW_TYPE_VERBOSE %>" <%= verboseSelected %> >Classic View (Verbose)</option>
                        <option value="<%= DEBUGVIEW_TYPE_TREE    %>" <%= treeSelected    %> >Hierarchical View</option>
                    </select>
                    <input type="button" value="Go" onclick="selectDebugView()" />
                    <br/>
                </td>
            </tr>
        </table>

        <br/>

        <%
        if( selectedDebugViewType == DEBUGVIEW_TYPE_TREE )
        {
            debugTreeView.dumpView(subsystems,out);
        }
        else
        {
        %>
            <table width="100%" border='0' cellspacing='0' cellpadding='0'>
                <tr>
                    <td valign="TOP" style="border-width: 4; border-color: #006699; border-style: solid;" class="dbgSettingsTable">

                        <%
                        int NUM_COLUMNS = 4;
                        String strHtmlColHdr     = "<table width=100% border=0 cellspacing=0 cellpadding=0><tr>\n<th></th>\n<th align=LEFT>DEBUG SETTING</th>\n<th align=CENTER>LEVEL</th>\n</tr>\n";
                        String strHtmlColBetween = "</td>\n<td ></td>\n<td   valign=TOP style='border-width: 4; border-color: #006699; border-style: solid;' class=dbgSettingsTable>\n";

                        if( selectedDebugViewType == DEBUGVIEW_TYPE_VERBOSE )
                        {
                            NUM_COLUMNS       = 1;
                            strHtmlColHdr     = "<table width=100% border=1 cellspacing=0 cellpadding=0><tr>\n<th></th>\n<th align=LEFT>DEBUG SETTING</th>\n<th align=CENTER>LEVEL</th><th>Description</th>\n</tr>\n";
                            strHtmlColBetween = "</td>\n<td width=5% style='width:25;'></td>\n<td width=30% valign=TOP style='border-width: 4; border-color: #006699; border-style: solid;' class=dbgSettingsTable>\n";
                        }

                        int currItemCount = 0;
                        int CurrentCol    = 0;
                        int numItemsInCol = 10;

                        if (numDebugSubsystems > 1)
                        {
                            numItemsInCol = ((numDebugSubsystems - 1) / NUM_COLUMNS) + 1;
                        }

                        // Display first column header
                        out.println (strHtmlColHdr);

                        e = subsystems.elements();
                        DbgStringComparer myCmp = new DbgStringComparer( selectedDebugViewType == DEBUGVIEW_TYPE_VERBOSE );

                        com.hp.mx.utilities.ObjectArraySorter dbgSorter = new com.hp.mx.utilities.ObjectArraySorter(e, myCmp);
                        dbgSorter.quickSort();

                        e = dbgSorter.getSortedElements();
                        while (e.hasMoreElements())
                        {
                            debugSubsystem = (DebugSubsystem)e.nextElement();

                            String debugSubsystemName = debugSubsystem.getName();
                            if( debugSubsystemName.equals(DebugOutput.GLOBAL_ENABLEALL_DEBUG) ||
                                debugSubsystemName.equals(DebugOutput.GLOBAL_FILEOUT_DEBUG  ) ||
                                debugSubsystemName.equals(DebugOutput.GLOBAL_TIMESTAMP_DEBUG) ||
                                debugSubsystemName.equals(DebugOutput.GLOBAL_UNIQUE_FILEOUT_DEBUG))
                            {
                                continue;
                            }

                            currItemCount++;
                            if (currItemCount > numItemsInCol)
                            {
                                // End the current column
                                out.println("</table>\n");

                                // Prep for new column if more columns exist
                                if (CurrentCol < NUM_COLUMNS)
                                {
                                    out.println (strHtmlColBetween);
                                    out.println (strHtmlColHdr);
                                    currItemCount = 1;
                                    CurrentCol++;
                                }
                            }
                        %>
                            <tr>
                                <td class='myTd'>

                                    <%
                                    String chkBoxName  = debugSubsystem.getName();
                                    String description = debugSubsystem.getDescription();

                                    if (debugSubsystem.getEnabled())
                                    {
                                        checked = "checked";
                                        color = "red";
                                    }
                                    else
                                    {
                                        color = "black";
                                        checked = "";
                                    }

                                    HTMLTag checkboxTag = HTMLTag.CHECKBOX();
                                    checkboxTag
                                        .setChecked( debugSubsystem.getEnabled() )
                                        .setId(chkBoxName)
                                        .setName(chkBoxName+"_enabled")
                                        ;

                                    out.println( checkboxTag.toString() );
                                    %>
                                </td>
                                <td class='myTd'>
                                    <font color="<%=color%>">
                                        <%
                                            HTMLTag labelTag = HTMLTag.LABEL();
                                            labelTag.setAttr("for",chkBoxName);

                                            if( description != null )
                                            {
                                                labelTag.setAttr("title",description);
                                            }

                                            out.println( labelTag.toString(chkBoxName) );
                                        %>
                                    </font>
                                </td>

                                <td align="CENTER" class='myTd'>
                                    <%
                                    HTMLTag textTag = HTMLTag.EDITBOX();
                                    textTag
                                        .setAttr("class","short")
                                        .setId(chkBoxName)
                                        .setName(chkBoxName+"_level")
                                        .setAttr("value",Integer.toString( debugSubsystem.getLevel() ) )
                                        .setAttr("size","3")
                                        ;

                                    if( description != null )
                                    {
                                        textTag.setAttr("title",description);
                                    }

                                    out.println( textTag.toString() );
                                    %>
                                </td>

                                <%
                                if( selectedDebugViewType == DEBUGVIEW_TYPE_VERBOSE )
                                {
                                    out.println("<td>");
                                    out.println("<font size='-1'>");

                                    if(description == null || description.length() == 0 )
                                    {
                                        out.println("none given");
                                    }
                                    else
                                    {
                                        out.println(description);
                                    }

                                    out.println("</font>");
                                    out.println("</td>");
                                }
                                %>
                            </tr>
                        <%
                        }
                        %>
                        </table>
                    </td>
                </tr>
            </table>
        <%
        }
        %>
        <input type="hidden" value="a" id="expandedNodes" name="expandedNodes" />
        <CENTER>
            <br/>
            <input type="Button" value="Select All" onClick='toggleCheckboxes(true)' />&nbsp;
            <input type="Button" value="Clear All"  onclick='toggleCheckboxes(false)'/>&nbsp;
            <input type="Submit" value="Apply Changes" id=Submit1 name=Submit1/>&nbsp;

            <%
            if (MxCMS.isWindows())
            {
                if (com.hp.mx.startup.MainWbemFrame.getIsShowing() == false)
                {
                    out.println("<input type=\"Submit\" value=\"Show server console\" id=showConsole name=showConsole> ");

                    out.println("<br> The console requires the domain manager to be run as: mxdomainmgr -Djava.awt.headless=false");
                }
            }
            %>

        </CENTER>
    </form>
    <%
    MxHtmlUtil.dumpBodyEnd(out);
    %>
    </body>
</html>
