
<%@ page import="java.util.*,
                 com.hp.mx.startup.*"
%>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="java.lang.reflect.Method" %>
<%@ page import="java.beans.BeanInfo" %>
<%@ page import="java.beans.IntrospectionException" %>
<%@ page import="java.beans.Introspector" %>
<%@ page import="java.beans.MethodDescriptor" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
%>

<HTML>
<HEAD>

<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">

</HEAD>
<BODY>
Thread stack dump.

<%

    try
    {

        // Since we compile with 4.2, needed way to still access the
        // 1.5 library data, without compile errors
        // replace this simple line with below
        // Map tmpMap = Thread.getAllStackTraces();
        Method getStackTraces = null;
        Method getThreadState = null;
        Method getThreadId= null;
        MethodDescriptor methods[] = null;
        try
        {
            BeanInfo bi = Introspector.getBeanInfo(Thread.class);
            methods = bi.getMethodDescriptors();
            for (int methPos=0; methPos < methods.length; methPos++)
            {
                if (methods[methPos].getName().equals("getAllStackTraces"))
                {
                    getStackTraces = methods[methPos].getMethod();
                }
                if (methods[methPos].getName().equals("getState"))
                {
                    getThreadState = methods[methPos].getMethod();
                }
                if (methods[methPos].getName().equals("getId"))
                {
                    getThreadId = methods[methPos].getMethod();
                }

                if (getStackTraces != null &&
                    getThreadState != null &&
                    getThreadId != null)
                    {
                        break;
                    }
            }
        }
        catch (IntrospectionException ex)
        {
            out.println("PropertyPanel: Couldn't introspect" + ex);
            return;
        }

        if (getStackTraces == null)
        {
            out.print("Could not get traces, not 1.5?");
            return;
        }

        Map tmpMap = (Map)getStackTraces.invoke(Thread.currentThread(), new Object[0]);


        Set tmpSet = tmpMap.keySet();
        Iterator iter = tmpSet.iterator();
        out.println("<br>");
        out.println("Thread Count = "+tmpMap.size());
        out.println("<br>");
        while (iter.hasNext() )
        {
            out.println("<br>");
            Thread th = (Thread)iter.next();


            //if (th.getState().equals(Thread.State.BLOCKED ))
            if (getThreadState.invoke(th, new Object[0]).toString().equals("BLOCKED") )
            {
                out.print("<b>");
            }
            out.print(th.getName());
            out.print(" (");
            out.print(getThreadState.invoke(th, new Object[0]));
            out.print(")</b>");
            out.print(" tid= ");
            out.print(getThreadId.invoke(th, new Object[0]));
            out.print(" pri= ");

            out.print(th.getPriority());

            out.println("<br>");
            StackTraceElement[] tmpSt = (StackTraceElement[])tmpMap.get(th);
            for (int elPos = 0; elPos < tmpSt.length; elPos++)
            {
                out.print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;+");
                out.print(tmpSt[elPos].toString());

                out.println("<br>");
            }
        }

    }
    catch (Exception ex)
    {
        out.print(ex.getMessage());
    }
%>

</BODY>
</HTML>
