<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" />
<%@ page import="com.hp.mx.html.table.GUIDOTable,
                 com.hp.mx.html.table.TreeTable,
                 com.hp.mx.html.table.AttributeValueTable,
                 com.hp.mx.portal.ui.MxBean,
                 com.hp.mx.core.nodemanager.MxNode,
                 com.hp.mx.core.persistence.databean.CIM_ComputerSystem,
                 com.hp.mx.core.persistence.databean.CIM_NetworkPort,
                 com.hp.mx.core.persistence.util.storage.BeanFinder,
                 com.hp.mx.core.persistence.util.storage.InterconnectDevice,
                 org.jfree.data.general.DefaultPieDataset,
                 org.jfree.chart.title.TextTitle,
                 java.awt.*,
                 com.hp.mx.utilities.PieChartFormatter,
                 org.jfree.chart.plot.PiePlot,
                 org.jfree.chart.JFreeChart,
                 java.util.*,
                 org.jfree.chart.ChartRenderingInfo,
                 org.jfree.chart.entity.StandardEntityCollection,
                 org.jfree.chart.servlet.ServletUtilities,
                 java.io.PrintWriter,
                 org.jfree.chart.ChartUtilities,
                 com.hp.mx.core.persistence.util.storage.Debug,
                 com.hp.mx.core.persistence.dataaccess.DataAccessException"
%>

<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="resource" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<div class="systemPageGroup">
<%
    /**
     * This panel will display capacity information for a given interconnect device.
     */

    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // setup resources.
    resource.init(loginBean, "StorageRelatedDevicePages");

    // keys to find system
    String durableName = deviceBean.getMxNode().getDurableName();
    int nodeID = deviceBean.getMxNode().getDeviceKey();

    GUIDOTable gt = new GUIDOTable(request.getLocale());
    String headers[] = { resource.getString("columnHeader.summary"),        // summary description
                         resource.getString("columnHeader.capacity") };     // capacity amount
    gt.setHeaders(headers);

    String filename = null;
    String graphURL = null;
    String pieChartCmd = "";
    boolean showPieChart = true;

    try {
        InterconnectDevice ic = new InterconnectDevice(nodeID, durableName);
        ArrayList rows = new ArrayList(3);          // we only track 3 metrics
        Long val;

        DefaultPieDataset pieDataset = new DefaultPieDataset();
        TextTitle title = null;
        Font font = null;

        String[] tableRow = new String[2];          // row has 2 columns
        tableRow[0] = resource.getString("metric.usedPorts");
        val = new Long(ic.getFreePorts());
        if (val.longValue() < 0) {
            tableRow[1] = resource.getString("metric.notFound");
            showPieChart = false;
        } else {
            tableRow[1] = val.toString();          // number of unused ports
            pieDataset.setValue(resource.getString("metric.usedPorts"),  val.longValue());
        }
        rows.add(tableRow);

        tableRow = new String[2];                   // row has 2 columns
        tableRow[0] = resource.getString("metric.freePorts");
        val = new Long(ic.getUsedPorts());
        if (val.longValue() < 0) {
            tableRow[1] = resource.getString("metric.notFound");
            showPieChart = false;
        } else {
            tableRow[1] = val.toString();           // number of free ports
            pieDataset.setValue(resource.getString("metric.freePorts"),  val.longValue());
        }
        rows.add(tableRow);

        tableRow = new String[2];                   // row has 2 columns
        tableRow[0] = resource.getString("metric.totalPorts");
        val = new Long(ic.getTotalPorts());
        if (val.longValue() < 0) {
            tableRow[1] = resource.getString("metric.notFound");
            showPieChart = false;
        } else {
            tableRow[1] = val.toString();           // number of total ports
            font = new Font("Arial", Font.BOLD, 12);
            title = new TextTitle(resource.getString("metric.portsTitle") + " " +
                    val.toString(), font);
        }
        rows.add(tableRow);

        gt.setRows(rows);

        if (showPieChart) {
            //  Create pie chart
            PieChartFormatter pcf = new PieChartFormatter(loginBean.getLocale());
            PiePlot plot = new PiePlot(pieDataset);
            plot.setInsets(new Insets(0, 5, 5, 5));
            plot.setLabelGenerator(pcf);
            plot.setToolTipGenerator(pcf);

            // assign colors
            for (int i=0; i<pieDataset.getItemCount(); i++) {
                plot.setSectionPaint(i, pcf.getSectionColor(i));
            }

            font = new Font("Arial", Font.PLAIN, 12);
            JFreeChart chart = new JFreeChart("", font, plot, true);
            chart.setTitle(title);
            chart.setLegend(null);
            chart.setBackgroundPaint(java.awt.Color.white);

            //  Write the chart image to the temporary directory
            ChartRenderingInfo info = new ChartRenderingInfo(new StandardEntityCollection());
            filename = ServletUtilities.saveChartAsPNG(chart, 500, 400, info, session);

            //  Write the image map to the PrintWriter
            PrintWriter pw = new PrintWriter(out);
            ChartUtilities.writeImageMap(pw, filename, info);
            pw.flush();
            graphURL = request.getContextPath() + "/servlet/DisplayChart?filename=" + filename;
            pieChartCmd = "<BR><img src=\"" + graphURL + "\" width=500 height=400 border=0 usemap=\"#" + filename + "\">";
        }

    } catch(DataAccessException dae) {
        Debug.trace("No Data Found for Switch with NodeID = " + nodeID + "  Name = " + durableName);
    } catch(RuntimeException re) {
        Debug.getDebugSubsystem().panic(re);
    } catch(Error e) {
        Debug.getDebugSubsystem().panic(e);
        throw e;
    }  finally {
        out.print(gt.getHTML().toString());
        out.print(pieChartCmd);
    }

%>
</div>
