<%@ page import="com.hp.mx.html.table.GUIDOTable,
                 com.hp.mx.core.nodemanager.MxNode,
                 java.util.*,
                 com.hp.mx.core.persistence.util.storage.Common,
                 com.hp.mx.core.persistence.util.storage.StorageDevice,
                 com.hp.mx.core.persistence.util.storage.StorageVolume,
                 com.hp.mx.core.persistence.databean.CIM_ComputerSystem,
                 com.hp.mx.utilities.ByteFormatter,
                 com.hp.mx.portal.ui.MxBean,
                 com.hp.mx.portal.res.MxResourceBean,
                 com.hp.mx.core.persistence.util.storage.Debug,
                 com.hp.mx.core.controllers.MxNodeController,
                 java.text.NumberFormat,
                 com.hp.mx.core.persistence.dataaccess.DataAccessException"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="deviceUtilBean" class="com.hp.mx.portal.device.MxDeviceUtilBean" scope="session" />
<jsp:useBean id="resource" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="genSystemPage" class="com.hp.mx.portal.device.MxGenSystemPage"  scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<div class="systemPageGroup">
<%
    //out.print("/src/hpwebadmin/webapps/ROOT/mxportal/DevicePage/SDLuns.jsp<BR>");
    //out.print("Type = " + deviceBean.getSystemType() + "<BR>");
    //out.print("Sub-Type = " + deviceBean.getSystemSubtype() + "<BR>");

    /**
     * List of table columns and associated database fields:
     *
     * "LUN Name" (LUN friendly name)
     *      CIM_ComputerSystem (Array) -> CIM_StorageVolume : ElementName
     *
     * "Block Size"
     *      CIM_ComputerSystem (Array) -> CIM_StorageVolume : BlockSize
     *
     * "Number of Blocks"
     *      CIM_ComputerSystem (Array) -> CIM_StorageVolume : NumberOfBlocks
     *
     * "Total Size" (calculated)
     *      CIM_ComputerSystem (Array) -> CIM_StorageVolume : BlockSize *
     *      CIM_ComputerSystem (Array) -> CIM_StorageVolume : NumberOfBlocks
     *
     * "RAID Type" (calculated)
     *      CIM_ComputerSystem (Array) -> CIM_StorageVolume :
     */

    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // setup resources.
    resource.init(loginBean, "StorageRelatedDevicePages");

    genSystemPage.dumpDataCollectionLine(deviceBean, deviceBundle, loginBean, out);

    String durableName = deviceBean.getMxNode().getDurableName();
    int nodeID = deviceBean.getMxNode().getDeviceKey();

    GUIDOTable gt = new GUIDOTable(loginBean.getLocale());
    MxResourceBean res = new MxResourceBean(loginBean.getLocale(), "com.hp.mx.html.table.resource.TableResources");
    gt.setResourceBundle(res.getBundle());

    String headers[] = { resource.getString("columnHeader.volumeName"),  // Volume Name
                         resource.getString("columnHeader.visibleHosts"),// hosts that can see this storage vol
                         resource.getString("columnHeader.blockSize"),   // Block Size
                         resource.getString("columnHeader.numBlocks"),   // Number of Blocks
                         resource.getString("columnHeader.totSize"),     // Total Size
                         resource.getString("columnHeader.RAIDlevel") }; // RAID Level
    gt.setHeaders(headers);
    ByteFormatter bf = new ByteFormatter(loginBean.getLocale());

    try {
        StorageDevice sd = new StorageDevice(nodeID, durableName);
        Map stitchedVolumes = Common.getStitchedVolumesForArray(nodeID);

        ArrayList rows = new ArrayList(sd.getStorageVolumes().size());
        Iterator svs = sd.getStorageVolumes().iterator();
        while (svs.hasNext()) {
            String[] tableRow = new String[headers.length];
            StorageVolume sv = (StorageVolume) svs.next();
            int idx = 0;

            // element name
            tableRow[idx++] = sv.getName();

            // Host(s) that see this LUN
            List remoteNodeIDs = (List) stitchedVolumes.get(sv.getCIMStorageVolume().getName());
            if(remoteNodeIDs != null) {
                String hyperlinks = Common.getDeviceHyperlinks(remoteNodeIDs, deviceUtilBean);
                tableRow[idx++] = hyperlinks;
            } else {
                tableRow[idx++] = resource.getString("unknown");
            }

            // block size
            tableRow[idx++] = bf.format(sv.getBlockSize());

            // number of blocks
            NumberFormat nf = NumberFormat.getInstance(loginBean.getLocale()); // format number with commas
            tableRow[idx++] = nf.format(sv.getNumberOfBlocks());

            // total size
            tableRow[idx++] = bf.format(sv.getSize());

            // RAID level
            tableRow[idx++] = sv.getRAIDLevel();

            rows.add(tableRow);
        }

        gt.setRows(rows);

    } catch(DataAccessException dae) {
        Debug.trace("No Data Found for Storage Device with NodeID = " + nodeID + "  Name = " + durableName);
    } catch(RuntimeException re) {
        Debug.getDebugSubsystem().panic(re);
    } catch(Error e) {
        Debug.getDebugSubsystem().panic(e);
        throw e;
    } finally {
        out.print(gt.getHTML().toString());
    }

%>
</div>
