<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/home/intro.jsp,v $
// $Revision: 1.47 $
// $Date: 2005/05/19 15:07:26 $
//
%>
<%@ page info="Introductory Page"%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="introBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="homePageBean" class="com.hp.mx.portal.settings.HomePageBean" scope="session"/>

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    introBundle.init(loginBean, "HomePage");
    homePageBean.initialize(loginBean);
%>

<html>
<head>
    <title><%= introBundle.getString("homepage.description") %></title>
    <link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script language="JavaScript" type="text/javascript">
        MxPortalWorkspaceSetHelpTopic("start_homePage");

        function submitMe()
        {
            var myForm = document.getElementById("hpoForm");
            myForm.submit();
        }

        function loadSystemList(listName, listTitle)
        {
            var href = "";
            if (listName == "All Systems")
            {
                href = "<%= homePageBean.getListUrl("All Systems") %>";
            }
            else if (listName == "All Events")
            {
                href = "<%= homePageBean.getListUrl("All Events") %>";
            }

            MxPortalWorkspaceCreateUrl(listTitle, href)
        }

        var billboardWindow = null;

        function openBillboardWindow(url, w, h)
        {
            billboardWindow = window.open(url, "billboard", "scrollbars=no,resizable=yes,width=" + w + ",height=" + h);
            billboardWindow.focus();
            return false;
        }
    </script>

    <% MxHtmlUtil.dumpHeadBegin(out); %>
    <% MxHtmlUtil.dumpHeadEnd(out); %>
</head>

<body class="body-flush-fit-scrolling">
<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        // Set the user's choices (for this page, if we're POSTing, it can only
        // mean that the user wants to DISABLE the First Time Admin section)
        homePageBean.setShowFta("");
        %>
        <script>
            MxPortalActionStart('STARTUP_PAGE', '')
        </script>
        <%
    }
    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////
    else
    {
%>
    <!--  Display the customize link -->
    <div class="home-customize">
        <a href="javascript:MxPortalActionStart('HOME_PAGE_SETTINGS', '')" title="<%= introBundle.getString("homepage.customize.tooltip") %>">
            <%= introBundle.getString("homepage.customize") %>
        </a>
    </div>

    <!-- BILLBOARD ROW #1 (FIRST TIME ADMIN CONTENT) -->
    <%
        if ((loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.FULL_RIGHTS)) && homePageBean.showFta())
        {
    %>

    <div class="home-heading"><%= introBundle.getString("homepage.finish") %></div>
    <table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr valign="top">
        <td class="home-fta">
            <h4><%= introBundle.getString("billboard.fta.prompt") %></h4>
        </td>
        <td class="home-dns">
        <form action="intro.jsp" method="post" id="hpoForm" name="hpoForm">
        <input type="checkbox" id="cbFta" value="" onclick="submitMe()"> <label for="cbFta"><%= introBundle.getString("billboard.fta.checkbox.label") %></label>
        </form>
        </td>
    </tr>
    </table>
    <table border="0" cellspacing="0" cellpadding="0">
    <tr valign="top">
        <td class="home-fta-1">
            <ul>
                <li><%= introBundle.getString("billboard.fta.bullet.nodeSetup") %>
                <li><%= introBundle.getString("billboard.fta.bullet.protocols") %>
                <li><%= introBundle.getString("billboard.fta.bullet.discovery") %>
            </ul>
        </td>
        <td>
            <ul>
                <LI><%= introBundle.getString("billboard.fta.bullet.auth") %>
                <LI><%= introBundle.getString("billboard.fta.bullet.email") %>
                <LI><%= introBundle.getString("billboard.fta.bullet.actionsOnEvents") %>
            </ul>
        </td>
    </tr>
    </table>
    <%
        }
    %>

    <!-- BILLBOARD ROW #2 -->
    <div class="home-heading"><%= introBundle.getString("homepage.learn") %></div>
    <table border="0" cellspacing="0" cellpadding="0">
    <tr valign="top">
        <td class="home-monitor">
            <!-- MONITOR BILLBOARD -->
            <h4 class="home-monitor-1"><%= introBundle.getString("billboard.monitor.title") %></h4>
            <ul>
                <li><%= introBundle.getString("billboard.monitor.bullet.allSystems") %>
                <li><%= introBundle.getString("billboard.monitor.bullet.allEvents") %>
                <li><%= introBundle.getString("billboard.monitor.bullet.overview") %>
                <li><%= introBundle.getString("billboard.monitor.bullet.faves") %>
                <li><%= introBundle.getString("billboard.monitor.bullet.iconView") %>
                <li><%= introBundle.getString("billboard.monitor.bullet.listView") %>
                <li><%= introBundle.getString("billboard.monitor.bullet.statusIcons") %>
            </ul>
        </td>
        <td>
            <!-- MANAGE BILLBOARD -->
            <h4><%= introBundle.getString("billboard.manage.title") %></h4>
            <ul>
                <li><%= introBundle.getString("billboard.manage.bullet.reports") %>
        <%
        if (homePageBean.isUserAuthorizedForTool("Install Software and Firmware"))
        {
        %>
                <li><%= introBundle.getString("billboard.manage.bullet.updateSw") %>
        <%
        }
        if (loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        {
        %>
                <li><%= introBundle.getString("billboard.manage.bullet.myTools") %>
        <%
        }
        if (loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
        {
        %>
                <li><%= introBundle.getString("billboard.manage.bullet.autoDiscovery") %>
        <%
        }
        if ((loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
            && (loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
            && (loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
            && (loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE)))
        {
        %>
                <li><%= introBundle.getString("billboard.manage.bullet.eventHandling") %>
        <%
        }
        if (loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_AUTHORIZATION_PRIVILEGE) &&
            loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE) &&
            loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOLBOX_MODIFICATION_PRIVILEGE)&&
            loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_GROUP_MODIFICATION_PRIVILEGE))
        {
        %>
                <li><%= introBundle.getString("billboard.manage.bullet.auth") %>
        <%
        }
        %>
            </ul>
        </td>
    </tr>
    </table>

    <!-- BILLBOARD ROW #3 -->
    <hr>
    <table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr valign="top">
        <td class="home-dyk">
            <!-- DID YOU KNOW BILLBOARD -->
            <h4 class="home-dky-1"><%= introBundle.getString("billboard.dyk.title") %></h4>
            <ul>
                <li><%= introBundle.getString("billboard.dyk.bullet.partners") %>
                <li><%= introBundle.getString("billboard.dyk.bullet.openView") %>
                <li><%= introBundle.getString("billboard.dyk.bullet.proliant") %>
                <li><%= introBundle.getString("billboard.dyk.bullet.wlm") %>
                <li><%= introBundle.getString("billboard.dyk.bullet.vpm") %>
                <li><%= introBundle.getString("billboard.dyk.bullet.survey") %>
                <li><%= introBundle.getString("billboard.dyk.bullet.services") %>
            </ul>
        </td>
    <%
        if (homePageBean.showDyk())
        {
    %>
        <td class="home-dyk-img">
            <BR>
            <%= homePageBean.displayRandomDykImage() %>
        </td>
    <%
        }
    %>
    </tr>
    </table>
<%
    }
%>
    <% MxHtmlUtil.dumpBodyEnd(out); %>
</body>
</html>
