<%@ page import="com.hp.mx.core.controllers.MxQueryController" %>
<%@ page import="com.hp.mx.core.objectmodel.MxGUID" %>
<%@ page import="com.hp.mx.core.nodemanager.DeviceStatusType" %>
<%@ page import="com.hp.mx.core.querymanager.Query" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.tree.MxCollectionTreeInstance" %>
<%@ page import="com.hp.mx.portal.tree.MxCollectionTreeModel" %>
<%@ page import="com.hp.mx.portal.tree.MxTreeInstance" %>
<%@ page import="com.hp.mx.portal.tree.MxTreeDataModel" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="drillDown" class="com.hp.mx.portal.core.MxDrillDown" scope="session" />
<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="collectionTreeInstanceManager" class="com.hp.mx.portal.tree.MxCollectionTreeInstanceManager" scope="session" />
<jsp:useBean id="treeInstanceManager" class="com.hp.mx.portal.tree.MxTreeInstanceManager" scope="session" />
<jsp:useBean id="rbTreeView" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }
    MxBean.jspInit(request, response);

    // Set the resource bundle
    rbTreeView.init(loginBean, "MxTreeView");

    String listId = "";
    String listName = "";
    String collectionId = "";
    String collectionName = "";
    String nodeId = "";
    String deviceId = "";
    String deviceName = "";
    String defaultView = "";
    String szDrillDownUrl = "";
    String szTitle = "";
    String szSubTitle = "";
    String severity = "";
    String szSeverityLabel = "";
    int iSeverity = 0;

    // Get the tree instance by timestamp
    String timeStamp = request.getParameter("timeStamp");
    if (timeStamp != null)
    {
        // Find out which tree model the drilldown is being called from
        MxCollectionTreeModel collectionTreeModel = null;
        MxTreeDataModel treeModel = null;
        if (request.getParameter("isCollectionView") != null)
        {
            MxCollectionTreeInstance collectionTreeInstance = collectionTreeInstanceManager.getTreeInstance(timeStamp);
            collectionTreeModel = collectionTreeInstance.getTreeDataModel();
        }
        else
        {
            MxTreeInstance treeInstance = (MxTreeInstance) treeInstanceManager.getInstance(timeStamp);
            treeModel = treeInstance.getTreeDataModel();
        }

        // Get the URL parameters
        listId = request.getParameter("listId" );
        listName = request.getParameter("listName");
        collectionId = request.getParameter("collectionId");
        collectionName = request.getParameter("collectionName");
        nodeId = request.getParameter("nodeId");
        deviceId = request.getParameter("deviceId");
        deviceName = request.getParameter("deviceName");
        defaultView = request.getParameter("defaultView");
        severity = request.getParameter("severity");

        // If the severity parameter is present, this is a container status drilldown
        if (severity != null)
        {
            iSeverity = Integer.parseInt(severity);
            DeviceStatusType statusType = DeviceStatusType.getStatusTypeByNumVal(iSeverity);
            szSeverityLabel = statusType.getLabel(loginBean.getLocale());
            String szContainerLabel = "";
            if (listName != null)
            {
                szContainerLabel = listName;
            }
            else if (collectionName != null)
            {
                szContainerLabel = collectionName;
            }
            else if (deviceName != null)
            {
                szContainerLabel = deviceName;
            }
            szTitle = szContainerLabel + ": " + szSeverityLabel + " " + rbTreeView.get("healthStatus");
            Query filteredQuery = null;
            if (collectionTreeModel != null)
            {
                filteredQuery = collectionTreeModel.buildQueryForContainerByStatus(nodeId, severity);
            }
            else
            {
                filteredQuery = treeModel.buildQueryForContainerByStatus(nodeId, severity);
            }

            String queryLUID = String.valueOf(filteredQuery.getLUID());
            szDrillDownUrl = "MxBannerLinks.jsp?severity=" + severity + "&listType=" + MxQueryController.BANNER_HARDWARE_STATUS_RESULTS + "&query=" + queryLUID;
        }

        // See if this is a list or collection drilldown
        else if (listId != null)
        {
            MxGUID oQueryGUID = new MxGUID(listId);
            szTitle = listName;
            String queryId = String.valueOf(oQueryGUID.getKey());
            szDrillDownUrl = "../../ui/jsp/XeHdr.jsp?PageName=viewContentsDevices&ViewType=DeviceViews&viewid=" + queryId + "&defaultView=" + defaultView;
        }
        else if (collectionId != null)
        {
            MxGUID oCollGUID = new MxGUID(collectionId);
            szTitle = collectionName;
            String collectionLUID = String.valueOf(oCollGUID.getLUID());
            szDrillDownUrl = "../../ui/jsp/XeHdr.jsp?PageName=viewContentsCollectionTree&ViewType=CollectionTree&collectionLUID=" + collectionLUID + "&defaultView=" + defaultView;
        }
    }
%>
<html>

<head>

<title></title>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

<script language="JAVASCRIPT">
<%
if (szDrillDownUrl != null)
{
%>
    MxPortalWorkspaceCreateUrlEx("<%=szTitle%>", "<%=szSubTitle%>", "<%=szDrillDownUrl%>");
<%
}
%>

</script>
</head>

<body>

</body>

</html>
