var MSGBOX_NONE =       0;
var MSGBOX_CRITICAL =   1;
var MSGBOX_WARNING =    2;
var MSGBOX_INFO =       3;
var MSGBOX_HELP =       4;

var gmb_anchorX, gmb_anchorY;
var gmb_rootX, gmb_rootY;
var gmb_bDragging = false;

////////////////////////////////////////////////
// drag drop functions

function mboxHandleMouseMove(e)
{
    var oMsgBox = document.getElementById("ID_MSGBOX");
    var myEvent = document.all ? event : e;

    if (gmb_bDragging)
    {
        oMsgBox.style.left = gmb_rootX + myEvent.clientX - gmb_anchorX;
        oMsgBox.style.top = gmb_rootY + myEvent.clientY - gmb_anchorY;
    }
}

function mboxHandleMouseDown(e)
{
    var oMsgBox = document.getElementById("ID_MSGBOX");

    gmb_anchorX = e.clientX;
    gmb_anchorY = e.clientY;

    gmb_rootX = parseInt(oMsgBox.style.left);
    gmb_rootY = parseInt(oMsgBox.style.top);

    gmb_bDragging = true;
    document.onmousemove = mboxHandleMouseMove;
}

function mboxHandleMouseUp()
{
    gmb_bDragging = false;
    document.onmousemove = null;
}

function hidebox()
{
    document.getElementById("ID_MSGBOX").style.display = "none";
}

function setBoxImage(nStatus)
{
    var szImage = null;
    switch (nStatus)
    {
        case MSGBOX_CRITICAL:
            szImage = "../images/msg_crit.jpg";
            break;

        case MSGBOX_WARNING:
            szImage = "../images/msg_warn.jpg";
            break;

        case MSGBOX_INFO:
            szImage = "../images/msg_info.jpg";
            break;

        case MSGBOX_HELP:
            szImage = "../images/msg_help.jpg";
            break;
    }

    var oCell = document.getElementById("ID_BOX_IMAGE");
    if (szImage != null)
        oCell.innerHTML = "&nbsp;&nbsp;&nbsp;<img src='" + szImage + "'>";
}

function ShowMsgBox(x, y, w, nStatus, szTitle, szHtml, aButtons)
{
    document.getElementById("ID_BOX_TITLE").innerHTML = szTitle;
    document.getElementById("ID_BOX_CONTENT").innerHTML = "<br>" + szHtml + "<br><br>";

    setBoxImage(nStatus);

    var szButtons = "";
    for (var i = 0; i < aButtons.length; i++)
    {
        var szOnClick = "hidebox();";
        if (aButtons[i][1] != null)
            szOnClick += aButtons[i][1];

        szButtons += '<input class="msgbox-button" type="button" value="' + aButtons[i][0] + '" onclick="' + szOnClick + '">\n'
    }

    document.getElementById("ID_BOX_BUTTONS").innerHTML = szButtons;

    var oMsgBox = document.getElementById("ID_MSGBOX");
    oMsgBox.style.left = "" + x;
    oMsgBox.style.top = "" + y;
    oMsgBox.style.width = w + "px";
    oMsgBox.style.zIndex = 1000;
    oMsgBox.style.display = "block";
}

function testHandler()
{
    alert("handler");
}

function testMsgBox()
{
    var b1 = new Array("Yes", "testHandler()");
    var b2 = new Array("No", "testHandler()");
    var b3 = new Array("Cancel", null);

    ShowMsgBox(200, 200,
        250,
        MSGBOX_CRITICAL,
        "Critical Emergency!",
        "Hello, <b>world</b>!<BR>Prepare for the worst!",
        new Array(b1, b2, b3))
}
