<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.custom.*" %>

<%
    MxHtmlUtil.jspInit(request, response);
    MxHtmlUtil.dumpLinkToScript(MxHtmlUtil.JS_MxIframes, !MxHtmlUtil.INCLUDE_TAGS, out);
    MxHtmlUtil.dumpLinkToScript(MxHtmlUtil.JS_MxBrowser, !MxHtmlUtil.INCLUDE_TAGS, out);
%>

/**
 * The MxPortal API for web pages.
 */

/**
 * Returns whether "this" browser frame is running inside the portal.
 */
function MxPortalIsPresent()
{
    return (p_MxPortalGetWindow() != null);
}

/**
 * Close the workspace window (same effect as user doing it).
 */
function MxPortalWorkspaceClose()
{
    var w = p_MxPortalGetWindow();
    if (w != null)
        w.p_MxPortalWorkspaceClose();
    else
        MxBrowserGetTopmost(null).close();
}

function MxPortalGetWorkspaceFrame()
{
    var w = p_MxPortalGetWindow();
    if (w != null)
    {
        var oFrame = MxPortalGetRightSideFrame();
        if (oFrame != null && oFrame.contentWindow != null)
            return oFrame.contentWindow.document.getElementById("FRAME_" + w.szWorkspaceId);
    }

    w = MxBrowserGetTopmost("MxSnapOff.jsp");
    if (w != null)
    {
        if (typeof w.MxSnapOffGetWorkspaceFrame == "function")
        {
            return w.MxSnapOffGetWorkspaceFrame();
        }
    }

    return null;
}

function MxPortalRefreshStatusOverview()
{
    var oLeft = MxPortalGetLeftSideFrame();
    if (oLeft != null)
    {
        var oFrame = oLeft.contentWindow.document.getElementById("<%=MxBannerSettings.ID_BANNER_DATA%>");
        MxBrowserRefreshFrame(oFrame);
    }
}

/**
 * @deprecated Use MxPortalRefreshStatusOverview
 */
function MxPortalRefreshBanner()
{
    MxPortalRefreshStatusOverview();
}

function MxPortalSetTopLocation(szUrl)
{
    var w = p_MxPortalGetWindow();
    if (w != null)
        w.p_MxPortalSetTopLocation(szUrl);
    else
        MxBrowserGetTopmost(null).document.location.replace(szUrl);
}

function MxPortalLogout()
{
    var w = p_MxPortalGetWindow();
    if (w != null)
        w.p_MxPortalLogout();
}

////////////////////////////////////////////////////////////
// these operate on the main portal window,
// even if called from a snap off

/**
 * Get the topmost hidden frame.
 */
function MxPortalGetHiddenFrame()
{
    var w = p_MxPortalGetWindowEx();
    if (w == null)
        return null;

    var wHidden = w.p_MxPortalGetHiddenFrame();
    if (wHidden != null)
        wHidden.contentWindow.portalWindow = w;

    return wHidden;
}

/**
 * Get the banner DIV.
 */
function MxPortalGetBannerDiv()
{
    var w = p_MxPortalGetWindowEx();
    if (w != null)
        w = w.document.getElementById("ID_BANNER");

    return w;
}

/**
 * Get the left-side frame that holds the navigation area.
 */
function MxPortalGetNavigationFrame()
{
    var w = p_MxPortalGetWindowEx();
    if (w != null)
        w = w.p_MxPortalGetNavigationFrame();

    return w;
}

function MxPortalGetLeftSideFrame()
{
    var w = p_MxPortalGetWindowEx();
    if (w != null)
        w = w.p_MxPortalGetLeftSideFrame()

    return w;
}

function MxPortalGetRightSideFrame()
{
    var w = p_MxPortalGetWindowEx();
    if (w != null)
        w = w.p_MxPortalGetRightSideFrame()

    return w;
}

function MxPortalRefreshNavigationArea()
{
    var w = p_MxPortalGetWindowEx();
    if (w != null)
        w.p_MxPortalRefreshNavigationArea();
}

function MxPortalRefreshLeftSide()
{
    var w = p_MxPortalGetWindowEx();
    if (w != null)
        w.p_MxPortalRefreshLeftSide()
}

function MxPortalRefreshRightSide()
{
    var w = p_MxPortalGetWindowEx();
    if (w != null)
        w.p_MxPortalRefreshRightSide()
}

/**
 * Refreshes the Manage menu from the server, rereading MxTool objects
 * from the database. It may be called very quickly without penalty;
 * multiple calls are throttled.
 */
function MxPortalManageMenuRefresh()
{
    var w = MxPortalGetHiddenFrame();
    if (w != null)
        w.contentWindow.handleManageMenuRefresh();
}

/**
 * This does nothing at the moment. It's here because of future
 * plans to resurrect "doing something" whenever selections change.
 */
function MxPortalManageMenuRefreshSelections()
{
}

////////////////////////////////////////////////////////////
// MxPortalBean commands

/**
 * Initiates the launching of a tool with the given ID.
 * For tools, this means launching the Task Wizard. For actions
 * this means loading a URL.
 *
 * The second parameter is URL parameters, and is optional.
 * If provided, the URL parameters are appended to the
 * Task Wizard URL used to launch to the tool.
 */
function MxPortalWorkspaceCreate(szActionId, szParams)
{
    if (arguments.length == 1)
        szParams = "";

    var parms = new Array();
    parms[parms.length] = new Array("cmd", "start");
    parms[parms.length] = new Array("actionId", szActionId);
    parms[parms.length] = new Array("winAction", "reset");
    parms[parms.length] = new Array("params", szParams);
    parms[parms.length] = new Array("insidePortal", MxPortalIsPresent());
    MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, false);
}

function MxPortalSnapOffCreate(szActionId, szTargetFrame)
{
    if (arguments.length == 1)
        szTargetFrame = "_blank";

    var parms = new Array();
    parms[parms.length] = new Array("cmd", "start");
    parms[parms.length] = new Array("actionId", szActionId);
    parms[parms.length] = new Array("winAction", "reset");
    parms[parms.length] = new Array("insidePortal", false);
    parms[parms.length] = new Array("targetFrame", szTargetFrame);
    MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, true);
}

/**
 * Completes the launching of a tool with the given ID.
 * Only the Task Wizard should call this, when performing a
 * web launch.
 */
function MxPortalWorkspaceTransfer(szActionId)
{
    var parms = new Array();
    parms[parms.length] = new Array("cmd", "start");
    parms[parms.length] = new Array("actionId", szActionId);
    parms[parms.length] = new Array("winAction", "transfer");
    parms[parms.length] = new Array("insidePortal", MxPortalIsPresent());
    MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, false);
}

/**
 * Loads the given URL into the portal workspace and makes
 * it part of the portal state. The URL cannot be set aside.
 */
function MxPortalWorkspaceCreateUrl(szTitle, szUrl)
{
    var parms = new Array();
    parms[parms.length] = new Array("cmd", "startUrl");
    parms[parms.length] = new Array("title", szTitle);
    parms[parms.length] = new Array("actionId", szUrl);
    parms[parms.length] = new Array("insidePortal", MxPortalIsPresent());
    MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, false);
}

/**
 * Loads the given URL into the portal workspace and makes
 * it part of the portal state. The URL cannot be set aside.
 */
function MxPortalWorkspaceCreateUrlEx(szTitle, szSubTitle, szUrl)
{
    var parms = new Array();
    parms[parms.length] = new Array("cmd", "startUrlEx");
    parms[parms.length] = new Array("title", szTitle);
    parms[parms.length] = new Array("subTitle", szSubTitle);
    parms[parms.length] = new Array("actionId", szUrl);
    parms[parms.length] = new Array("insidePortal", MxPortalIsPresent());
    MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, false);
}

/**
 * Start the given action, appending any supplied parameters onto
 * the action's URL. The paramaters are optional and can be left off.
 */
function MxPortalActionStart(szId, szParams)
{
    if (arguments.length == 1)
        szParams = "";

    var parms = new Array();
    parms[parms.length] = new Array("cmd", "startAction");
    parms[parms.length] = new Array("actionId", szId);
    parms[parms.length] = new Array("params", szParams);
    parms[parms.length] = new Array("insidePortal", MxPortalIsPresent());
    MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, false);
}

function MxPortalWindowAction(szWinId, szWinAction)
{
    if (szWinAction == "<%=MxXmlWindow.WIN_HELP%>")
    {
        var wNew = window.open(szWorkspaceHelpUrl, "<%=MxOptions.FRAME_HELP%>");
        MxPortalTrackPopup(wNew);
    }
    else
    {
        var parms = new Array();
        parms[parms.length] = new Array("cmd", "click");
        parms[parms.length] = new Array("winId", szWinId);
        parms[parms.length] = new Array("winAction", szWinAction);
        MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, true);
    }
}

function MxPortalWindowSized(szWinId, h)
{
    var parms = new Array();
    parms[parms.length] = new Array("cmd", "resize");
    parms[parms.length] = new Array("winId", szWinId);
    parms[parms.length] = new Array("size", h);
    MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, true);
}

function MxPortalSplitterMoved(width)
{
    var parms = new Array();
    parms[parms.length] = new Array("cmd", "splitterMoved");
    parms[parms.length] = new Array("size", width);
    MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, true);
}

function MxPortalSendTimeZone()
{
    var zone = MxBrowserGetCookie("<%=MxLoginPage.COOKIE_ZONE%>");
    if (zone == null)
        return;

    var parms = new Array();
    parms[parms.length] = new Array("cmd", "setTimeZone");
    parms[parms.length] = new Array("actionId", zone);
    MxIframeSubmit("<%=MxOptions.URL_BASE%>/home/MxPortalCmd.jsp", parms, true);
}

////////////////////////////////////////////////////////////
// title/subtitle APIs

function MxPortalWorkspaceGetTitleHtml()
{
    var szHtml = "";

    var win = parent;
    if (MxPortalIsPresent())
    {
        var oFrame = MxPortalGetRightSideFrame();
        if (oFrame != null)
            win = oFrame.contentWindow;
    }

    var oDiv = win.document.getElementById("<%=MxPortalRender.ID_PORTAL_TITLE%>");
    if (oDiv != null)
    {
        szHtml = oDiv.innerHTML;
    }

    return szHtml;
}

function MxPortalWorkspaceSetTitleHtml(szHtml)
{
    var win = parent;
    if (MxPortalIsPresent())
    {
        var oFrame = MxPortalGetRightSideFrame();
        if (oFrame != null)
            win = oFrame.contentWindow;
    }

    var oDiv = win.document.getElementById("<%=MxPortalRender.ID_PORTAL_TITLE%>");
    if (oDiv != null)
    {
        oDiv.innerHTML = szHtml;
        if (typeof(win.myOnResize) == "function")
            win.myOnResize();
    }
}

function MxPortalWorkspaceSetSubtitleHtml(szHtml)
{
    var win = parent;
    if (MxPortalIsPresent())
    {
        var oFrame = MxPortalGetRightSideFrame();
        if (oFrame != null)
            win = oFrame.contentWindow;
    }

    var oDiv = win.document.getElementById("<%=MxPortalRender.ID_PORTAL_SUBTITLE%>");
    if (oDiv != null)
    {
        oDiv.innerHTML = szHtml;
        if (typeof(win.myOnResize) == "function")
            win.myOnResize();
    }
}

////////////////////////////////////////////////////////////
//  help APIs

/**
 * For context-sensitive help: get the URL associated with the
 * workspace help URL in the banner.
 */
function MxPortalWorkspaceGetHelpUrl()
{
    var w = p_MxPortalGetWindow();
    if (w != null)
    {
        return w.p_MxPortalWorkspaceGetHelpUrl();
    }

    w = MxBrowserGetTopmost("MxSnapOff.jsp");
    if (w != null)
    {
        if (typeof w.MxSnapOffGetHelpUrl == "function")
        {
            return w.MxSnapOffGetHelpUrl();
        }
    }

    return null;
}

/**
 * For context-sensitive help: set the URL associated with the
 * workspace help URL in the banner.
 */
function MxPortalWorkspaceSetHelpUrl(szUrl)
{
    var w = p_MxPortalGetWindow();
    if (w != null)
    {
        w.p_MxPortalWorkspaceSetHelpUrl(szUrl);
        return;
    }

    w = MxBrowserGetTopmost("MxSnapOff.jsp");
    if (w != null)
    {
        if (typeof w.MxSnapOffSetHelpUrl == "function")
        {
            w.MxSnapOffSetHelpUrl(szUrl);
            return;
        }
    }
}

/**
 * For context-sensitive help: set the current mxportal help topic for the workspace.
 */
function MxPortalWorkspaceSetHelpTopic(szTopic)
{
    MxPortalWorkspaceSetHelpUrl("<%=MxActionMgr.getStaticHelpMapperUrl()%>?topic="
        + szTopic);
}

/**
 * For context-sensitive help: set the current help topic for the workspace,
 * for the given webapp.
 */
function MxPortalWorkspaceSetHelpTopicEx(szWebapp, szTopic)
{
    MxPortalWorkspaceSetHelpUrl("<%=MxActionMgr.getStaticHelpMapperUrl()%>?appid="
        + szWebapp + "&topic=" + szTopic);
}

/**
 * Loads the given URL into the help window.
 * Returns the window object.
 */
function MxPortalOpenHelpUrl(szUrl)
{
    var oWin = window.open(szUrl,
        "<%=MxOptions.FRAME_HELP%>",
        "<%=MxOptions.HELP_DECORATIONS%>");

    if (oWin != null)
    {
        oWin.focus();
        MxPortalTrackPopup(oWin);
    }

    return oWin;
}

/**
 * Loads the given help topic into the help window.
 */
function MxPortalOpenHelpTopic(szTopic)
{
    var szUrl = "<%=MxActionMgr.getStaticHelpMapperUrl()%>?topic=" + szTopic;
    MxPortalOpenHelpUrl(szUrl);
}

/**
 * Loads the given help topic into the help window,
 * for the given webapp.
 */
function MxPortalOpenHelpTopicEx(szWebapp, szTopic)
{
    var szUrl = "<%=MxActionMgr.getStaticHelpMapperUrl()%>?appid="
        + szWebapp + "&topic=" + szTopic;
    MxPortalOpenHelpUrl(szUrl);
}

/**
 * Opens the help window and displays help for the current page.
 * If the parameter is true, this returns the window object.
 */
function MxPortalOpenPageHelp(bReturnWindow)
{
    var result = null;

    var w = p_MxPortalGetWindow();
    if (w != null)
        result = w.p_MxPortalOpenPageHelp();

    if (bReturnWindow)
        return result;
}

function MxPortalOpenAboutWindow(szUrl, w, h)
{
    var helpWindow = window.open(szUrl, "MX_HELP_ABOUT_<%=request.getRequestedSessionId()%>",
        "menubar=0, titlebar=0, toolbar=0, scrollbars=1, resizable=1, width=" + w + ", height=" + h);

    if (helpWindow != null)
    {
        helpWindow.focus();
        MxPortalTrackPopup(helpWindow);
    }
}

function MxPortalOpenPopupWindow(szUrl, szTargetFrame, w, h)
{
    var newWindow = window.open(szUrl, szTargetFrame,
        "menubar=0, titlebar=0, toolbar=0, scrollbars=1, resizable=1, width=" + w + ", height=" + h);

    if (newWindow != null)
    {
        newWindow.focus();
        MxPortalTrackPopup(newWindow);
    }
}

////////////////////////////////////////////////////////////
// node selection APIs

function p_MxPortalNodesApi(szParams)
{
    var szUrl = "<%=MxOptions.URL_BASE%>/home/MxObjSelectionsApi.jsp?" + szParams;
    MxIframeLoad(szUrl);
}

/**
 * Clears the node selections on the server,
 * and updates the Manage menu.
 */
function MxPortalNodesClear()
{
    p_MxPortalNodesApi("clear=true");
}

/**
 * Adds the given node to the selections maintained on the server,
 * and updates the Manage menu.
 */
function MxPortalNodesAddNode(szGuid)
{
    p_MxPortalNodesApi("add=" + szGuid);
}

/**
 * Removes the given node from the selections maintained on the server,
 * and updates the Manage menu.
 */
function MxPortalNodesRemoveNode(szGuid)
{
    p_MxPortalNodesApi("remove=" + szGuid);
}

/**
 * Clears the node selections, adds the specified node,
 * and updates the Manage menu.
 */
function MxPortalNodesSetNode(szGuid)
{
    p_MxPortalNodesApi("set=" + szGuid);
}

////////////////////////////////////////////////////////////
// debug APIs

function p_MxPortalGetDebug()
{
    var w = p_MxPortalGetWindowEx();
    if (w == null)
        w = MxBrowserGetTopmost(null);

    if (typeof(w.MxDebugWin) == "undefined")
       w.MxDebugWin = null;

    if (w.MxDebugWin != null && w.MxDebugWin.closed)
        w.MxDebugWin = null;

    if (w.MxDebugWin == null)
    {
        w.MxDebugWin = window.open("about:blank", "_blank",
            "menubar=0, titlebar=0, toolbar=0, scrollbars=0, resizable=1, width=640, height=480");

        var doc = w.MxDebugWin.document;
        doc.writeln("<" + "title>HP SIM Debug Window<" + "/title>");
        doc.writeln("<" + "body style='margin:0;border:0;padding:0;overflow:hidden'>");
        doc.writeln("<" + "textarea id='ID_DEBUG_TEXT' style='margin:0; border:0; padding:0; width:100%; height:100%' wrap=off><" + "/textarea>");
        doc.writeln("<" + "/body>");
    }

    return w.MxDebugWin.document.getElementById("ID_DEBUG_TEXT");
}

function MxPortalDebug(s)
{
    if (typeof(s) == "object")
    {
        MxPortalDebugObject(s);
        return;
    }

    var oEdit = p_MxPortalGetDebug();
    oEdit.value = s + "\n" + oEdit.value;
}

function MxPortalDebugObject(o)
{
    var s = 'begin {\n';
    for (var i in o)
    {
        try {
            var v = eval('o.' + i);
            if (v != null)
                s += '  ' + i + ' = ' + v + '\n';
        } catch (e) { }
    }

    s += '} end';

    MxPortalDebug(s);
}

////////////////////////////////////////////////////////////
//  misc APIs

/**
 * Provides a level of indirection required by IE6 SP1b (or later)
 * in order to support writing OBJECT tags.
 */
function MxPortalWriteLine(sz)
{
    document.writeln(sz);
}

function MxPortalMessageBox(x, y, width, nStatus, szTitle, szHtml, aButtons)
{
    var w = p_MxPortalGetWindow();
    if (w != null)
        w.p_MxPortalMessageBox(x, y, width, nStatus, szTitle, szHtml, aButtons);
}

////////////////////////////////////////////////////////////
// window management

/**
 * Any window passed in to this function will be kept track of and
 * closed when the portal is closed.
 */
function MxPortalTrackPopup(wNew)
{
    var w = p_MxPortalGetWindowEx();
    if (w != null)
        w.p_MxPortalTrackPopup(wNew);

}

function MxPortalClosePopups()
{
    var w = p_MxPortalGetWindowEx();
    if (w != null)
        w.p_MxPortalClosePopups();
}

/**
 * Returns whether the given region is collapsed. The ID is defined in
 * Portal.xml. For example, the status panel is ID_STATUS.
 */
function MxPortalIsPanelCollapsed(szId)
{
    var oFrame = MxPortalGetLeftSideFrame();
    if (oFrame != null)
    {
        var div = oFrame.contentWindow.document.getElementById("<%=MxPortalRender.ID_COLLAPSED%>_" + szId);
        return (div != null);
    }

    return false;
}

function MxPortalKickGlobalTimer()
{
    var w = MxPortalGetHiddenFrame();
    if (w != null)
        w.contentWindow.doGlobalTick();
}

////////////////////////////////////////////////////////////
// private APIs

function p_MxPortalGetWindow()
{
    var w = window;
    while (true)
    {
        if (typeof w.MX_PORTAL_MAIN_DOCUMENT == "string")
            return w;

        if (w == w.top) break;
        w = w.parent;
    }

    return null;
}

function p_MxPortalGetOpener()
{
    var w = top.opener;
    if (w == null || typeof(w) == "undefined")
        return null;

    while (true)
    {
        if (typeof w.MX_PORTAL_MAIN_DOCUMENT == "string")
            return w;

        if (w == w.top) break;
        w = w.parent;
    }

    return null;
}

function p_MxPortalGetWindowEx()
{
    var w = p_MxPortalGetWindow();
    if (w == null)
        w = p_MxPortalGetOpener();

    return w;
}
