//======================================================================
//
// Common Java Functions used by the Monitor tab
//
//======================================================================

//======================================================================
// Generic function to get the source element from an event
//======================================================================
function getEventSrc(e)
{
    if (document.all)
        return e.srcElement;

    var src = e.target;
    while (src.nodeType != src.ELEMENT_NODE)
        src = src.parentNode;
    return src;
}

//======================================================================
// Get the parent for the current element
//======================================================================
function checkParent(src, dest)
{
    // Search for a specific parent of the current element
    while (src != null)
    {
        if (src.tagName == dest)
            return src;

        src = src.parentNode;
    }

    return null;
}

//======================================================================
// Trim the input text string
//======================================================================
function trim(strText)
{
    while (strText.substring(0,1) == ' ')
        strText = strText.substring(1, strText.length);

    while (strText.substring(strText.length-1,strText.length) == ' ')
        strText = strText.substring(0, strText.length-1);

   return strText;
}

//======================================================================
// Function to reset the parent help topic, size, and replace the sub-window
// to the blank html.  This function is called after the successful database
// operation.
//======================================================================
function closeSave(sBlankHtml)
{
    window.parent.scrollTo(0,0);
    document.location.replace(sBlankHtml);
    parent.setHelpTopics();
    parent.hideOperationSpaceIF();
}

//======================================================================
// OnReSize handler for te IFRAME child object
//======================================================================
function resizeFrame(offset, sBodyId)
{
    var oSelf = parent.document.getElementById("operationSpace");
    var h;

    // It is possible that this function is called from New List and Edit List jsps.
    // And it calls the function like: resizeFrame(offset);
    if (sBodyId != null)
    {
        h = document.getElementById(sBodyId).offsetHeight;
        oSelf.style.height = h + offset;
    }
}

//======================================================================
// Get first child object for the given tag.
// This function is added to solve Mozilla1.5 problem; indexing the
// option radio button doesn't work in Mozilla1.5.
//======================================================================
function getFirstChildOfType(obj, szTag)
{
    if (obj == null)
        return null;

    var childrenByTags = obj.getElementsByTagName(szTag);
    if (childrenByTags != null && childrenByTags.length > 0)
        return childrenByTags.item(0);

    return null;
}
