<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="clusterSearchUI" class="com.hp.mx.portal.search.MxClusterSearchUI" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsearch" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
    rbsearch.init(loginBean, "MxSearch");
    clusterSearchUI.init(loginBean, rbsearch.getBundle(), 1);

    String edit = request.getParameter("edit");
    String inframe = request.getParameter("inframe");
    boolean bIsPreInstalledQuery = false;

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    if (edit != null && edit.equals("customize"))
    {
        bIsPreInstalledQuery = clusterSearchUI.isPreInstalledList(request.getParameter("queryName"));
        buttons.addMxTag(new MxDefaultTag("go_button", rbsearch.getString("button.searchNow"), "loadResults('Cluster')"));
        buttons.addMxTag(new MxDefaultTag("ok_button", rbsearch.getString("button.save"), "checkAndSubmit('Cluster'," + bIsPreInstalledQuery + ")"));
        buttons.addMxTag(new MxDefaultTag("cancel_button", rbsearch.getString("button.cancel"), "closeSave()"));
    }
    else
    {
        buttons.addMxTag(new MxDefaultTag("go_button", rbsearch.getString("button.searchNow"), "loadResults('Cluster')"));
        buttons.addMxTag(new MxDefaultTag("ok_button", rbsearch.getString("button.saveAs"), "loadSave('Cluster')"));

        if (inframe != null && inframe.equals("customize"))
        {
            buttons.addMxTag(new MxDefaultTag("cancel_button", rbsearch.getString("button.cancel"), "closeSave()"));
        }
    }

%>

<html>

<head>
<title></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/search/css/MxSearch.css'>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>

<script language="JAVASCRIPT">

// Get the URL parameters which tell us if we're launched in another UI
// or we're in edit mode
var inframe = "<%=request.getParameter("inframe") %>";
var edit = "<%=request.getParameter("edit") %>";
var queryId = "<%=request.getParameter("queryId") %>";
var queryName = "<%=request.getParameter("queryName") %>";

// Load the initial selection box inner HTML from the search bean
var InitCriteriaBoxHTML = "<% clusterSearchUI.dumpInitCriteriaListBox(out); %>";
var InitCompBoxHTML = "<% clusterSearchUI.dumpInitCompListBox(out); %>";
var InitValBoxHTML = "<% clusterSearchUI.dumpInitValueListBox(out); %>";
var InitEmptyValBoxHTML = "<% clusterSearchUI.dumpEmptyInitValueListBox(out); %>";

// Load the comp selection box inner HTML variables from the search bean
<% clusterSearchUI.dumpCompSelectionBoxHTMLVariables(out); %>

// Load the value selection box inner HTML variables from the search bean
<% clusterSearchUI.dumpValueSelectionBoxHTMLVariables(out); %>

// Load the date information for the time criteria
var todaysDate = "<%=clusterSearchUI.getTodaysDate() %>";
var tomorrowsDate = "<%=clusterSearchUI.getTomorrowsDate() %>";
var currentTime = "<%=clusterSearchUI.getCurrentTime() %>";
var ampmHTML = "<%=clusterSearchUI.getAmPmHTML() %>";
var timeZone = "<%=clusterSearchUI.getTimeZone() %>";

// Load the Version Control Repository Status
var isVCRepositoryConnected = <%=clusterSearchUI.getIsVCConnected() %>;

</script>

<script src="js/MxSearchApi.jsp" language="JavaScript" type="text/javascript"></script>

<script language="JAVASCRIPT">

// Load the script functions from the cluster search bean
<% clusterSearchUI.loadScriptFunctions(out); %>

function init()
{
<%
    if (edit != null)
    {
        clusterSearchUI.loadSearch(request.getParameter("queryId"), out);
    }
    else
    {
        out.println("        var oNewRow = addRow(false, \"\");");
        out.println("        updateCompBox(oNewRow.firstChild.nextSibling.firstChild);");
    }
%>

    // Set the help context
    resetHelpContext();
}

function resetHelpContext()
{
    MxPortalWorkspaceSetHelpTopic("monitor_search_cluster");
    if (edit == "customize")
        MxPortalWorkspaceSetHelpTopic("monitor_lists_system_edit");
}

function switchSearch()
{
    if (document.getElementById("searchType").value == "1")
    {
        var URL = "AdvancedSystemsSearch.jsp";
        if (inframe == "customize") URL += "?inframe=customize";
        document.location.href = URL;
    }
    else
    {
        document.location.href = "AdvancedEventsSearch.jsp";
    }
}
</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body name="SearchBody" id="SearchBody" onLoad="onSearchLoad()" onResize="resizeFrame(50)">
<div name="searchDiv" id="searchDiv">
<div name="criteriaDiv" id="criteriaDiv">

<!--Begin header-->
<script language="JAVASCRIPT">

    if (edit == "customize")
    {
        MxPortalWorkspaceSetHelpTopic("monitor_lists_system_edit");
        document.write("<hr><font class='mx-subheader-nosep'><%=rbsearch.getString("editList")%></font><br><br>");
        document.write("<table cellspacing='0' cellpadding='0' border='0'><tr><td style='padding-top:3px;padding-right:4px'><%=rbsearch.getString("name")%></td><td><input name='name' id='name' type='text' style='width:200' maxlength='70' value='<%=request.getParameter("queryName") %>' onKeyup='checkBlankName()' onClick='setTimeout(\"checkBlankName()\", 3000)' onPaste='setTimeout(\"checkBlankName()\", 100)'");
        if (<%=bIsPreInstalledQuery%>)
            document.write(" disabled='true'");
        document.write("></td></tr></table><br><br>");
        document.write("&nbsp;<%=rbsearch.getString("searchClusters")%><br><br>");
    }
    else if (inframe == "customize")
    {
        MxPortalWorkspaceSetHelpTopic("monitor_lists_system_createList");
        document.write("<hr>");
        document.write("<table cellspacing='0' cellpadding='0' border='0'><tr><td style='padding-top:3px;padding-right:4px'><%=rbsearch.getString("searchFor")%> </td>"
                       + "<td><select name='searchType' id='searchType' onChange='switchSearch()'>"
                       + "<option value='1'><%=rbsearch.getString("systems")%></option>"
                       + "<option value='3' SELECTED><%=rbsearch.getString("clusters")%></option>"
                       + "</select>"
                       + " :"
                       + "</td></tr></table><br><br>");
    }
    else if (inframe != "customize")
    {
        document.write("<table cellspacing='0' cellpadding='0' border='0'><tr><td style='padding-top:3px;padding-right:4px'><%=rbsearch.getString("searchFor")%>  </td>"
                       + "<td><select name='searchType' id='searchType' onChange='switchSearch()'>"
                       + "<option value='1'><%=rbsearch.getString("systems")%></option>"
                       + "<option value='2'><%=rbsearch.getString("events")%></option>"
                       + "<option value='3' SELECTED><%=rbsearch.getString("clusters")%></option>"
                       + "</select>"
                       + " :"
                       + "</td></tr></table><br><br>");
    }
</script>



<!--End header-->
<!--Begin divQry-->

<DIV name="divQry" id="divQry" style="padding-left:10px">

<table ID="tabCriteria" NAME="tabCriteria"
    cellspacing="0" cellpadding="2">
    <tbody ID="tabCriteriaBody" NAME="tabCriteriaBody">
    </tbody>
</table>

</DIV>

<!--End divQry-->

<!--Begin footer-->

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<!--End footer -->
<input type='hidden' name='crit1' value="">
<input type='hidden' name='comp1' value="">
<input type='hidden' name='val1' value="">

</div>

<IFRAME ID="resultSpace" NAME="resultSpace" SRC="blank.html" marginwidth='0' WIDTH=100% HEIGHT=1 SCROLLING=NO FRAMEBORDER=0></IFRAME>
<IFRAME ID="HierCommSpace" SRC="blank.html" style="position:absolute; display:none" height=1 width=1></IFRAME>
<form method="POST" target="resultSpace" action="" id="SearchForm" name="SearchForm">
</form>

</div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
