<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.html.core.*" %>

<jsp:useBean id="systemSearchUI" class="com.hp.mx.portal.search.MxSystemSearchUI" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsearch" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
    rbsearch.init(loginBean, "MxSearch");
    systemSearchUI.init(loginBean);

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("go_button", rbsearch.getString("button.go"), "checkSearchString('go')"));
    buttons.addMxTag(new MxDefaultTag("advanced_button", rbsearch.getString("button.advanced"), "loadAdvanced()"));
    buttons.addMxTag(new MxDefaultTag("save_button", rbsearch.getString("button.saveAs"), "checkSearchString('save')"));
%>

<html>

<head>
<title></title>
<link type='text/css' rel='stylesheet' href='css/MxSearch.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>

<script language="JAVASCRIPT">
// Globals for setting iframe heights dynamically
currentIframe = "none";

// Set the help context
resetHelpContext();

var searchString = "<%=MxHtmlUtil.encodeJScriptSafeEntities(request.getParameter("search")) %>";
var searchStringHtml = "<%=MxHtmlUtil.encodeHtmlEntities(request.getParameter("search")) %>";
var lastSearchString;
var invalidSearchStringMsg = "<%=rbsearch.getString("invalidSearchStringMsg")%>";
var blankSearchFieldMsg = "<%=rbsearch.getString("blankSearchFieldMsg")%>";
var invalidWhiteSpaceBasicMsg = "<%=rbsearch.getString("invalidWhiteSpaceBasicMsg")%>";
if (searchString == "null")
    searchString = "";
var type = "<%=request.getParameter("searchType") %>";
var searchType = "";
if (type == "null" || type == "attrs")
    searchType = "<%=rbsearch.getString("systemAttrs")%>";
else
    searchType = "<%=rbsearch.getString("systemName")%>";

function onLoadHandler()
{
    setTimeout("checkSearchString('go')", 100);
    resizeFrame();
}

function loadResults()
{
    currentIframe = "view";
    showMatchHeader();
    document.getElementById("resultSpace").contentWindow.document.location.replace("BasicSystemsSearchResults.jsp?search=" + searchString);
}

function resetHelpContext()
{
    MxPortalWorkspaceSetHelpTopic("monitor_search_basic");
}

function throwStringError()
{
    document.getElementById("resultSpace").contentWindow.document.location.replace("blank.html");
    hideResultSpace();
    hideMatchHeader();
    alert(invalidSearchStringMsg);
}

function checkBlankString(isKeyup)
{
    var str = document.getElementById('srchStr').value;

    // If we are checking as a result of a keyup event, the string has changed, and
    // any previous result display is collapsed
    if (isKeyup == true && document.getElementById("resultSpace").style.height != 0)
    {
        if (lastSearchString != document.getElementById("srchStr").value)
        {
            hideResultSpace();
            hideMatchHeader();
        }
    }
    if (trim(str) == "")
        setButtons("disabled");
    else
        setButtons("enabled");
}

function checkSearchString(action)
{
    var stringToCheck = document.getElementById("srchStr").value;
    if (stringToCheck == "")
    {
        if ("<%=request.getParameter("refresh")%>" == "null")
            alert(blankSearchFieldMsg);
        setButtons("disabled");
    }
    else if (trim(stringToCheck) == "")
    {
        if ("<%=request.getParameter("refresh")%>" == "null")
            alert(invalidWhiteSpaceBasicMsg);
        setButtons("disabled");
    }
    else if (isValidSearchString(stringToCheck))
    {
        if (action == "go")
            searchAgain();
        else
            loadSave();
    }
    else
        throwStringError();
}

function setButtons(state)
{
    if (state == "disabled")
    {
        ourButtonManager.disableButtonById('go_button');
        ourButtonManager.disableButtonById('save_button');
    }
    else
    {
        ourButtonManager.enableButtonById('go_button');
        ourButtonManager.enableButtonById('save_button');
    }
}

function trim(strText)
{
    while (strText.substring(0,1) == ' ')
        strText = strText.substring(1, strText.length);

    while (strText.substring(strText.length-1,strText.length) == ' ')
        strText = strText.substring(0, strText.length-1);

   return strText;
}

function showMatchHeader()
{
    document.getElementById("matchesFor").style.display = "inline";
    document.getElementById("str").style.display = "inline";
    document.getElementById("inText").style.display = "inline";
    document.getElementById("searchType").style.display = "inline";
    document.getElementById("colon").style.display = "inline";
}

function hideMatchHeader()
{
    document.getElementById("matchesFor").style.display = "none";
    document.getElementById("str").style.display = "none";
    document.getElementById("inText").style.display = "none";
    document.getElementById("searchType").style.display = "none";
    document.getElementById("colon").style.display = "none";
}

function hideResultSpace()
{
    currentIframe = "none";
    document.getElementById("resultSpace").src = "blank.html";
    document.getElementById("resultSpace").style.height = 0;
}

function loadAdvanced()
{
    oTypeSelect = document.getElementById("searchOpt");
    srchString = document.getElementById("srchStr").value;
    if (!isValidSearchString(srchString))
        srchString = "";
    urlParams = "basicSearchString=" + encodeURIComponent(srchString) + "&basicSearchType=";

    if (oTypeSelect.options[1].selected == true)
        urlParams += "name";
    else
        urlParams += "attrs";
    MxPortalActionStart("SEARCH_ADVANCED", urlParams);
}

function loadSave()
{
    currentIframe = "save";
    oStrText = document.getElementById("str");
    oTypeText = document.getElementById("searchType");
    oTypeSelect = document.getElementById("searchOpt");
    oTypeText.innerHTML = oTypeSelect.options[oTypeSelect.selectedIndex].text;
    lastSearchString = document.getElementById("srchStr").value;
    oStrText.innerHTML = lastSearchString;
    hideMatchHeader();

    sURL = "SaveBasicSystemSearch.jsp?search=" + encodeURIComponent(document.getElementById("srchStr").value);
    if (oTypeSelect.options[1].selected == true)
         sURL = sURL + "&type=name";
    else
         sURL = sURL + "&type=attrs";

    document.getElementById("resultSpace").contentWindow.document.location.replace(sURL);
}

function searchAgain()
{
    currentIframe = "view";
    var oStrText = document.getElementById("str");
    var oTypeText = document.getElementById("searchType");
    var oTypeSelect = document.getElementById("searchOpt");
    var newString = document.getElementById("srchStr").value;
    lastSearchString = newString;
    var encodedNewString = encodeURIComponent(newString);

    showMatchHeader();

    if (trim(newString) != "")
    {
        sURL = "BasicSystemsSearchResults.jsp?search=" + encodedNewString;
        if (oTypeSelect.options[1].selected == true)
            sURL = sURL + "&type=name";
        else
            sURL = sURL + "&type=attrs";

        document.getElementById("resultSpace").contentWindow.document.location.replace(sURL);
        oTypeText.innerHTML = oTypeSelect.options[oTypeSelect.selectedIndex].text;
        oStrText.innerHTML = newString;
    }
    else
        hideMatchHeader();
}

function resizeFrame()
{
    if (currentIframe == "view")
    {
        setIframeHeight(Math.max(300, getAvailableHeight()));
        setIframeWidth(Math.max(0, getAvailableWidth()));
    }
}

function getAvailableHeight()
{
    // Get the total height
    var workspaceHeight = Math.max (0, MxDomGetBodyHeight());

    // Subtract the search html height
    var searchDivHeight = document.getElementById("criteriaDiv").offsetHeight;

    // We reserve the right to fudge
    var fudgeHeight = 30;

    var availableHeight = workspaceHeight - searchDivHeight - fudgeHeight;
    return availableHeight;
}

function getAvailableWidth()
{
    // Get the total height
    var workspaceWidth = Math.max(0, MxDomGetBodyWidth());

    // Just return this value, since there is no width taken up by
    // the search div
    var searchDivWidth = 0;

    // We reserve the right to fudge
    var fudgeWidth = 50;

    var availableWidth = workspaceWidth - searchDivWidth - fudgeWidth;
    return availableWidth;
}

function setIframeHeight(height)
{
    document.getElementById("resultSpace").style.height = height;
}

function setIframeWidth(width)
{
    document.getElementById("resultSpace").style.width = width;
}
</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body scrolling="auto" onLoad="onLoadHandler()" onResize="resizeFrame()">
<div id='searchDiv' name='searchDiv'>
<div name="criteriaDiv" id="criteriaDiv">
<table cellspacing='0' cellpadding='0' border='0'>
    <tr>
        <td style='padding-top:4px;padding-right:4px;'><%=rbsearch.getString("searchAgain")%>: </td>
        <td>
            <input name='srchStr' id='srchStr' type='text' style='width:140px' maxlength='90' onKeyup='checkBlankString(true)' onClick='setTimeout("checkBlankString(false)", 1500)' onPaste='setTimeout("checkBlankString(true)", 100)'>
        </td>
        <td style='padding-top:4px;padding-right:4px;padding-left:4px'><%=rbsearch.getString("in")%></td>
        <td style='padding-top:1px'>
            <select name="searchOpt" id="searchOpt" onChange="javascript:hideResultSpace();hideMatchHeader();">
                <option value="0"><%=rbsearch.getString("systemAttrs")%></option>
                <option value="1"><%=rbsearch.getString("systemName")%></option>
            </select>
        </td>
    </tr>
</table>
<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<script language="JAVASCRIPT">
    document.write("<font class='subtitle-name'><span id='matchesFor' name='matchesFor'><%=rbsearch.getString("matchesFor")%> \"</span>");
    document.write('<span id="str" name="str">' + searchStringHtml + '</span>' + '<span id="inText" name="inText">" <%=rbsearch.getString("in")%></span> <span id="searchType" name="searchType">' + searchType + '</span><span id="colon" name="colon">:</span>');
    document.write("</font>");

    hideMatchHeader();
    document.getElementById("srchStr").value = searchString;
</script>
</div>
</div>
<IFRAME ID='resultSpace' NAME='resultSpace' SRC='blank.html' WIDTH=100% HEIGHT=1 SCROLLING=AUTO FRAMEBORDER=0></IFRAME>
<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
