<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsearch" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
    rbsearch.init(loginBean, "MxSearch");
%>

// Localized error messages
var blankNameErrMsg = "<%=rbsearch.getString("blankNameErrMsg")%>";
var blankCatNameErrMsg = "<%=rbsearch.getString("blankCatNameErrMsg")%>";
var listNameDupErrMsg = "<%=rbsearch.getString("listNameExistsErrMsg")%>";
var folderNameDupErrMsg = "<%=rbsearch.getString("folderNameExistsErrMsg")%>";
var listNameInvalidErrMsg = "<%=rbsearch.getString("listNameInvalidErrMsg")%>";
var folderNameInvalidErrMsg = "<%=rbsearch.getString("folderNameInvalidErrMsg")%>";

// API functions for Save Search UI Pages

///////////////////////////////////////////////////////////////////////
// Utility functions
///////////////////////////////////////////////////////////////////////
function trim(strText)
{
    while (strText.substring(0,1) == ' ')
        strText = strText.substring(1, strText.length);

    while (strText.substring(strText.length-1,strText.length) == ' ')
        strText = strText.substring(0, strText.length-1);

   return strText;
}

function getFirstChildOfType(obj, szTag)
{
    if (obj == null)
        return null;

    var childrenByTags = obj.getElementsByTagName(szTag);
    if (childrenByTags != null && childrenByTags.length > 0)
        return childrenByTags.item(0);

    return null;
}

///////////////////////////////////////////////////////////////////////
// Page loading and management functions
///////////////////////////////////////////////////////////////////////
function setOKButton(state)
{
    var oButton = document.getElementById("ok_button");
    if (oButton != null)
    {
        if (state == "enabled")
        {
            ourButtonManager.enableButton(oButton);
        }
        else
        {
            ourButtonManager.disableButton(oButton);
        }
    }
}

function resizeFrame()
{
    var oSelf = parent.document.getElementById("resultSpace");
    var h = document.getElementById("saveDiv").offsetHeight;
    oSelf.style.height = h + 50;
    if (parent.resizeFrame != null)
        parent.resizeFrame(50);
}

function onSaveLoad()
{
    var oCollectionBox = document.getElementById("parentCol");
    resizeFrame();
    init();
    if (parent.setOKButton != null)
        parent.setOKButton("enabled");
}

function init()
{
    setOKButton("disabled");
    document.getElementById("cancel_button").focus();
    setTimeout('document.getElementById("name").focus()', 100);
}

function closeSave()
{
    parent.resetHelpContext();
    document.location.replace("blank.html");
}

///////////////////////////////////////////////////////////////////////
// Folder selection control functions
///////////////////////////////////////////////////////////////////////
function setSelected()
{
    var oParentColBox = document.getElementById("parentCol");
    var oCollectionNameInput = document.getElementById("selectedCollection");

    var collectionString = oParentColBox.options[oParentColBox.selectedIndex].value;
    var collectionInfo = collectionString.split(";");
    var collectionIdInfo = collectionInfo[0].split("=");
    oCollectionNameInput.value = collectionIdInfo[1];
}

///////////////////////////////////////////////////////////////////////
// Error checking functions
///////////////////////////////////////////////////////////////////////
function checkAndSubmit(type)
{
    // Disable the OK button
    setOKButton("disabled");
    var listName = document.saveForm.name.value;
    var selectedCollection = document.saveForm.selectedCollection.value;

    if (!isValidListName(listName))
    {
        alert(listNameInvalidErrMsg);
        setOKButton("enabled");
    }
    else
        verifyNames(listName, selectedCollection, type);
}

function verifyNames(listName, selectedCollection, type)
{
    var encodedListName = encodeURIComponent(listName);
    var encodedSelectedCollection = encodeURIComponent(selectedCollection);
    var URL = "CheckListName.jsp" + "?listName=" + encodedListName;
    URL += "&type=" + type;
    document.getElementById("commSpace").contentWindow.document.location.replace(URL);
}

function checkBlankName()
{
    if (trim(document.getElementById("name").value) == "")
         setOKButton("disabled");
    else
         setOKButton("enabled");
}

function throwNameError(errMsg)
{
    alert(errMsg);
    setOKButton("enabled");
}

function submitSaveForm()
{
    setSelected();
    if (parent.inframe == "customize")
        document.getElementById("inframe").value = "customize";
    document.saveForm.submit();
}
