<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/security/serverCertCSR.jsp,v $
// $Revision: 1.17 $
// $Date: 2005/01/19 06:18:00 $
//
%>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all your Java imports here -->
<!-- ---------------------------------------------------------------------- -->

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.portal.security.ServerCertificateBean" %>
<%@ page import="com.hp.mx.utilities.MxKeystore" %>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all your taglib imports here -->
<!-- ---------------------------------------------------------------------- -->

<!-- ---------------------------------------------------------------------- -->
<!--  Create all your beans here -->
<!-- ---------------------------------------------------------------------- -->

<!--  REQUIRED: This bean is used (later) to verify that this page is allowed to run -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<!-- My uniquely named beans -->
<jsp:useBean id="security_serverCertBean" class="com.hp.mx.portal.security.ServerCertificateBean" scope="session"/>
<jsp:useBean id="security_serverCertBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<!-- ---------------------------------------------------------------------- -->
<!--  Put one block of initialization Java code here -->
<!--  In general, keep Java code to a minimum. Put Java code into JavaBeans. -->
<!-- ---------------------------------------------------------------------- -->
<%
    // REQUIRED: Set necessary HTTP header attributes (for localization and page caching)
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE))
    {%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
  <%}

    // Set up the resource file
    security_serverCertBundle.init(loginBean, "ServerCertificate");
    security_serverCertBean.initBean(out, loginBean);

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnCreate", security_serverCertBundle.getString("servercert.button.create") + "...", "createCSR()"));
%>

<!-- ---------------------------------------------------------------------- -->
<!--  From here on, this is a well-formed HTML file -->
<!-- ---------------------------------------------------------------------- -->

<html>

<!-- ---------------------------------------------------------------------- -->
<!--  The HEAD block contains meta tags, the TITLE, style sheet links, -->
<!--  JavaScript links, and JavaScript code. -->
<!-- ---------------------------------------------------------------------- -->

<head>

<!-- ---------------------------------------------------------------------- -->
<!--  Most pages can get away with no title, because they are displayed -->
<!--  inside of a frame. -->
<!-- ---------------------------------------------------------------------- -->
    <TITLE></TITLE>

<!-- ---------------------------------------------------------------------- -->
<!--  Any additional style sheets links go here -->
<!-- ---------------------------------------------------------------------- -->
    <STYLE TYPE="text/css">
    <!--
        .required{ color:#FF0000; font-weight:bold; }
        .indented{ margin-left:12px; }
    -->
    </STYLE>

<!-- ---------------------------------------------------------------------- -->
<!--  Any additional JavaScript links go here -->
<!-- ---------------------------------------------------------------------- -->

<!--  COMMONLY USED: This includes the browser-based portal API -->
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all additional JavaScript here -->
<!-- ---------------------------------------------------------------------- -->
<script language='JavaScript' type='text/javascript'>

   function createCSR()
   {
      ourButtonManager.disableButtonById('btnCreate');
      document.CreateCSRForm.submit();
   }

   function doExport()
   {
      f = document.getElementById("hiddenframe");
      if (f != null)
          f.contentWindow.document.location.replace('<%=MxKeystore.EXPORT_CSR%>');
   }

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<!-- ---------------------------------------------------------------------- -->
<!--  The BODY block begins here -->
<!-- ---------------------------------------------------------------------- -->
<body>

<font class='mx-subheader-nosep'><%= security_serverCertBundle.getString("servercert.csr.title") %></font>
<p><%= security_serverCertBundle.getString( "servercert.csr.instructions") %></p>

    <P class='errorTextBold' id="globalResult"></P>

<!-- blockquote -->

    <strong><%= security_serverCertBundle.getString("servercert.subject") %>:</strong>
    <table class="indented">
        <% security_serverCertBean.showCertificate( ServerCertificateBean.CERT_SUBJECT, out); %>
    </table>

 <form action="serverCertCSR.jsp?createCSR=yes" method="POST" name="CreateCSRForm">
 <div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
 </div>
 </form>

<!-- /blockquote -->

<iframe id="hiddenframe" style="width:0; height:0; position:relative; visibility:hidden"
       scrolling="no" marginwidth="0" frameborder="0" src="<%=MxOptions.URL_BASE%>/home/MxBlank2.html">
</iframe>

<script>
<%
  // Process POST (export request) and result
  if ( request.getMethod().equalsIgnoreCase("POST") && (request.getParameter("createCSR") != null) )
  {
    String result = security_serverCertBean.createCSR();
    if (result == null)
      out.println("doExport();");
    else
      out.println("document.getElementById('globalResult').innerHTML=\""+result+"\";");
  }
%>
</script>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
