<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/security/serverCertificateChange.jsp,v $
// $Revision: 1.23 $
// $Date: 2005/06/10 18:58:03 $
//
%>

<!--  Put all your Java imports here -->

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.utilities.MxKeystore" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="javax.swing.table.AbstractTableModel" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<!--  Put all your taglib imports here -->

<!--  Create all your beans here -->

<!--  REQUIRED: This bean is used (later) to verify that this page is allowed to run -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<!-- My uniquely named beans -->
<jsp:useBean id="security_serverCertBean" class="com.hp.mx.portal.security.ServerCertificateBean" scope="session"/>
<jsp:useBean id="security_serverCertBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<!--  Put one block of initialization Java code here -->
<!--  In general, keep Java code to a minimum. Put Java code into JavaBeans. -->

<%!
    /** **********************************************************************
     * The debug object
     ************************************************************************ */
    public DebugSubsystem dbg = DebugOutput.getDebugSubsystem("jsp.serverCert");
%>
<%
    // REQUIRED: Set necessary HTTP header attributes (for localization and page caching)
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE))
    {%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
  <%}

    // Set up the resource file
    security_serverCertBundle.init(loginBean, "ServerCertificate");
    security_serverCertBean.initBean(out, loginBean);

    // Process POST with certificate change request
    if (request.getMethod().equals("POST"))
        security_serverCertBean.changeServerCert(request, out);

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnOk", security_serverCertBundle.getString("servercert.button.ok"), "processChangeCertificate();"));
    buttons.addMxTag(new MxDefaultTag("btnCancel", security_serverCertBundle.getString("servercert.button.cancel"), "document.location='"+ MxOptions.URL_BASE+ "/home/MxBlank2.html'"));
%>

<!--  From here on, this is a well-formed HTML file -->

<html>

<!--  The HEAD block contains meta tags, the TITLE, style sheet links, -->
<!--  JavaScript links, and JavaScript code. -->

<head>

<!--  Most pages can get away with no title, because they are displayed -->
<!--  inside of a frame. -->
    <TITLE><%= security_serverCertBundle.getString("servercert.main.title") %></TITLE>

<!--  Any additional style sheets links go here -->
    <STYLE TYPE="text/css">
    <!--
        .required-hdr{ font-family:arial,sans-serif; font-size:8.5pt; font-weight:normal; color: black;}
        .indented{ margin-left:12px; }
    -->
    </STYLE>

<!--  Any additional JavaScript links go here -->

<!--  COMMONLY USED: This includes the browser-based portal API -->
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/utilities.js" ></script>

<!--  Put all additional JavaScript here -->

<script language='JavaScript' type='text/javascript'>
   function isEmpty( s)
   {
      var rx = new RegExp( /\S/ );
      if ( (s==null) || (s.value==null) || (s.value=="") || !rx.test(s.value) )
         return true;
      else
         return false;
   }

   function isValidString( s)
   {
      var rx = new RegExp( /<%= security_serverCertBean.regex_js %>/);
      return !rx.test(s);
   }

<!-- This function name is passed to the bean -->
   function isValidField( s)
   {
      if ( !isEmpty(s) && isValidString(s.value) )
         return true;
      else
         return false;
   }

<!-- This function name is no longer passed to the bean due to issues on Mozilla -->
   function isValidChar( e)
   {
      var charCode = e.which;
      if (charCode == null)
         charCode = e.keyCode;

      var str = String.fromCharCode(charCode);
      return isValidString(str);
   }

   function validateParams()
   {
      <% security_serverCertBean.showValidateParams( out, "isValidField"); %>
   }

   function processChangeCertificate()
   {
      result = validateParams();
      if (result != null)
      {
         document.getElementById("globalResult").innerHTML = result;
         return;
      }
      answer=confirm( <% security_serverCertBean.showWarning( request, out); %> );
      if (answer)
      {
         disableButtons();
         document.CertChangeForm.submit();
      }
   }

   function disableButtons()
   {
      ourButtonManager.disableButtonById('btnOk');
      ourButtonManager.disableButtonById('btnCancel');
   }
</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body>

<hr class="mx-hr">

<%
    // If posted a change request and no errors, redisplay the parent page with updated certificate.
    if ( request.getMethod().equals("POST") && !security_serverCertBean.hasErrorMessages())
        out.println("<script>parent.location.replace('serverCertificate.jsp');</script>");
%>

    <font class='mx-subheader-nosep'><%= security_serverCertBean.getChangePageTitle(request) %></font>
    <p><%= security_serverCertBean.getChangePageDescription( request) %></p>
<%
    // Display any errors available in the bean.
    security_serverCertBean.displayErrorMessagesInHtml(out);
    security_serverCertBean.clearAllErrorMessages();
%>
    <P class='errorTextBold' id="globalResult"></P>

    <div class="required-hdr"><%= security_serverCertBundle.getString("servercert.required") %> *</div>
    <br>

    <form action="serverCertificateChange.jsp" method="POST" name="CertChangeForm">
    <strong><%= security_serverCertBundle.getString("servercert.subject") %>:</strong>
    <table class="indented">
    <% security_serverCertBean.showChangeCertificateForm( request, out, ""); %>
    </table>
    </form>

   <br>

    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
