<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="discTemplate" class="com.hp.mx.portal.discovery.AutoDiscoveryTemplateBean" scope="session" />
<jsp:useBean id="discTempSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
        return;
    }

    // Bean setup
    discTemplate.initialize(loginBean, discTempSelectionModel );

    String  fileNameFieldState = "";
    String  mode = "";
    String errStr = "";
    String subHeader="";

    if (request.getMethod().equals("POST"))
    {
        // save the file...
        discTemplate.clearAllErrorMessages();
        discTemplate.processDetailsPost(request,  out);

        // maintain the mode
        if (request.getParameter("newOrEdit") != null)
        {
            mode = request.getParameter("newOrEdit");
        }
    }
    else
    {
        discTemplate.clearAllErrorMessages();

        // load the file - or show default new.
        if (request.getParameter("delTemplate") != null)
        {
            discTemplate.deleteSelectedFile();

            if (!discTemplate.hasErrorMessages())
            {
                out.print(" <script language='JavaScript' type='text/javascript'>");
               // out.print("MxTableRefreshInPlace(\"ID_DISCTEMP_TABLE\")");
                out.print("parent.location.href='AutoDiscoveryTemplates.jsp'");
                out.print("</script> ");
                return;
            }
        }
        if (request.getParameter("newTemplate") != null)
        {
            mode = "new";
        }
        else if (request.getParameter("editTemplate")!= null )
        {
            // for now always leave enabled - otherwise field is not in param list

            fileNameFieldState = "readonly";
            mode = "edit";
        }
        else
        {
            return;
        }
    }


    if (mode.equalsIgnoreCase("new"))
    {
        subHeader = discTemplate.getResourceString("template.page.details.label.newTemplate");
    }
    else if (mode.equalsIgnoreCase("edit"))
    {
        subHeader = discTemplate.getResourceString("template.page.details.label.editTemplate");
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    buttons.addMxTag(new MxDefaultTag("btnOK", discTemplate.getResourceString("template.page.details.button.OK"), "doSave()"));
    buttons.addMxTag(new MxDefaultTag("btnCancel", discTemplate.getResourceString("template.page.details.button.cancel"), "parent.location.href='AutoDiscoveryTemplates.jsp'"));

    MxTag uploadBtnTag = new MxDefaultTag("uploadBtn", discTemplate.getResourceString("template.page.details.import"), "doUpload()");
%>

<html>
    <head>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript" ></script>
        <script src="<%=MxOptions.URL_BASE%>/js/utilities.js"   language="JavaScript" type="text/javascript"></script>

        <script language='JavaScript' type='text/javascript'>
        <%
        if (mode.equals("edit"))
        {
            %>MxPortalWorkspaceSetHelpTopic("admin_discovery_template_edit");<%
        }
        else
        {
            %>MxPortalWorkspaceSetHelpTopic("admin_discovery_template_new");<%
        }
        %>

        function cancel()
        {
            MxPortalWorkspaceSetHelpTopic("admin_discovery_template");
            location.href="<%= MxOptions.URL_BASE %>/home/MxBlank2.html";
        }


        function doUpload()
        {
            // Since we're dealing with a multi-part form, use URL for settings
            document.ConfigForm.action = "AutoDiscoveryTemplateDetails.jsp?loadNow=true&uploadFile=true&newOrEdit=<%= mode %>";
            document.ConfigForm.submit();
        }

        function doSave()
        {
            //    validateAll();
            var fileName = document.getElementById("fileName").value;
            document.ConfigForm.action = "AutoDiscoveryTemplateDetails.jsp?newOrEdit=<%= mode %>&fileName=" + escape(fileName);
            document.ConfigForm.submit();
            return true;
        }


        function checkDetailButtonStates()
        {
            // new button is always enabled.
            // default state on page load is disabled, so only enable if something is selected.

            if (document.ConfigForm.fileName.value.length > 0)
                ourButtonManager.enableButtonById('btnOk');
            else
                ourButtonManager.disableButtonById('btnOk');

            if (document.ConfigForm.selectFileBtn.value.length > 0)
                ourButtonManager.enableButtonById('uploadBtn');
            else
                ourButtonManager.disableButtonById('uploadBtn');
        }


        function init()
        {
            checkDetailButtonStates();
            setDisplayHeightAndWidth();
        }

        function setDisplayHeightAndWidth()
        {
            var pageHeight  = document.body.scrollHeight;
            var pageWidth  = document.body.scrollWidth;
            parent.setFrmDisplayHeight(pageHeight);
        }
        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>
    <body  onLoad="init()" >
        <table border='0' cellspacing='0' cellpadding='0' width="100%">
            <tr>
                <td><div class='mx-subheader'><%= subHeader %></div><td>
            <tr>
        </table>
        <%
            // Display any error messages
            if (discTemplate.hasErrorMessages())
            {
                // Display plurally-correct label
                if (discTemplate.getErrorMessageList().size() == 1)
                {
        %>
                    <div class="errorTextBold"><%= discTemplate.getResourceString("discovery.general.error.label.single")%></div>
                    <BR>
        <%
                }
                else
                {
                    %>
                    <div class="errorTextBold"><%= discTemplate.getResourceString("discovery.general.error.label.multiple")%></div>
                    <BR>
                    <%
                }

                // Finally, display the error message(s)
                discTemplate.displayErrorMessagesInHtml(out);
            }
        %>
        <form action="javascript:doSave()" method="POST" name="ConfigForm" ENCTYPE="multipart/form-data">
            <input type='hidden' name='newOrEdit' value='<%= mode %>' >
            <div style="margin-left:4px;" class="required_label"><%= discTemplate.getResourceString("template.page.details.label.required")%> *</div>
            <table >
              <tr>
                <td>
                  <strong><%= discTemplate.getResourceString("template.page.details.fileName")%><span class="required">*</span></strong>
                </td>
                <td>
                  <input style="width:300;" type='text' <%= fileNameFieldState %> name='fileName' id='fileName' onMouseUp="checkDetailButtonStates()" onKeyUp="checkDetailButtonStates()" onChange="checkDetailButtonStates()" value='<%=discTemplate.getFileName(request) %>' maxlength='50' >
                </td>
                <td></td>
                </tr>
                <tr>
                <td>
                    <strong><%= discTemplate.getResourceString("template.page.details.fileUploadName")%></strong>
                </td>
                <td>
                    <input style="width:300; height:24" onKeyUp="checkDetailButtonStates()" onClick="checkDetailButtonStates()"  onChange="checkDetailButtonStates()" type='file' name='selectFileBtn' id='selectFileBtn' value=''>&nbsp;&nbsp;
                </td>
                <td>
                    <% MxButton.dumpButton(uploadBtnTag, out); %>
                </td>
              </tr>
            </table>
            <br>
            <br>
            <strong><%= discTemplate.getResourceString("template.page.details.contents") %></strong><br>
            <textarea name='fileContents' id='fileContents' wrap="off" cols='80' rows='15'><% discTemplate.getFileContents(request, out); %></textarea>
            <div style="margin-top:15px">
                <% buttons.dumpButtons(out); %>
            </div>
        </form>
     <script>giveFocus("fileName");</script>

<% MxHtmlUtil.dumpBodyEnd(out); %>

  </body>
</html>
