<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil" %>

<jsp:useBean id="toolboxUI" class="com.hp.mx.portal.settings.MxToolBoxUI" scope="session" />
<jsp:useBean id="toolboxTableModel" class="com.hp.mx.portal.settings.MxToolboxTableModel" scope="session" />
<jsp:useBean id="toolboxSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="toolUI" class="com.hp.mx.portal.settings.MxToolUI" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOLBOX_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    String errorFlag = request.getParameter("error");
    if (errorFlag == null)
    {
        errorFlag = "";
    }
    if ( ! errorFlag.equals("true") )
    {
        toolboxUI.resetBean();
    }
    int[] toolboxIndex = toolboxSelectionModel.getSelectedIndices();
    // Used later to store GUID;
    String toolboxGUID  = "";
    boolean isMonitorToolbox = false;
    boolean isMasterToolbox  = false;
    if (null != toolboxIndex && toolboxIndex.length > 0)
    {
        MxObjectID toolboxID = toolboxTableModel.getObjectID(toolboxIndex[0]);
        toolboxGUID = toolboxID.getGUID().toString();

        String masterID = toolboxUI.getMasterToolBoxID(loginBean);
        String monitorID = toolboxUI.getMonitorToolBoxID(loginBean);
        if ( toolboxGUID.equals( masterID) )
        {
            isMasterToolbox = true;
        }
        else
        {
            toolboxUI.LoadToolBox(loginBean, toolboxID);
            if ( toolboxGUID.equals( monitorID) )
            {
                isMonitorToolbox = true;
            }
        }
    }
    rbsettings.init(loginBean, "MxSettings");

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag okButtonTag = new MxDefaultTag("okButton", rbsettings.getString("button.ok"), "");
    okButtonTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(okButtonTag);

    buttons.addMxTag(new MxDefaultTag("cancelButton", rbsettings.getString("button.cancel"), "cancelEdit()"));

    buttons.setMxTagSelectionId("okButton");

    MxButtons vertButtons = new MxButtons();
    vertButtons.clearMxTags();
    vertButtons.addMxTag(new MxDefaultTag("addButton", ">>", "addToToolList()"));
    vertButtons.addMxTag(new MxDefaultTag("removeButton", "<<", "removeFromToolList()"));
    vertButtons.setVerticalAligned(true);
%>

<html>

<head>
<title></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_auth_modifyToolbox");

function resetScroll()
{
    window.parent.scrollTo(0,0);
}

function setToolBox(toolList)
{
    // Populate the tool list based on the string from the tool list
    toolList = document.toolboxForm.toolsAddList.value;
    var toolListArray = toolList.split("*");

    // Find out how many tools there are
    var noOfTools = toolListArray.length;
    var toolBox = document.toolboxForm.tools_list;
    var toolBoxCnt = toolBox.length;

    for(var i = 0; i < noOfTools; i++)
    {
        var currentToolArray = toolListArray[i].split("|");

        // Create a new option object and add
        var newToolOption = new Option(currentToolArray[0], currentToolArray[1]);
        toolBox.options[toolBox.length] = newToolOption;
    }
}

function getNewToolsList()
{
    var categoryIndex = document.toolboxForm.toolsCategory.value;
    var category = document.toolboxForm.toolsCategory.options[categoryIndex].text;
    document.getElementById("ToolboxCommSpace").src = "GetToolsForCategory.jsp?category=" + category;
}

function resetToolsList(toolsList)
{
    // Loop through the tools list box to clear it out, then reload
    var availableBox = document.toolboxForm.available_tools;
    var categoryIndex = document.toolboxForm.toolsCategory.value;
    var category = document.toolboxForm.toolsCategory.options[categoryIndex].text;
    var optCnt = 0;
    while (availableBox.length > 0)
    {
        availableBox.options[0] = null;
    }

    // Repopulate the available box with the new tool names
    // Parse through the list, and for each matching group name, turn on the selection
    var toolListArray = toolsList.split("*");

    // Find out how many tools there are
    var noOfTools = toolListArray.length;
    var toolBox = document.toolboxForm.tools_list;
    var toolBoxCnt = toolBox.length;

    for(var i = 0; i < noOfTools; i++)
    {
        // See if this tool is already in the toolbox. If it isn't, add it to the available box
        // Add this element to the end of the group list box
        var inToolBox = false;
        var toolPair         = toolListArray[i];
        var toolPairArray    = toolPair.split("|");
        var toolName         = toolPairArray[0];
        var toolGuidCatPair  = toolPairArray[1];
        var toolGuidCatArray = toolGuidCatPair.split(":");
        var toolGuid         = toolGuidCatArray[0];

        for (var j = 0; j < toolBoxCnt; j++)
        {
            var toolFormValue = toolBox.options[j].value;
            var toolFormValueArray = toolFormValue.split(":");
            if (toolFormValueArray[0] == toolGuid)
            {
                inToolBox = true;
            }
        }

        if (inToolBox == false)
        {
          // Create a new option object and add
          var newToolOption = new Option(toolName, toolGuidCatPair);
          availableBox.options[availableBox.length] = newToolOption;
        }
    }
}

function addToToolList()
{
    // Set up the select box elements and the option counter
    var availableBox = document.toolboxForm.available_tools;
    var toolBox = document.toolboxForm.tools_list;
    var optCnt = 0;
    var availCnt = availableBox.length;

    // Loop through the available list
    // Add selected elements to the add list
    for (optCnt = 0; optCnt < availCnt; optCnt++)
    {
        if(availableBox.options[optCnt].selected == true)
        {
            // Create a new option object
            var newToolOption = new Option((availableBox.options[optCnt].text), (availableBox.options[optCnt].value));

            // Add this element to the end of the group list box
            toolBox.options[toolBox.length] = newToolOption;
        }
    }

    // Loop through to remove the selected items from the available list
    for (optCnt = 0; optCnt < availCnt; optCnt++)
    {
        if(availableBox.options[optCnt].selected == true)
        {
            // Remove the selected option from the available list
            availableBox.options[optCnt] = null;
            optCnt--;
            availCnt--;
        }
    }

    //Now check the buttons
    checkButtons();
}

function removeFromToolList()
{
    // Set up the select box elements and the option counter
    var availableBox = document.toolboxForm.available_tools;
    var categoryIndex = document.toolboxForm.toolsCategory.value;
    var category = document.toolboxForm.toolsCategory.options[categoryIndex].text;
    var toolBox = document.toolboxForm.tools_list;
    var optCnt = 0;
    var toolCnt = toolBox.length;

    // Loop through the group list
    // Add selected elements to the available list
    for (optCnt = 0; optCnt < toolCnt; optCnt++)
    {
        var toolGuidCatPair = toolBox.options[optCnt].value;
        var toolGuidCatArray = toolGuidCatPair.split(":");
        // Only add the removed tool back to the available box if it belongs to the current category
        if(toolBox.options[optCnt].selected == true && toolGuidCatArray[1] == category)
        {
            // Create a new option object
            var newToolOption = new Option((toolBox.options[optCnt].text), toolGuidCatPair);

            // Add this element to the end of the group list box
            availableBox.options[availableBox.length] = newToolOption;
        }
    }
    // Remove selected elements from group list
    for (optCnt = 0; optCnt < toolCnt; optCnt++)
    {
        if(toolBox.options[optCnt].selected == true)
        {
            // Remove the selected option from the available list
            toolBox.options[optCnt] = null;
            optCnt--;
            toolCnt--;
        }
    }

    // Now check the buttons
    checkButtons();
}

function postToolsList()
{
    // Loop through to concat the tool names together
    // Format is optionText|value*optionText|value, etc
    var optCnt = 0;
    var toolBox = document.toolboxForm.tools_list;
    var toolCnt = toolBox.length;
    var toolList = "";
    if(toolCnt != 0)
    {
        toolList = toolBox.options[0].text + "|" + toolBox.options[0].value;

        for (optCnt = 1; optCnt < toolCnt; optCnt++)
        {
            toolList = toolList + "*" + toolBox.options[optCnt].text + "|" + toolBox.options[optCnt].value;
        }
    }
    // Add the string to the url for posting
    document.toolboxForm.toolsAddList.value = toolList;
    resetScroll();
}

function cancelEdit()
{
    resetScroll();
    parent.document.location.href="ToolboxStart.jsp";
}

function checkName()
{
    if(document.toolboxForm.name.value != "")
    {
        ourButtonManager.enableButtonById('okButton');
    }
    else
    {
        ourButtonManager.disableButtonById('okButton');
    }
}

function checkButtons()
{
    // Loop through the available node box and the member node boxes and
    // see if they have anything selected. If no selections, disable the appropriate button
    var availableBox = document.toolboxForm.available_tools;
    var availableCnt = availableBox.length;
    ourButtonManager.disableButtonById('addButton');

    for (var i = 0; i < availableCnt; i++)
    {
        if (availableBox.options[i].selected == true)
        {
            ourButtonManager.enableButtonById('addButton');
        }
    }

    var memberBox = document.toolboxForm.tools_list;
    var memberCnt = memberBox.length;
    ourButtonManager.disableButtonById('removeButton');

    for (i = 0; i < memberCnt; i++)
    {
        if (memberBox.options[i].selected == true)
        {
            ourButtonManager.enableButtonById('removeButton');
        }
    }
}

function init()
{
    // Prevent the Monitor toolbox fields from being edited
<%  if ( isMonitorToolbox )
    {
%>
        document.toolboxForm.name.disabled = "true";
        document.toolboxForm.name.className = "disabled-text";
        document.toolboxForm.description.disabled = "true";
        document.toolboxForm.description.className = "disabled-text";
        document.toolboxForm.enabled.disabled = "true";
        document.toolboxForm.enabled.className = "disabled-text";
<%  }
    else if ( isMasterToolbox )
    {
%>
        document.toolboxForm.name.disabled = "true";
        document.toolboxForm.name.className = "disabled-text";
        document.toolboxForm.description.disabled = "true";
        document.toolboxForm.description.className = "disabled-text";
        document.toolboxForm.enabled.disabled = "true";
        document.toolboxForm.enabled.className = "disabled-text";

        document.toolboxForm.toolsCategory.disabled = "true";
        document.toolboxForm.toolsCategory.className = "disabled-text";
        document.toolboxForm.available_tools.disabled = "true";
        document.toolboxForm.available_tools.className = "disabled-text";
        document.toolboxForm.tools_list.disabled = "true";
        document.toolboxForm.tools_list.className = "disabled-text";

        ourButtonManager.disableButtonById('okButton');
<%  }
    else
    {
%>
        document.toolboxForm.name.focus();
<%  }
%>
    checkButtons();
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<%  if ( isMasterToolbox )
    {
%>
<body>
  <hr>
  <font class="subwindow-header"><%=rbsettings.getString("toolbox.edittitle")%></font>
  <br><br>
    <div align="center"><font class="errorTextBold"><%=rbsettings.getString("toolbox.edit.master.error")%></font>
    </div>
  <br>
</body>
<%  }
    else
    {
%>
<body onLoad="init();">
<form method="POST" name="toolboxForm" autocomplete="off" style="border:0px;padding:0px;margin:0px" action="ToolboxServer.jsp" onSubmit="postToolsList()">
  <hr>
    <table border="0" width="100%">
      <tr>
        <td align="left"><font class="subwindow-header"><%=rbsettings.getString("toolbox.edittitle")%></font></td>
        <td align="right"><%=rbsettings.getString("lastmodified")%> <jsp:getProperty name='toolboxUI' property='lastModified' /></td>
      </tr>
    </table>
<%  if( errorFlag.equals("true") )
    {
        String errorCodeStr = request.getParameter("errorCode");
        String errorCodeMsg = toolboxUI.getEditErrorMessageByCode(errorCodeStr,rbsettings);
        String errorMessage = toolboxUI.getErrorMessage();

        if (errorMessage != null || errorCodeMsg != null)
        {
            out.println("<hr>");
            if (errorCodeMsg != null)
            {
                out.println("<div align='center'>");
                out.println("<font class='errorTextBold'>");
                out.println(errorCodeMsg);
                out.println("</font>");
                out.println("</div>");
            }
            if (errorMessage != null)
            {
                out.println("<div align='center'>");
                out.println("<font class='errorText'>");
                out.println(errorMessage);
                out.println("</font>");
                out.println("</div>");
            }
            out.println("<hr>");
        }
    }
%>
    <br>&nbsp;<span class="required_label"><%=rbsettings.getString("required")%>*</span>
    <br><br>
    <table border="0" width="100%">
      <tr>
        <td width="10%">
          <font class="input-field"><%=rbsettings.getString("toolbox.name")%>&nbsp;</font><span class="required">*</span></td>
        <td width="90%"><input type="text" name="name" size="20" onKeyup="checkName()" onBlur="checkName()"></td>
      </tr>
      <tr>
        <td width="10%">
          <font class="input-field"><%=rbsettings.getString("toolbox.description")%>&nbsp;</font>
        </td>
        <td width="90%">
          <font class="input-field"><input type="text" name="description" size="60"></font>
        </td>
      </tr>
    </table>
<br>

<input type="checkbox" name="enabled" value="ON" checked> <font class="input-field"><%=rbsettings.getString("toolbox.enabled")%></font><br><br>

    <table border="0" width="100%">
      <tr>
        <td width="40%" valign="middle" align="center" colspan="2">
          <p align="left"><font class="listbox-header"><%=rbsettings.getString("toolbox.showtools")%> </font></p>
        </td>
        <td width="40%" valign="middle" align="left"><font class="listbox-header"><%=rbsettings.getString("toolbox.toolbox")%></font></td>
      </tr>
      <tr>
        <td colspan="3">
          <select size="1" name="toolsCategory" onChange="getNewToolsList()">
            <% toolUI.ListToolCategories(loginBean, out); %>
          </select> :
        </td>
      </tr>
      <tr>
        <td width="45%" valign="middle" align="center">

  <select size="5" name="available_tools" style="width:100%" onChange="checkButtons()" multiple></select></td>
        <td width="10%" valign="middle" align="center">

        <% vertButtons.dumpButtons(out); %>

        </td>
        <td width="45%" valign="middle" align="center"><select size="5" name="tools_list" style="width:100%" onChange="checkButtons()" multiple></select></td>
      </tr>
    </table>

<input type="hidden" name="command" value="edit">
<input type="hidden" name="toolboxGUID" value=<%=toolboxGUID %>>
<input type="hidden" name="toolsAddList">

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

</form>

<IFRAME ID="ToolboxCommSpace" SRC="Blank.html" style="position:absolute; visibility:hidden" height="1" width="1"></IFRAME>
<script language="JAVASCRIPT">
getNewToolsList()
</script>

<script language="JAVASCRIPT">

    // Now load up the edit field values with the data loaded into the beans
    document.toolboxForm.name.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(toolboxUI.getName())%>";
    document.toolboxForm.description.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(toolboxUI.getDescription())%>";
    document.toolboxForm.enabled.checked = "<jsp:getProperty name='toolboxUI' property='enabled' />";
    document.toolboxForm.toolsAddList.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(toolboxUI.getToolsAddList())%>";
    var toolsAddList = "<%=MxHtmlUtil.encodeJScriptSafeEntities(toolboxUI.getToolsAddList())%>";
    if("<jsp:getProperty name='toolboxUI' property='enabled' />" == "YES")
    {
      document.toolboxForm.enabled.checked = true;
    }
    else
    {
      document.toolboxForm.enabled.checked = false;
    }

    // Set the toolbox
    if(toolsAddList != "")
    {
      setToolBox("<%=MxHtmlUtil.encodeJScriptSafeEntities(toolboxUI.getToolsAddList())%>");

      // Refresh the available tools to clear out any duplicates
      getNewToolsList();
    }

</script>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
<%  } // isMasterToolbox
%>
</html>
