<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil" %>

<jsp:useBean id="userUI" class="com.hp.mx.portal.settings.MxUserUI" scope="session" />
<jsp:useBean id="userTableModel" class="com.hp.mx.portal.settings.MxUserTableModel" scope="session" />
<jsp:useBean id="userSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    String errorFlag = request.getParameter("error");
    if (errorFlag == null)
    {
        errorFlag = "";
    }
    if ( ! errorFlag.equals("true") )
    {
        userUI.resetBean();
    }

    boolean isUserGroup = false; // Flag to specify if this is a user group
    boolean isGroupBased = false; // Flag to specify if this is a group-based user

    // Used later to store GUID;
    String userGUID  = "";
    int[] userIndex = userSelectionModel.getSelectedIndices();
    if (null != userIndex && userIndex.length > 0)
    {
        MxObjectID userID = userTableModel.getObjectID(userIndex[0]);
        isUserGroup = userTableModel.getIsUserGroup(userIndex[0]);
        isGroupBased = userTableModel.getIsGroupBased(userIndex[0]);
        userGUID = userID.getGUID().toString();
        userUI.LoadUser(loginBean, userID, isUserGroup);
    }
    rbsettings.init(loginBean, "MxSettings");

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag okButtonTag = new MxDefaultTag("okButton", rbsettings.getString("button.ok"), "");
    okButtonTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(okButtonTag);

    buttons.addMxTag(new MxDefaultTag("cancelButton", rbsettings.getString("button.cancel"), "cancelEdit()"));

    buttons.setMxTagSelectionId("okButton");

    // Used to make fields read-only for group-based user
    String gbReadOnly = "";
    if (isGroupBased)
        gbReadOnly = "disabled";
%>

<html>

<head>
<title></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_auth_modifyUser");

function resetScroll()
{
    window.parent.scrollTo(0,0);
}

function cancelEdit()
{
        resetScroll();
        parent.document.location.href="UserStart.jsp";
}

function checkName()
{
        if(document.userForm.name.value != "")
        {
            ourButtonManager.enableButtonById('okButton');
        }
        else
        {
            ourButtonManager.disableButtonById('okButton');
        }
}
function clearGroup()
{
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<% if (isGroupBased)
   { %>
<body>
<% } else { %>
<body onLoad="document.userForm.name.focus();">
<% } %>

<form method="POST" autocomplete="off" style="border:0px;padding:0px;margin:0px" name="userForm" action="UserServer.jsp">
  <hr>
    <table border="0" width="100%">
      <tr>
        <td align="left"><font class="subwindow-header">
            <%=isUserGroup?rbsettings.getString("user.editgrouptitle"):rbsettings.getString("user.edittitle")%>
        </font></td>
        <td align="right"><%=rbsettings.getString("lastmodified")%> <jsp:getProperty name='userUI' property='lastModified' /></td>
      </tr>
    </table>
<%
    if(errorFlag.equals("true"))
    {
        String errorCodeStr = request.getParameter("errorCode");
        String errorCodeMsg = userUI.getAddErrorMessageByCode(errorCodeStr,rbsettings);
        String errorMessage = userUI.getErrorMessage();

        if (errorMessage != null || errorCodeMsg != null)
        {
            out.println("<hr>");
            if (errorCodeMsg != null)
            {
                out.println("<center>");
                out.println("<font class='errorTextBold'>");
                out.println(errorCodeMsg);
                out.println("</font>");
                out.println("</center>");
            }
            if (errorMessage != null)
            {
                out.println("<center>");
                out.println("<font class='errorText'>");
                out.println(errorMessage);
                out.println("</font>");
                out.println("</center>");
            }
            out.println("<hr>");
        }
    }
%>
    <br>&nbsp;<span class="required_label"><%=rbsettings.getString("required")%>*</span>
    <br><br>
    <table border="0" width="100%">
<% if (isGroupBased)
   { %>
      <tr>
        <td><input class="input-field" type="checkbox" name="membergroups_cb" onclick="javascript:clearGroup();" checked="checked" ><%=rbsettings.getString("user.membergroups")%></td>
        <td><input disabled name="membergroups" type="text" size="50" ></td>
      </tr>
      <tr>
        <td colspan="2"><hr></td>
      </tr>
<% } %>
      <tr>
        <td><font class="input-field"><%=rbsettings.getString("user.name")%></font><span class="required">*</span></td>
        <td><input type="text" name="name" size="12" maxlength="32" onKeyup="checkName()" onBlur="checkName()" <%=gbReadOnly%> ></td>
      </tr>
<% if (userUI.showDomainName())
   { %>
      <tr>
        <td><font class="input-field"><%=rbsettings.getString("user.domain")%></font></td>
        <td><input type="text" name="domain" size="12" maxlength="32" <%=gbReadOnly%> ></td>
      </tr>
<% } %>
      <tr>
        <td><font class="input-field"><%=rbsettings.getString("user.fullname")%>&nbsp;</font>
        </td>
        <td><input type="text" name="fullname" size="50" <%=gbReadOnly%> >
        </td>
      </tr>
<% if (!isUserGroup && !isGroupBased)
   { %>
      <tr>
        <td><font class="input-field"><%=rbsettings.getString("user.phone")%>&nbsp;</font>
        </td>
        <td>
        <input type="text" name="phone" size="20">
        </td>
      </tr>
      <tr>
        <td><font class="input-field"><%=rbsettings.getString("user.email")%>&nbsp;</font>
        </td>
        <td><input type="text" name="email" size="50">
        </td>
      </tr>
<% } %>
    </table>

<hr>
<font class="input-field"><%=rbsettings.getString("user.priv.label")%></font><span class="required">*</span>
<table border="0" width="100%" cellpadding=0>
  <tr>
    <td align="left">
      <input type="radio" name="privilege" value="full" <%=gbReadOnly%> >
        <%=rbsettings.getString("user.priv.full.label")%> </td>
  </tr>
  <tr>
    <td>
      <input type="radio" name="privilege" value="limited" <%=gbReadOnly%> >
        <%=rbsettings.getString("user.priv.limited.label")%> </td>
    <td>
    </td>
  </tr>
  <tr>
    <td>
      <input type="radio" name="privilege" value="none" checked <%=gbReadOnly%> >
        <%=rbsettings.getString("user.priv.none.label")%> </td>
    <td>
    </td>
  </tr>
</table>

<hr>
<font class="subwindow-header"><%=rbsettings.getString("user.iprestrict.label")%></font>
<br><br>
<%=rbsettings.getString("user.iprestrict.hint")%>
<br><br>
<table border="0" width="100%" cellpadding=0>
  <tr>
    <td align="left"><font class="input-field"><%=rbsettings.getString("user.iprestrict.include")%>&nbsp;</font>&nbsp;</td>
    <td align="left"><font class="input-field"><%=rbsettings.getString("user.iprestrict.exclude")%>&nbsp;</font></td>
  </tr>
  <tr>
    <td align="left"><textarea name='iplogininclusion' cols='30' rows='3' <%=gbReadOnly%> ></textarea></td>
    <td align="left"><textarea name='iploginexclusion' cols='30' rows='3' <%=gbReadOnly%> ></textarea></td>
  </tr>
</table>
<% if (!isUserGroup && !isGroupBased && userUI.showPagerInfo())
   { %>
<hr>
<font class="subwindow-header"><%=rbsettings.getString("user.pager.label")%>&nbsp;</font>
<br><br>
<table border="0" width="100%" cellpadding=0>
  <tr>
    <td><font class="input-field"><%=rbsettings.getString("user.pager.phone")%>&nbsp;</font>
    </td>
    <td><input type="text" name="pagerphonenumber" size="20">
    </td>
  </tr>
  <tr>
    <td><font class="input-field"><%=rbsettings.getString("user.pager.pin")%>&nbsp;</font>
    </td>
    <td><input type="text" name="pagerpinnumber" size="20">
    </td>
  </tr>
  <tr>
    <td><font class="input-field"><%=rbsettings.getString("user.pager.msglen")%>&nbsp;</font>
    </td>
    <td>
    <select size="1" name="pagermsglength">
      <% userUI.ListPagerMsgLengths(loginBean, out, rbsettings.getBundle());%>
    </select>
    </td>
  </tr>
  <tr>
    <td><font class="input-field"><%=rbsettings.getString("user.pager.baudrate")%>&nbsp;</font>
    </td>
    <td>
    <select size="1" name="pagerbaudrate">
      <% userUI.ListPagerBaudRates(loginBean, out, rbsettings.getBundle());%>
    </select>
    </td>
  </tr>
  <tr>
    <td><font class="input-field"><%=rbsettings.getString("user.pager.dataformat")%>&nbsp;</font>
    </td>
    <td>
    <select size="1" name="pagerdataformat">
      <% userUI.ListPagerDataFormats(loginBean, out, rbsettings.getBundle());%>
    </select>
    </td>
  </tr>
</table>
<% } %>

  <hr>

<% if (isUserGroup) { %>
<input type="hidden" name="command" value="editusergroup">
<% } else if (isGroupBased) { %>
<input type="hidden" name="command" value="editgroupbased">
<% } else { %>
<input type="hidden" name="command" value="edit">
<% } %>

<input type="hidden" name="UserGUID" value=<%=userGUID %>>

<div style="margin-top:15px">
<% buttons.dumpButtons(out); %>
</div>

</form>

<script language="JAVASCRIPT">

    // Now load up the edit field values with the data loaded into the beans
    document.userForm.name.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(userUI.getName())%>";
<% if (isGroupBased)
   { %>
    document.userForm.membergroups.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(userUI.getMemberGroups())%>";
<% } %>
<% if (userUI.showDomainName())
   { %>
    document.userForm.domain.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(userUI.getDomain())%>";
<% } %>
    document.userForm.fullname.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(userUI.getFullname())%>";
<% if (!isUserGroup && !isGroupBased)
   { %>
    document.userForm.phone.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(userUI.getPhone())%>";
    document.userForm.email.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(userUI.getEmail())%>";
<% } %>
    var privilege = "<jsp:getProperty name='userUI' property='privilege' />";
    if( privilege == "full" )
    {
        document.userForm.privilege[0].checked = true;
        document.userForm.privilege[1].checked = false;
        document.userForm.privilege[2].checked = false;
    }
    else if( privilege == "limited" )
    {
        document.userForm.privilege[0].checked = false;
        document.userForm.privilege[1].checked = true;
        document.userForm.privilege[2].checked = false;
    }
    else if( privilege == "none" )
    {
        document.userForm.privilege[0].checked = false;
        document.userForm.privilege[1].checked = false;
        document.userForm.privilege[2].checked = true;
    }
    else
    {
        document.userForm.privilege[0].checked = false;
        document.userForm.privilege[1].checked = false;
        document.userForm.privilege[2].checked = false;
        document.userForm.privilege[0].disabled = true;
        document.userForm.privilege[1].disabled = true;
        document.userForm.privilege[2].disabled = true;
    }
    document.userForm.iplogininclusion.value = "<%=userUI.escapeNewlines(MxHtmlUtil.encodeJScriptSafeEntities(userUI.getIpLoginInclusionRange()))%>";
    document.userForm.iploginexclusion.value = "<%=userUI.escapeNewlines(MxHtmlUtil.encodeJScriptSafeEntities(userUI.getIpLoginExclusionRange()))%>";
<% if (!isUserGroup && !isGroupBased && userUI.showPagerInfo())
   { %>
    document.userForm.pagerphonenumber.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(userUI.getPagerPhoneNumber())%>";
    document.userForm.pagerpinnumber.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(userUI.getPagerPinNumber())%>";
<% } %>

</script>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
