<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="authUI" class="com.hp.mx.portal.settings.MxAuthUI" scope="session" />
<jsp:useBean id="authReportTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="authReportTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="authTableReportController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="authReportSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_AUTHORIZATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    String printable = request.getParameter("printable");

    rbsettings.init(loginBean, "MxSettings");
%>
<%
    if ( authTableReportController.isFirstTime() )
    {
        authReportTableView.setId("ID_AUTH_REPORT_TABLE");
        authReportTableView.setUrlHandler(request.getRequestURI());
        authTableReportController.setTableModelWithSorting(authReportTableModel);
        // authTableReportController.setSelectionModel(authReportSelectionModel);
        authTableReportController.setTableView(authReportTableView);
    }
    if ( authTableReportController.checkUrlForControllerMessages(request, out) )
    {
        return;
    }
    // Get the date and time when report is generated.
    MxDateAndTime currentTime = new MxDateAndTime( loginBean.getLocale(),
                                                   loginBean.getTimeZone()
                                                 );
    String currentTimeOfDay = currentTime.getCurrentDateTimeFormatString(
                                          MxDateAndTime.DATE_TIME_FULL_FORMAT);
    // Load the table
    authReportTableModel.setAddUrlHref(false);
    authReportTableModel.loadAllAuths(loginBean,rbsettings);
    MxTableSortingModel sortable = authTableReportController.getSortingModelOrNull();
    if (null != sortable)
    {
        // Sort on the users (first column)
        sortable.sortTable(0,true);
    }

    if (printable == null)
    {
        authReportTableView.setHeight("150px");
        authReportTableView.setWidth("600px");
    }
    else
    {
        authReportTableView.setHeight(null);
        authReportTableView.setWidth(null);
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("B6", rbsettings.getString("button.viewprintable") + "...", "openPrintable()"));
%>

<html>

<head>
<title><%=rbsettings.getString("auth.reporttitle")%></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_auth_reportAuth");

function openPrintable()
{
    var url;
    url = "ReportAuth.jsp?printable=yes";
    reportWindow = window.open(url, "authReportWindow", "menubar=1, titlebar=1, toolbar=1, scrollbars=1, resizable=1");
    reportWindow.focus();
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% authReportTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body>

<form method="POST" action="AuthServer.jsp" name="authForm">
<%  if(printable == null)
    {
%>
    <hr>
    <table border="0" width="100%" cellpadding=0>
<%
    }
    else
    {
%>
    <table border="0" cellpadding=0>
    <tr><td align="right">
        &nbsp;<br><br>
    </td></tr>
<%
    }
%>
    <tr>
    <td><font class="subwindow-header"><%=rbsettings.getString("auth.reporttitle")%>
<%  if(printable != null)
    {
%>
        <%=rbsettings.getString("auth.reportforallauths")%>
<%
    }
%>
    </font></td>

<%  if(printable != null)
    {
%>
    </tr><tr><td align="left"><br>
<%
    }
    else
    {
%>
    <td align="right">
<%
    }
    out.print( "<font class='section-header'>" );
    out.print( rbsettings.getString("auth.report.asof") );
    out.print( "</font> " );
    out.println( currentTimeOfDay );
%>
    </td>
    </tr>
    </table>
    <br>
<%  if (authReportTableModel.getRowCount() > 0)
    {
%>
    <div id="reportTable">
    <% authReportTableView.dumpTableVisiblePart(out); %>
    </div>
<%  }
    else
    {
%>
    <div id="reportTable" align="center" style="width=600px;height=150px">
    <br><br><br><b><%=rbsettings.getString("auth.no.auths.configured")%></b><br>
    </div>
<%  }

    if(printable == null)
    {
%>
    <hr>
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
<%
    }
%>

</form>

<% authReportTableView.dumpTableHiddenPart(out); %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
