<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="groupUI" class="com.hp.mx.portal.settings.MxGroupUI" scope="session" />
<jsp:useBean id="groupReportTableModel" class="com.hp.mx.portal.settings.MxNodeGroupTableModel" scope="session" />
<jsp:useBean id="groupReportTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="groupTableReportController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="groupReportSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_GROUP_MODIFICATION_PRIVILEGE))
    { %>
       <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    String printable = request.getParameter("printable");
    rbsettings.init(loginBean, "MxSettings");
%>
<%
    if ( groupTableReportController.isFirstTime() )
    {
        groupReportTableView.setId("ID_GROUP_REPORT_TABLE");
        groupReportTableView.setUrlHandler(request.getRequestURI());
        groupTableReportController.setTableModelWithSorting(groupReportTableModel);
        groupTableReportController.setTableView(groupReportTableView);
    }
    if ( groupTableReportController.checkUrlForControllerMessages(request, out) )
    {
        return;
    }
    // Get the date and time when report is generated.
    MxDateAndTime currentTime = new MxDateAndTime( loginBean.getLocale(),
                                                   loginBean.getTimeZone()
                                                 );
    String currentTimeOfDay = currentTime.getCurrentDateTimeFormatString(
                                          MxDateAndTime.DATE_TIME_FULL_FORMAT);
    // Load the table
    groupReportTableModel.setShowMembers(true);
    groupReportTableModel.loadAllNodeGroups(loginBean,rbsettings);
    MxTableSortingModel sortable = groupTableReportController.getSortingModelOrNull();
    if (null != sortable)
    {
        // Sort on the group name (first column)
        sortable.sortTable(0,true);
    }

    if (printable == null)
    {
        groupReportTableView.setHeight("150px");
        groupReportTableView.setWidth("600px");
    }
    else
    {
        groupReportTableView.setHeight(null);
        groupReportTableView.setWidth(null);
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("B6", rbsettings.getString("button.viewprintable") + "...", "openPrintable()"));
%>
<html>

<head>
<title><%=rbsettings.getString("group.reporttitle")%></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_auth_reportGroup");

function openPrintable()
{
    reportWindow = window.open("ReportGroup.jsp?printable=yes", "groupReportWindow", "menubar=1, titlebar=1, toolbar=1, scrollbars=1, resizable=1");
    reportWindow.focus();
}
</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% groupReportTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body>
<%  if (printable == null)
    {
%>
  <hr>
  <table border="0" width="100%" cellpadding=0>
<%
    }
    else
    {
%>
  <table border="0" cellpadding=0>
  <tr><td align="right">
      &nbsp;<br><br>
  </td></tr>
<%
    }
%>

  <tr>
  <td align="left">
    <font class="subwindow-header"><%=rbsettings.getString("group.reporttitle")%></font>
  </td>
<%  if (printable != null)
    {
%>
    </tr><tr><td align="left"><br>
<%
    }
    else
    {
%>
    <td align="right">
<%
    }
    out.print( "<font class='section-header'>" );
    out.print( rbsettings.getString("datetime") );
    out.print( "</font> " );
    out.println( currentTimeOfDay );
%>
  </td>
  </tr>
  <tr>
<%  if (printable == null)
    {
%>
      <td colspan="2"><br>
<%  }
    else
    {
%>
      <td><br>
<%  }
      groupReportTableView.dumpTableVisiblePart(out);
%>
      <br></td></tr>
      </table>
<%  if (printable == null)
    {
%>
    <hr>
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
<%
    }
%>
<% groupReportTableView.dumpTableHiddenPart(out); %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
