<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="userUI" class="com.hp.mx.portal.settings.MxUserUI" scope="session" />
<jsp:useBean id="userReportTableModel" class="com.hp.mx.portal.settings.MxUserTableModel" scope="session" />
<jsp:useBean id="userReportTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="userTableReportController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="userReportSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    String printable = request.getParameter("printable");

    rbsettings.init(loginBean, "MxSettings");
%>
<%
    if ( userTableReportController.isFirstTime() )
    {
        userReportTableView.setId("ID_USER_REPORT_TABLE");
        userReportTableView.setUrlHandler(request.getRequestURI());
        userTableReportController.setTableModelWithSorting(userReportTableModel);
        userTableReportController.setTableView(userReportTableView);
    }
    if ( userTableReportController.checkUrlForControllerMessages(request, out) )
    {
        return;
    }
    // Get the date and time when report is generated.
    MxDateAndTime currentTime = new MxDateAndTime( loginBean.getLocale(),
                                                   loginBean.getTimeZone()
                                                 );
    String currentTimeOfDay = currentTime.getCurrentDateTimeFormatString(
                                          MxDateAndTime.DATE_TIME_FULL_FORMAT);
    // Load the table
    userReportTableModel.setShowPagerInfo(userUI.showPagerInfo());
    userReportTableModel.loadAllUsers(loginBean,rbsettings);
    MxTableSortingModel sortable = userTableReportController.getSortingModelOrNull();
    if (null != sortable)
    {
        // Sort on the user name (first column)
        sortable.sortTable(0,true);
    }

    if (printable == null)
    {
        userReportTableView.setHeight("150px");
        userReportTableView.setWidth("600px");
    }
    else
    {
        userReportTableView.setHeight(null);
        userReportTableView.setWidth(null);
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("B6", rbsettings.getString("button.viewprintable") + "...", "openPrintable()"));
%>
<html>

<head>
<title><%=rbsettings.getString("user.reporttitle")%></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_auth_reportUser");

function openPrintable()
{
    reportWindow = window.open("ReportUser.jsp?printable=yes", "userReportWindow", "menubar=1, titlebar=1, toolbar=1, scrollbars=1, resizable=1");
    reportWindow.focus();
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% userReportTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body>

<form method="POST" action="UserServer.jsp">
<%  if (printable == null)
    {
%>
  <hr>
  <table border="0" width="100%" cellpadding=0>
<%
    }
    else
    {
%>
<table border="0" cellpadding=0>
  <tr><td align="right">
      &nbsp;<br><br>
  </td></tr>
<%
    }
%>
  <tr>
  <td align="left">
    <font class="subwindow-header"><%=rbsettings.getString("user.reporttitle")%></font>
  </td>
<%  if (printable != null)
    {
%>
    </tr>
    <tr><td align="left"><br>
<%
    }
    else
    {
%>
    <td align="right">
<%
    }
    out.print( "<font class='section-header'>" );
    out.print( rbsettings.getString("user.report.asof") );
    out.print( "</font> " );
    out.println( currentTimeOfDay );
%>
  </td>
  </tr>
  <tr>
<%  if (printable == null)
    {
%>
      <td colspan="2"><br>
<%  }
    else
    {
%>
      <td><br>
<%  }
      userReportTableView.dumpTableVisiblePart(out);
%>
      <br></td></tr>
      </table>
<%  if (printable == null)
    {
%>
    <hr>
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
<%
    }
%>

<input type="hidden" name="command" value="report">
</form>
<% userReportTableView.dumpTableHiddenPart(out); %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
