<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="userUI" class="com.hp.mx.portal.settings.MxUserUI" scope="session" />
<jsp:useBean id="userTableModel" class="com.hp.mx.portal.settings.MxUserTableModel" scope="session" />
<jsp:useBean id="userSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    rbsettings.init(loginBean, "MxSettings");
%>
<html>

<head>
<title>Required Field</title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>

<body>

<!-- Similar deleteForm in UserStart.jsp which first does the confirmation check -->
<form method="POST" action="UserServer.jsp" target="UserSpace" name="deleteNowForm">
    <input type="hidden" name="command" value="deletenow">
</form>


<%
    String cmd = new String(request.getParameter("command"));
    int doAddRet = 0;
    int doEditRet = 0;

    // If the apply button was pushed from the add page,
    // load up the field values using the node bean properties
    // and reload the page
    // If there is an edit error, tell the start page to reload
    // the edit page
    String applyFlag = request.getParameter("apply");

    //System.out.println("UserServer.jsp: command=" + cmd + "; apply=" + applyFlag);

    boolean editErr       = false;
    boolean addErr        = false;
    boolean isUserGroup   = false;
    boolean isGroupBased  = false;

    if (cmd.startsWith("add"))
    {
        if (cmd.equals("addgroup"))
            isUserGroup = true;

        // Call Add user
        doAddRet = userUI.DoAddUser(loginBean, request, rbsettings.getBundle(), isUserGroup);
        if(doAddRet != 0)
        {
            addErr = true;
        }
    }
    if (cmd.startsWith("edit"))
    {
        if (cmd.equals("editusergroup"))
            isUserGroup = true;
        if (cmd.equals("editgroupbased"))
            isGroupBased = true;

        // Call Edit user
        doEditRet = userUI.DoEditUser(loginBean, request, isUserGroup, isGroupBased);
        if(doEditRet != 0)
        {
            editErr = true;
        }
        else
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.editok")%>");
            </script>
<%      }
    }
    if (cmd.startsWith("delete"))
    {
        int doDeleteRet = 0;
        int doConfirmDeleteRet = 0;
        String doConfirmMsg = null;
        if ( !cmd.equals("deletenow") )
        {
            // Check if deleting any user groups that would delete any unselected users.
            doConfirmDeleteRet = userUI.DoConfirmDeleteUsers( loginBean, userSelectionModel, userTableModel);
        }

        if ( doConfirmDeleteRet == 0 )
        {
            // No secondary group-based users to delete, or we got the "deletenow" command
            // meaning we've previously done the confirmation... delete the selected users.
            doDeleteRet = userUI.DoDeleteUsers(loginBean, userSelectionModel, userTableModel);
        }
        else if (doConfirmDeleteRet == 1)
        {
            // Confirm with the user to delete unselected group-based users as a result
            // of deleting selected user groups.
%>
            <script language="JAVASCRIPT">
            if (confirm("<%=rbsettings.getString("usergroup.delete.groupbased")+userUI.getErrorMessage(false)%>"))
            {
                document.deleteNowForm.submit();
            }
            </script>
<%
            return; // Stop processing page - do NOT load UserStart.jsp
        }

        if(doDeleteRet == 1)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.deleteerr")%>");
            </script>
<%      }
        else if(doDeleteRet == 2)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.deletelasterr")%>");
            </script>
<%      }
        else if(doDeleteRet == 3)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.invaliderr")%>");
            </script>
<%      }
        else if(doDeleteRet == 4)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.delete.self.err")%>");
            </script>
<%      }
        else if(doDeleteRet == 5)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("usergroup.delete.self.err")%>");
            </script>
<%      }
        else if(doDeleteRet == 6)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("usergroup.delete.modifylasterr")%>");
            </script>
<%      }
        else
        {
%>
            <script language="JAVASCRIPT">
            MxPortalRefreshNavigationArea();
            </script>
<%      }
    }

    // Group flags
    String userGroupParam = "";
    String groupBasedParam = "";
    if (isUserGroup)
        userGroupParam = "usergroup=true&";
    if (isGroupBased)
        groupBasedParam = "groupbased=true&";

    if(addErr)
    {
%>
        <script language="JAVASCRIPT">
            document.location.href = "AddUser.jsp?<%=userGroupParam%>error=true&errorCode=<%=doAddRet%>&apply=true";
        </script>
<%  }
    else if(applyFlag != null && applyFlag.equals("true"))
    {
%>
        <jsp:setProperty name="userUI" property="*" />
        <script language="JAVASCRIPT">
            parent.document.location.href = "UserStart.jsp?<%=userGroupParam%>apply=true";
        </script>
<%
    }
    else if(editErr)
    {
%>
        <script language="JAVASCRIPT">
            document.location.href = "EditUser.jsp?<%=userGroupParam%>error=true&errorCode=<%=doEditRet%>";
        </script>
<%  }
    else
    {
        userUI.resetBean();
%>
        <script language="JAVASCRIPT">
            parent.document.location.href = "UserStart.jsp";
        </script>
<%  }
%>

</body>

</html>
