<%@ page
    import="java.lang.String,
            javax.swing.tree.TreeModel,
            javax.swing.tree.DefaultTreeModel,
            javax.swing.tree.DefaultMutableTreeNode,
            com.hp.mx.core.querymanager.components.SWTreeEventData,
            com.hp.mx.portal.ui.MxBean"
%>

<jsp:useBean id="vcRepositoryBean" class="com.hp.mx.portal.settings.VCRepositorySetup" scope="session"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="vcTreeView" class="com.hp.mx.html.tree.MxTreeView" scope="session" />
<jsp:useBean id="vcExpansionModel" class="com.hp.mx.html.tree.MxDefaultTreeExpansionModel" scope="session" />
<jsp:useBean id="vcController" class="com.hp.mx.html.tree.MxTreeController" scope="session" />
<jsp:useBean id="rbvcrsetup" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);

    // set up the resource file
    rbvcrsetup.init(loginBean, "VCRepositorySetup");

    TreeModel myTreeModel = null;

    if (vcController.checkUrlForControllerMessages(request, out)) return;

    boolean error = false;
    String errorStr = "";

    int treeType = 0;
    String param1 = request.getParameter("treeType");
    if (param1 != null)
        treeType = Integer.parseInt(param1);

    // Set up the tree for the first time
    if (vcController.isFirstTime())
    {
        vcTreeView.setId("ID_MY_CATALOG_TREE");
        vcTreeView.setUrlHandler(request.getRequestURI());

        vcController.setExpansionModel(vcExpansionModel);
        vcController.setTreeView(vcTreeView);

        vcController.expandPathToId("ID_PREOPEN");
    }


    // Get the tree data
    SWTreeEventData treeData = vcRepositoryBean.getSelectedRepository(treeType);
    if (treeData != null)
    {
        DefaultMutableTreeNode root = treeData.getRoot();


        if (root != null)
        {
            myTreeModel = new DefaultTreeModel(treeData.getRoot());
            vcController.setTreeModel(myTreeModel);
        }
        else
        {
            // Not a valid catalog tree, find the error
            int opStat = treeData.getOpStat();
            error = true;
            errorStr = rbvcrsetup.getString("retrieve.generalerror");
        }
    }
    else
    {
        // This should never happen
        error = true;
        errorStr = rbvcrsetup.getString("retrieve.generalerror");
    }
%>

<HTML>
    <HEAD>
    <% vcTreeView.dumpHeadContent(out); %>
    </HEAD>

    <BODY>

    <%
    // Display the error, if there was one
    if (error)
    {
        error = false;
        out.println("<font class='errorTextBold'>");
        out.println("<br>"+ errorStr);
        out.println("</font>");
        out.println("<script>parent.disableOKButton(true)</script>"); // disable the OK button
        return;
    }
    %>

    <%
    if (myTreeModel != null)
    {
    %>
        <div align=right>
        <%
        vcTreeView.dumpExpansionButtons(out);
        %>
        </div>
        <%
        vcTreeView.dumpTree(out);
        out.println("<script>parent.disableOKButton(false)</script>"); // enable the OK button
    }
    %>

    </BODY>
</HTML>
