<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.controllers.VCRepositoryController" %>
<%@ page import="com.hp.mx.core.controllers.MxNodeController" %>
<%@ page import="com.hp.mx.core.nodemanager.MxNode" %>
<%@ page import="com.hp.mx.exceptions.MxException" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.security.DetermineTrustStatus" %>
<%@ page import="javax.swing.table.AbstractTableModel"%>

<jsp:useBean id="pspSelectionModelRepositories" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="vcrTableViewRepositories" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="vcrControllerRepositories" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="rbvcrsetup" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="vcRepositoryBean" class="com.hp.mx.portal.settings.VCRepositorySetup" scope="session"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // do we need to abort?
    if (vcrControllerRepositories.checkUrlForControllerMessages(request, out)) return;

    int numDevs = 0;

    // set up the resource file
    rbvcrsetup.init(loginBean, "VCRepositorySetup");
    rbvcrsetup.setUserAgent(request);

    // this will only happen if we're re-entering this page after the user
    // hits the Last Update button
    String rowToUpdate = request.getParameter("rowToUpdate");
    int onEnterSelectedDeviceKey = 0;
    if (rowToUpdate != null && !rowToUpdate.equals(""))
    {
        onEnterSelectedDeviceKey = vcRepositoryBean.getSelectedDeviceKey();
        MxNode dev = null;
        try
        {
            dev = MxNodeController.getDefaultControllerNoEx().getNodeByKey(onEnterSelectedDeviceKey);
        }
        catch (MxException ex)
        {
            dev = null;
        }
        if (dev != null)
        {
            DetermineTrustStatus.makeTrustRequest(dev);
            vcRepositoryBean.forceRepositoryUpdate(onEnterSelectedDeviceKey);
        }
    }

    // we can initialize VCRepositorySetup
    int result = vcRepositoryBean.initialize(loginBean);

    if (result == 0)
    {
        // setup the display of the Repository Setup table model
        if (vcrControllerRepositories.isFirstTime())
        {
            pspSelectionModelRepositories.setSelectionMode(MxTableSelectionModel.SINGLE_SELECTION);
            vcrTableViewRepositories.setId("ID_MY_REPO_SETUP_TABLE");
            vcrTableViewRepositories.setHeight("105");
            vcrTableViewRepositories.setOnSelectionChange("mySelectionChanged");
            vcrTableViewRepositories.setUrlHandler(request.getRequestURI());
        }

        AbstractTableModel tableModel = vcRepositoryBean.getVCRDevsTableModel();
        vcrControllerRepositories.setTableModelWithSorting(tableModel);
        vcrControllerRepositories.setSelectionModel(pspSelectionModelRepositories);
        vcrControllerRepositories.setTableView(vcrTableViewRepositories);
    }

    numDevs     = vcRepositoryBean.getNumDevs();
    MxDateAndTime curTime = new MxDateAndTime(loginBean.getLocale(), loginBean.getTimeZone());

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag okButtonTag = new MxDefaultTag("okButton", rbvcrsetup.getString("button.ok"), "saveSelection()");
    okButtonTag.setAttr(MxTag.DISABLED, "true");
    buttons.addMxTag(okButtonTag);
%>

<html>
    <head>
        <title><%= rbvcrsetup.getString("page.title") %></title>
        <link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>
        <link href='<%= MxOptions.URL_BASE %>/taskandjob/css/taskAndJob.css' rel='stylesheet' type='text/css'>

        <STYLE TYPE="text/css">
        <!--
            .indented{margin-left:12px;}
        -->
        </STYLE>

        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
        <script language='javascript' type='text/javascript' src='../taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='js/VCRepositorySetup.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript'> MxPortalWorkspaceSetHelpTopic("admin_vcrm");</script>

        <SCRIPT src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></SCRIPT>

        <script language='javascript' type='text/javascript'>

        var treeType = <%=VCRepositoryController.SWTREE_VERSION_LEAVES + VCRepositoryController.SWTREE_TAG_NODES%>;

            function loadPage()
            {
                myResize();
                if (MxTableIsPresent('ID_MY_REPO_SETUP_TABLE'))
                    getSelectedCatalog();
            }

            // resize the MxTable to be flush with the right browser edge
            function myResize()
            {
                var w = Math.max(0, MxBrowserGetBodyWidth(-NETSCAPE_SCROLLBAR_WIDTH, 0));
                if (w > 600)
                    w = 600;
                else
                    w = Math.max(0, w - 10);

                if (MxTableIsPresent('ID_MY_REPO_SETUP_TABLE'))
                    MxTableSetWidth('ID_MY_REPO_SETUP_TABLE', w);
            }

            //
            // the function called when the selection changes on the <table>
            //
            var selectedRow = 0;

            //
            // the function called to change the name of the repos on this page
            //
            function setRepName(reposname)
            {
                var el = document.getElementById("repname");
                el.innerHTML = reposname;
            }

            //
            // enable or disable the OK button
            //
            function disableOKButton(flag)
            {
                if (!flag)
                    ourButtonManager.enableButtonById('okButton');
                else
                    ourButtonManager.disableButtonById('okButton');
            }

            //
            // the function called to perform selection change, including
            // retrieval of new repository catalog
            //
            function mySelectionChanged(szIdTable, iRow, bSelected)
            {
                // retrieve the catalog for the newly selected row
                selectedRow = iRow;
                disableOKButton(true);
                getSelectedCatalog();
            }

            //
            // user has selected an item from the tree
            //
            function treeSelectionChanged(count)
            {
            }

            //
            // the function called to save off the repository as default
            //
            function saveSelection()
            {
                // save current selection to CMS
                var iframe = document.getElementById("catalogtree");
                iframe.contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/taskandjob/UpdateSystemSoftware/LoadingCatalogWait.jsp?saving=1");

                var iframe = document.getElementById("action");
                iframe.contentWindow.document.location.replace("VCRepositorySaveRow.jsp?iRow=" + selectedRow);
            }

            //
            // attempt to save repository has completed
            //
            function saveComplete(status)
            {
                var iframe = document.getElementById("catalogtree");
                if (status == <%= VCRepositoryController.REPOSITORY_SAVE_SUCCESS %>)
                {
                    iframe.contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/taskandjob/UpdateSystemSoftware/LoadingCatalogWait.jsp?saving=2");
                }
                else
                {
                    iframe.contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/taskandjob/UpdateSystemSoftware/LoadingCatalogWait.jsp?saving=3");
                }
            }

            //
            // the function called to get the currently selected catalog
            //
            function getSelectedCatalog()
            {
                var iframe = document.getElementById("catalogtree");
                iframe.contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/taskandjob/UpdateSystemSoftware/LoadingCatalogWait.jsp");

                var iframe = document.getElementById("action");
                var url = "<%=MxOptions.URL_BASE%>/taskandjob/InitialPSPInstall/RetrieveCatalog.jsp?treeType="+treeType;
                iframe.contentWindow.document.location.replace(url);
            }

            //
            // Update display with new catalog. This function is called
            // by the Javascript that retrieves the catalog
            //
            function drawNewCatalog(status)
            {
                var iframe = document.getElementById("catalogtree");
                iframe.contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/settings/VCRepositoryCatalogFrame.jsp?treeHeight=190&treeType="+treeType);

                if (status == 0)
                    disableOKButton(false);
                else
                    disableOKButton(true);
            }

        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% vcrTableViewRepositories.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body class="tools-body" onLoad='loadPage()' onResize='myResize()'">

    <%
    int index = 0;
    if (rowToUpdate != null && !rowToUpdate.equals(""))
        index = vcRepositoryBean.getIndexFromDeviceKey(onEnterSelectedDeviceKey);
    else
        index = vcRepositoryBean.getDefaultSelectRowIndex();

    if (numDevs > 0)
    {
    %>
        <!-- <table> to display repository devices -->
        <%= rbvcrsetup.getString("table.instructions") %><br><br>
        <div class="indented">
            <table border='0' cellpadding='0' cellspacing='0' style='width:600'>
                <tr>
                    <td id='totalDevs' style='width:50%' align='left' nowrap>
                        <a href="javascript:location.replace(location.href+'?rowToUpdate='+selectedRow)" title="<%= rbvcrsetup.getString("table.lastRefreshToolTip") %>"><%= rbvcrsetup.getString("table.lastRefresh") %></a>
                        <%= curTime.getCurrentDateTimeStringSIMFormat() %>
                    </td>
                </tr>
            </table>
            <%
            vcRepositoryBean.selectRepositoryDeviceRow(index);
            pspSelectionModelRepositories.setSelectedIndex(index, true);
            vcrTableViewRepositories.dumpWholeTable(out);
            %>
        </div>
            <br><% buttons.dumpButtons(out); %>
        <!-- hidden <iframe> for retrieving repository -->
        <hr>
        <font class='mx-subheader-nosep'><%= rbvcrsetup.getString("tree.header") %>&nbsp;<span id="repname"></span></font>

        <div class="indented">
        <iframe id='action' name='action' style='display:none; width:100%; height:100'
                scrolling='no' marginwidth='0' frameborder='1' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        </div>

        <!-- <iframe> for catalog tree -->
        <iframe id='catalogtree' name='catalogtree' style='width:100%; height:220;padding-top:10px'
              scrolling='no' marginwidth='12' frameborder='0' src='<%=MxOptions.URL_BASE%>/taskandjob/UpdateSystemSoftware/LoadingCatalogWait.jsp'>
        </iframe>

    <%
    }
    else
    {
        out.println("<span class='errorTextBold'>");
        out.println(rbvcrsetup.getString("error.noRepository1"));
        out.println("</span>");
        out.println("<br><br>");
        out.println("<span>");
        out.println(rbvcrsetup.getString("error.noRepository2"));
        out.println("</span>");
    }
    %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>
</html>
