<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="java.util.*"%>
<%@ page import="com.hp.mx.utilities.MxCMS" %>
<%@ page import="com.hp.mx.core.taskmanager.*" %>
<%@ page import="java.util.Calendar"%>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime"%>

<jsp:useBean id="ftwUIbean" scope="session" class="com.hp.mx.portal.settings.FirstTimeWizardUIBean" />
<jsp:useBean id="ftwProtoSettings" class="com.hp.mx.portal.settings.ProtocolSettingsBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="ftwAutoDiscoveryBean" class="com.hp.mx.portal.discovery.AutoDiscoveryBean" scope="session" />

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    ftwUIbean.getResBundles(loginBean);

    Calendar cal = Calendar.getInstance(loginBean.getTimeZone(), loginBean.getLocale());

    MxDateAndTime dateAndTime = new MxDateAndTime(loginBean.getLocale(),
                                                  loginBean.getTimeZone(),
                                                  cal.getTime());

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    MxTag btnBackTag = new MxDefaultTag("btnBack", ftwUIbean.getResString("BUTTON_PREV_LABEL"), "prevPage()");
    MxTag btnNextTag = new MxDefaultTag("btnNext", ftwUIbean.getResString("BUTTON_NEXT_LABEL"), "nextPage()");
    buttons.addMxTag(btnBackTag);
    buttons.addMxTag(btnNextTag);

    //setting the mode to "ftw" will prevent processPost() from saving the discoveryData bean.
    String mode = "ftw";

    String referer = request.getHeader("referer");

    if (referer.indexOf(ftwUIbean.getResString("SNMP_PAGE_URL")) != -1)
    {
        //clear all snmp variables
        ftwProtoSettings.clearSnmpDefaults();
    }
%>

<HTML>
<HEAD>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <TITLE>
        <%=ftwUIbean.getResString("DISCOVERY_LABEL")%>
    </TITLE>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>

    <script language='JavaScript' type='text/javascript'>

    function isIPChecked()
    {
        if(document.ConfigForm.discoveryEnabledCheckBox.checked == true &&
           document.ConfigForm.ipCheckbox.checked == true &&
           document.ConfigForm.inclusionTextBox.value == "")
        {
            alert("<%= ftwAutoDiscoveryBean.getResourceString("auto.page.error.inclusion.missing")%>");
            return false;
        }
        else
            return true;
    }

    function validateAll()
    {
        if ( validateIP() == false)
        {
            return false;
        }
        if (isIPChecked() == false )
        {
            return false;
        }
        if (validateInterval() == false)
        {
            return false;
        }
        if (validateDOM() == false)
        {
            return false;
        }
        return true;
    }

    function validateInterval()
    {
        if (document.ConfigForm.discoveryEnabledCheckBox.checked == true)
        {
             if (document.ConfigForm.intervalType.value == <%= ScheduleIntervals.INTERVAL_MINUTES %>  &&
                 document.ConfigForm.interval.value < 15)
             {
                 alert ("<%= ftwAutoDiscoveryBean.getResourceString("auto.page.error.intervalTooSmall")%>");
                 return false;
             }
             if (document.ConfigForm.interval.value  < 1)
             {
                 alert(" <%=ftwAutoDiscoveryBean.getResourceString("auto.page.error.intervalgtzero")%>" );
                 hilite( document.ConfigForm.interval );
                 return false;
             }
             return validateNumFieldConfig(document.ConfigForm.interval,  '<%=ftwAutoDiscoveryBean.getResourceString("auto.page.error.interval")%>' );
        }
        return true;
    }

    function validateDOM()
    {
        if (document.ConfigForm.discoveryEnabledCheckBox.checked == true &&
            document.ConfigForm.intervalType.value == <%= ScheduleIntervals.INTERVAL_MONTHLY %>)
        {
             if (document.ConfigForm.intervalDOM.value < 1 || document.ConfigForm.intervalDOM.value > 31)
             {
                 alert ("<%= ftwAutoDiscoveryBean.getResourceString("auto.page.error.dom.range")%>");
                 return false;
             }

            return validateNumFieldConfig(document.ConfigForm.intervalDOM,  '<%=ftwAutoDiscoveryBean.getResourceString("auto.page.error.dom")%>' );
        }
        return true;
    }

    function  noSpaces( str )
    {
        for ( var i = 0; i < str.length; i++ )
        {
            if ( str.charAt(i) == ' ' )
            {
               return false;
            }
        }
        return true;  // There are no spaces
    }

    // Validate the for empty fields and correct syntax used for snmp config settings
    function validateNumFieldConfig( field, nameStr  )
    {
        var rc = true;
        // Check for invalid network timeout

        var onechar = field.value.substring(0,1)

        if ((field.value.length == 0) )
        {
            alert(nameStr+  " <%=ftwAutoDiscoveryBean.getResourceString("auto.page.error.notblank")%>");
            hilite( field );
            return false;
        }

        if ( checkNumber( field, nameStr  ) == false)
        {
            hilite( field );
            return false;
        }

        // Check for a valid Network timeout & Retries
        if (noSpaces( field.value ) == false )
        {
            alert( nameStr+" <%=ftwAutoDiscoveryBean.getResourceString("auto.page.error.nospaces")%>" );
            hilite( field );
            return false;
        }
        return true;
    }

    // Check for valid numbers
    function checkNumber( field, settingName  )
    {
        inputStr = field.value;
        for (var i=0; i < inputStr.length; i++)
        {
            var oneChar = inputStr.charAt(i);
            if (oneChar < "0" || oneChar > "9")
            {
                alert( settingName + " <%=ftwAutoDiscoveryBean.getResourceString("auto.page.error.mustbenumb")%>" );
                hilite( field );
                return false;
            }
        }
    }

    function hilite( editWindow )
    {
        editWindow.focus();
        editWindow.select();
        return true;
    }

    function validateIP()
    {
        var pass = true;

        if ( !validateIPString(document.ConfigForm.inclusionTextBox.value) )
        {
            alert("<%=ftwAutoDiscoveryBean.getResourceString("auto.page.error.inclusion.contents")%>");
            pass = false;
        }
        return pass;
    }

    function validateIPString( str )
    {
        var i, chr;

        for ( i = 0; i < str.length; ++i )
        {
            chr = str.charCodeAt(i);
            //            1            0             #              $             -                                                                                                                                 _
            if (((chr >= 48)&&(chr <= 57))|| (chr == 35) || (chr == 36)|| (chr == 42)|| (chr == 32)|| (chr == 10)|| (chr == 13)|| (chr == 9) || (chr == 45) || (chr == 46) || (chr == 58) || (chr == 64) || (chr == 95) ||((chr >= 65)&&(chr <= 90)) || ((chr >= 97)&&(chr <= 122)))
            {
                continue;
            }
            else
            {
                // alert(chr);
                return false;
            }
        }

        return true;
    }

    function markFormAsChanged()
    {
        bSettingsChanged=true;
    }

    function handleIPCheckChange()
    {
        if (document.ConfigForm.ipCheckbox.checked)
        {
             document.ConfigForm.inclusionTextBox.disabled = false;
        }
        else
        {
            document.ConfigForm.inclusionTextBox.disabled = true;
        }
    }

    function handleEnableDisableChanges()
    {
        if (document.ConfigForm.discoveryEnabledCheckBox.checked)
        {
             document.ConfigForm.interval.disabled = false;
             document.ConfigForm.intervalType.disabled = false;
             if (document.ConfigForm.intervalTime != null)
             {
                 document.ConfigForm.intervalTime.disabled = false;
             }
             if (document.ConfigForm.intervalDOW != null)
             {
                 document.ConfigForm.intervalDOW.disabled = false;
             }
             if (document.ConfigForm.intervalDOM != null)
             {
                 document.ConfigForm.intervalDOM.disabled = false;
             }
             if (document.ConfigForm.intervalAMPM != null)
             {
                 document.ConfigForm.intervalAMPM.disabled = false;
             }
        }
        else
        {
             document.ConfigForm.interval.disabled = true;
             document.ConfigForm.intervalType.disabled = true;

             if (document.ConfigForm.intervalTime != null)
             {
                 document.ConfigForm.intervalTime.disabled = true;
             }
             if (document.ConfigForm.intervalDOW != null)
             {
                 document.ConfigForm.intervalDOW.disabled = true;
             }
             if (document.ConfigForm.intervalDOM != null)
             {
                 document.ConfigForm.intervalDOM.disabled = true;
             }
             if (document.ConfigForm.intervalAMPM != null)
             {
                 document.ConfigForm.intervalAMPM.disabled = true;
             }

        }
    }

    function init()
    {
        pageLoaded = true;
        displayMorePeriodical();
        handleEnableDisableChanges();
    }

    /////////////////////////////////////////////////
    // displayMorePeriodical()
    /////////////////////////////////////////////////
    function displayMorePeriodical()
    {
        var td = document.getElementById("morePeriodical");

        var select    = document.getElementById("intervalType");
        var listIndex = select.value;

        switch (listIndex)
        {
            case '<%= ScheduleIntervals.INTERVAL_MINUTES %>':  // minutes
                td.innerHTML = "&nbsp;";
                break;

            case '<%= ScheduleIntervals.INTERVAL_HOURS %>':  // hours
                td.innerHTML = "&nbsp;";
                break;

            case '<%= ScheduleIntervals.INTERVAL_DAYS %>':  // days
                td.innerHTML = "&nbsp;<%= ftwAutoDiscoveryBean.getResourceString("auto.page.label.at") %>&nbsp;"+
                               "<input id='intervalTime' name='intervalTime' type='text' size='5' value='<%=ftwAutoDiscoveryBean.getIntervalTimeStr() %>' maxlength='5'>"
                <%
                    if (dateAndTime.getUseAMPM() == true)
                    {
                %>

                               +"<select id='intervalAMPM' name='intervalAMPM' size='1'>" +
                               "<option value='AM' <%=ftwAutoDiscoveryBean.getIsAmChecked() %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.ampm.am") %></option>" +
                               "<option value='PM' <%=ftwAutoDiscoveryBean.getIsPmChecked() %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.ampm.pm") %></option>" +
                               "</select>";
                <%
                    }
                %>
                break;

            case '<%= ScheduleIntervals.INTERVAL_WEEKLY %>':  // weeks
                td.innerHTML = "&nbsp;<%= ftwAutoDiscoveryBean.getResourceString("auto.page.label.on") %>&nbsp;<select id='intervalDOW' name='intervalDOW' size='1'>" +
                               "<option value='<%= Calendar.SUNDAY %>' <%= ftwAutoDiscoveryBean.getIntervalDOWSelStr(Calendar.SUNDAY)%>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.dow.sun") %></option>" +
                               "<option value='<%= Calendar.MONDAY %>' <%= ftwAutoDiscoveryBean.getIntervalDOWSelStr(Calendar.MONDAY)%>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.dow.mon") %></option>" +
                               "<option value='<%= Calendar.TUESDAY %>' <%= ftwAutoDiscoveryBean.getIntervalDOWSelStr(Calendar.TUESDAY)%>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.dow.tue") %></option>" +
                               "<option value='<%= Calendar.WEDNESDAY %>' <%= ftwAutoDiscoveryBean.getIntervalDOWSelStr(Calendar.WEDNESDAY)%>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.dow.wed") %></option>" +
                               "<option value='<%= Calendar.THURSDAY %>' <%= ftwAutoDiscoveryBean.getIntervalDOWSelStr(Calendar.THURSDAY)%>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.dow.thu") %></option>" +
                               "<option value='<%= Calendar.FRIDAY %>' <%= ftwAutoDiscoveryBean.getIntervalDOWSelStr(Calendar.FRIDAY)%>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.dow.fri") %></option>" +
                               "<option value='<%= Calendar.SATURDAY %>' <%= ftwAutoDiscoveryBean.getIntervalDOWSelStr(Calendar.SATURDAY)%>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.dow.sat") %></option>" +
                               "</select>" +
                               "&nbsp;<%= ftwAutoDiscoveryBean.getResourceString("auto.page.label.at") %>&nbsp;" +
                               "<input id='intervalTime' name='intervalTime' type='text' size='5' value='<%=ftwAutoDiscoveryBean.getIntervalTimeStr() %>' maxlength='5'>"
                <%
                    if (dateAndTime.getUseAMPM() == true)
                    {
                %>
                               +"<select name='intervalAMPM' size='1'>" +
                               "<option value='AM' <%=ftwAutoDiscoveryBean.getIsAmChecked() %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.ampm.am") %></option>" +
                               "<option value='PM' <%=ftwAutoDiscoveryBean.getIsPmChecked() %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.ampm.pm") %></option>" +
                               "</select>";
                <%
                    }
                %>

                break;

            case '<%= ScheduleIntervals.INTERVAL_MONTHLY %>':  // months
                td.innerHTML = "&nbsp;<%= ftwAutoDiscoveryBean.getResourceString("auto.page.label.onday") %>&nbsp;<input id='intervalDOM'  name='intervalDOM' type='text' size='2' maxlength='2' value='<%=ftwAutoDiscoveryBean.getIntervalDOM() %>'>" +
                               "&nbsp;<%= ftwAutoDiscoveryBean.getResourceString("auto.page.label.at") %>&nbsp;<input id='intervalTime' name='intervalTime' type='text' size='5' value='<%=ftwAutoDiscoveryBean.getIntervalTimeStr() %>'>"
                <%
                    if (dateAndTime.getUseAMPM() == true)
                    {
                %>
                               + "<select intervalAMPM name='intervalAMPM' size='1'>" +
                               "<option value='AM' <%=ftwAutoDiscoveryBean.getIsAmChecked() %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.ampm.am") %></option>" +
                               "<option value='PM' <%=ftwAutoDiscoveryBean.getIsPmChecked() %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.ampm.pm") %></option>" +
                               "</select>";
                <%
                    }
                %>
                break;
        }
    }

    MxPortalWorkspaceSetHelpTopic("admin_discovery_configAuto");
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>
<BODY LEFTMARGIN=0 onload="init()">
<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        ftwAutoDiscoveryBean.clearAllErrorMessages();
        boolean success = ftwAutoDiscoveryBean.processPost(request);
        if (success)
        {
            %>
            <script language='JavaScript' type='text/javascript'>
                var okToContinue = true;
                <%
                if (ftwAutoDiscoveryBean.isRangeTooLarge())
                {
                    %>okToContinue = confirm("<%= ftwAutoDiscoveryBean.getBigRangeWarningMessage() %>");<%
                }
                %>

                if (okToContinue)
                {
                    location.href="<%=ftwUIbean.getResString("USERS_PAGE_URL")%>";
                }
                </script>

                <%
                if (!ftwAutoDiscoveryBean.isRangeTooLarge())
                {
                    %></body><%
                    return;
                }
                %>

            <%
        }
        else
        {
            %>
            <script language='JavaScript' type='text/javascript'>
                location.href="<%=ftwUIbean.getResString("DISCOVERY_PAGE_URL")%>";
            </script>
            </body>
            <%
            return;
        }
    }
    else
    {
%>
        <jsp:setProperty name="ftwProtoSettings" property="*"/>
<%  } %>

<A NAME="NAME_PAGE_TOP"></A>

<form action="ftw_Discovery.jsp?mode=<%= mode %>" method="POST" id="ConfigForm" name="ConfigForm" onSubmit="return validateAll()">
    <TABLE width='100%' border='0' cellspacing='0' cellpadding='0'>
    <TR valign='top'>
        <TD>
            <%int currentTab = 4;%>
            <%@include file="FirstTimeWizard_DrawTabs.txt"%>
        </TD>
        <TD style='padding-left:12px;' align='left' width='100%'>
            <TABLE  class="top-border-table" WIDTH="100%">
            <TR><TD>
                <FONT class="mxPageSubTitle">
                   <%=ftwUIbean.getResString("DISCOVERY_LABEL")%>
                </FONT>
                <br>
                <b><%=ftwUIbean.getResString("DISCOVERY_LINK")%></b>
                <p>
                    <%=ftwUIbean.getResString("DISCOVERY_MAIN_TEXT")%>
                <p>
                <p>

                <P>
                <%
                    if (ftwAutoDiscoveryBean.hasErrorMessages())
                    {
                        // Display plurally-correct label
                        if (ftwAutoDiscoveryBean.getErrorMessageList().size() == 1)
                        {
                            %><div class="errorTextBold"><%= ftwAutoDiscoveryBean.getResourceString("discovery.general.error.label.single")%></div><%
                        }
                        else
                        {
                            %><div class="errorTextBold"><%= ftwAutoDiscoveryBean.getResourceString("discovery.general.error.label.multiple")%></div><%
                        }

                        ftwAutoDiscoveryBean.displayErrorMessagesInHtml(out);
                    }
                %>

                <!-- NAME -->
                <span style="font-weight:bold;"><%= ftwAutoDiscoveryBean.getResourceString("auto.page.label.name")%></span> &nbsp; <jsp:getProperty name="ftwAutoDiscoveryBean" property="discoveryName" /><br/><br/>

                <!-- SCHEDULE AND STATUS -->
                <div style="font-weight:bold;"><%= ftwAutoDiscoveryBean.getResourceString("auto.page.label.schedule")%></div>
                <div class="indented">
                    <input type="checkbox" name="discoveryEnabledCheckBox" id="id_discoveryCheckBox" onClick="handleEnableDisableChanges()"  value="ON" <%= ftwAutoDiscoveryBean.getTaskCheckStr() %> >
                    <LABEL class=sizeTen for="id_discoveryCheckBox"><%= ftwAutoDiscoveryBean.getResourceString("auto.page.cb.enableSchedule") %></LABEL><br>

                    <table border='0' cellspacing='0' cellpadding='0' style='width:100%'>
                        <tr>
                          <td nowrap><input id='interval' name='interval' type='text' size='3' value='<%= ftwAutoDiscoveryBean.getInterval()%>' maxlength='3'></td>
                          <td nowrap>
                            <select id='intervalType' name='intervalType' onChange='displayMorePeriodical()'>
                               <option value='<%= ScheduleIntervals.INTERVAL_HOURS %>' <%= ftwAutoDiscoveryBean.getIsIntervalTypeSelected( ScheduleIntervals.INTERVAL_HOURS) %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.schedule.hours") %></option>
                               <option value='<%= ScheduleIntervals.INTERVAL_DAYS %>' <%= ftwAutoDiscoveryBean.getIsIntervalTypeSelected( ScheduleIntervals.INTERVAL_DAYS) %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.schedule.days") %></option>
                               <option value='<%= ScheduleIntervals.INTERVAL_WEEKLY %>' <%= ftwAutoDiscoveryBean.getIsIntervalTypeSelected( ScheduleIntervals.INTERVAL_WEEKLY) %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.schedule.weeks") %></option>
                               <option value='<%= ScheduleIntervals.INTERVAL_MONTHLY %>' <%= ftwAutoDiscoveryBean.getIsIntervalTypeSelected( ScheduleIntervals.INTERVAL_MONTHLY) %>><%= ftwAutoDiscoveryBean.getResourceString("auto.page.schedule.months") %></option>
                             </select>
                           </td>
                           <td id='morePeriodical' nowrap style='width:100%'></td>
                        </tr>
                    </table>
                </div><br/>

                <!-- PING INCLUSION RANGE -->
                <div style="font-weight:bold;"><%= ftwAutoDiscoveryBean.getResourceString("auto.page.label.ping") %> <span class="required">*</span></div>
                <div class="indented">
                    <%
                    if (ftwAutoDiscoveryBean.isRangeTooLarge())
                    {
                        %><div class='errorTextBold'><%= ftwAutoDiscoveryBean.getBigRangeWarningMessage() %></div><%
                    }
                    %>
                    <textarea name="inclusionTextBox" id="inclusionTextBox" onChange="markFormAsChanged()" style="WIDTH: 300px;HEIGHT: 120px"  wrap="off"><%=ftwAutoDiscoveryBean.getIpInclusionRangeStr() %></textarea>
                </div>

                <!-- CONFIGURATION -->
                <div class="indented" style="visibility:hidden">
                    <%
                    if (MxCMS.isWindows())
                    {
                    %>
                        <input type="checkbox" name="ipxCheckbox" id="id_ipxCheckbox" value="ON" <%= ftwAutoDiscoveryBean.IPXEnabledCBStr() %> >
                        <LABEL for="id_ipxCheckbox"><%= ftwAutoDiscoveryBean.getResourceString("auto.page.cb.protocols.ipx") %></LABEL><br>
                    <%
                    }
                    %>
                </div>
            </TD></TR>
            </TABLE>
        </TD>
    </TR>
    </TABLE>

    <input type="hidden" name="discoveryName" value="<%= ftwAutoDiscoveryBean.getDiscoveryName() %>">
    <input type="hidden" name="ipCheckbox" value="checked">

    <!-- End Data -->

    <SCRIPT>
    function nextPage()
    {
        if (validateAll())
        {
            <!-- Need to do a post to ftw_Discovery.jsp to save the settings. -->
            <!--document.getElementById('ConfigForm').action='<%=ftwUIbean.getResString("USERS_PAGE_URL")%>'; -->
            document.getElementById('ConfigForm').submit();
        }
    }

    function prevPage()
    {
        document.getElementById('ConfigForm').action='<%=ftwUIbean.getResString("SNMP_PAGE_URL")%>';
        document.getElementById('ConfigForm').submit();
    }
    </SCRIPT>

</FORM>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
