<%@ page info="Manul Discovery - Hosts Files List"%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.database.*" %>
<%@ page import="com.hp.mx.portal.help.*" %>
<%@ page import="com.hp.mx.portal.discovery.ManualDiscoveryHostsBean" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.html.table.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="mdHostsBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="mdHostsBean" class="com.hp.mx.portal.discovery.ManualDiscoveryHostsBean" scope="session" />
<jsp:useBean id="mdHostsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="mdHostsTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="mdHostsTableController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="discRbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="discTabModel" class="com.hp.mx.portal.discovery.DiscoveryTabModel" scope="session" />

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // Set up the Discovery Tabs
    discRbsettings.init(loginBean, "Discovery");
    discTabModel.load(discRbsettings);
    discTabModel.setMxTagSelectionId(discTabModel.DISC_HOSTS);

     // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Do we need to abort?
    if (mdHostsTableController.checkUrlForControllerMessages(request, out)) return;

    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
        return;
    }

    // setup resources.
    mdHostsBundle.init(loginBean, "ManualDiscovery");

    // and my bean
    mdHostsBean.initialize(loginBean, mdHostsSelectionModel );

    if (request.getParameter("error") == null)
    {
        mdHostsBean.clearAllErrorMessages();
    }

    String hostsFileTableName = "ID_MDHOSTS_TABLE";
    if (mdHostsTableController.isFirstTime())
    {
        mdHostsSelectionModel.setSelectionMode(MxTableSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        mdHostsTableView.setId(hostsFileTableName);
        mdHostsTableView.setOnSelectionChange("mySelectionChanged");
        mdHostsTableView.setUrlHandler(request.getRequestURI());
        mdHostsTableController.setTableModelWithSorting(mdHostsBean.getTableModel() );
        mdHostsTableController.setSelectionModel(mdHostsSelectionModel);
        mdHostsTableController.setTableView(mdHostsTableView);
    }

    mdHostsBean.setFileList();

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag btnNewTag = new MxDefaultTag("btnNew", mdHostsBundle.getString("mdHosts.button.new"), "newTemplate()");
    MxTag btnEditTag = new MxDefaultTag("btnEdit", mdHostsBundle.getString("mdHosts.button.edit"), "showTemplateDetails()");
    MxTag btnDeleteTag = new MxDefaultTag("btnDelete", mdHostsBundle.getString("mdHosts.button.delete"), "delTemplate()");
    MxTag btnAddSystemsTag = new MxDefaultTag("btnAddSystems", mdHostsBundle.getString("mdHosts.button.add"), "addSystems()");

    btnEditTag.setAttr(MxTag.DISABLED, "true");
    btnDeleteTag.setAttr(MxTag.DISABLED, "true");
    btnAddSystemsTag.setAttr(MxTag.DISABLED, "true");

    buttons.addMxTag(btnNewTag);
    buttons.addMxTag(btnEditTag);
    buttons.addMxTag(btnDeleteTag);
    buttons.addMxTag(btnAddSystemsTag);

    buttons.setVerticalAligned(true);
%>
<html>
    <head>
        <link href="<%=MxOptions.URL_BASE%>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
        <script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/MxBrowser.js"></script>
        <script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js"></script>
        <script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/utilities.js" ></script>
        <script language="JavaScript" type="text/javascript">
            // Set the help context
            MxPortalWorkspaceSetHelpTopic("admin_discovery_manageHostsFiles");
        </script>
        <script language="JavaScript" type="text/javascript">

        function mySelectionChanged(szIdTable, iRow, bSelected)
        {
            checkButtonStates();
            var iFrame = document.getElementById("templateDetails");
            if (iFrame != null)
            {
                iFrame.contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/home/MxBlank.html");
            }
            MxPortalWorkspaceSetHelpTopic("admin_discovery_manageHostsFiles");
        }

        function checkButtonStates()
        {
            // new button is always enabled.
            // default state on page load is disabled, so only enable if something is selected.
            var aSel = MxTableGetSelections("<%= hostsFileTableName %>");
            (aSel.length == 1) ? ourButtonManager.enableButtonById('btnEdit') : ourButtonManager.disableButtonById('btnEdit');
            (aSel.length >  0) ? ourButtonManager.enableButtonById('btnDelete') : ourButtonManager.disableButtonById('btnDelete');
            (aSel.length == 1) ? ourButtonManager.enableButtonById('btnAddSystems') : ourButtonManager.disableButtonById('btnAddSystems');
        }

        function newTemplate()
        {
            var iFrame = document.getElementById("templateDetails");
            if (iFrame != null)
            {
                iFrame.contentWindow.document.location.replace("manualDiscoveryHostDetails.jsp?newTemplate=true");
            }
        }


        function showTemplateDetails()
        {
            var aSel = MxTableGetSelections("<%= hostsFileTableName %>");
            if (aSel.length != 1)
            {
                alert("<%= mdHostsBundle.getString("mdHosts.error.noFileSelection") %>");
                return;
            }

            var iFrame = document.getElementById("templateDetails");
            if (iFrame != null)
            {
                iFrame.contentWindow.document.location.replace("manualDiscoveryHostDetails.jsp?editTemplate=true");
            }

        }


        function addSystems()
        {
            var iFrame = document.getElementById("templateDetails");
            if (iFrame != null)
            {
                iFrame.contentWindow.document.location.replace("manualDiscoveryHostDetails.jsp?addSystems=true");
            }
        }

        function delTemplate()
        {
            var aSel = MxTableGetSelections("<%= hostsFileTableName %>");
            if (aSel.length == 0)
            {
                alert("<%= mdHostsBundle.getString("mdHosts.error.noFileSelection") %>");
                return;
            }
            var proceed = true;
            if (aSel.length == 1)
            {
                proceed = confirm ("<%= mdHostsBundle.getString("mdHosts.msg.delete1") %>")
            }
            else
            {
                proceed = confirm ("<%= mdHostsBundle.getString("mdHosts.msg.delete2") %>")
            }

            if (proceed)
            {
                var iFrame = document.getElementById("templateDetails");
                if (iFrame != null)
                {
                    iFrame.contentWindow.document.location.replace("manualDiscoveryHostDetails.jsp?delTemplate=true");
                }
            }
        }

        function init()
        {
            resize_w(); // set width
            <%
            // Tell the user that the hosts file systems were added successfully
            if (request.getParameter("addSucceeded") != null)
               out.println("alert(\"" + mdHostsBundle.getString("mdHosts.msg.success") + "\");");
            %>
            checkButtonStates();
        }

        // Resize the MxTable to be flush with the right browser edge
        function resize_w()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(0, 0) - 200);
            MxTableSetWidth("<%= hostsFileTableName %>", w);
        }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% discTabModel.dumpHeadContent(out); %>
<% mdHostsTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
    </head>

    <body onLoad="init()" onResize="resize_w()">
    <% discTabModel.dumpTabs(out); %>

    <p><%= mdHostsBundle.getString("mdHosts.description")%></p>

    <%
        if (mdHostsBean.hasErrorMessages())
        {
        %>
            <%
                mdHostsBean.displayErrorMessages(out);
                mdHostsBean.clearAllErrorMessages();
            %>
        <%
        }
    %>
    <table border=0 cellspacing="0" cellpadding="2">
       <tr valign="top">
            <td>
                <% mdHostsTableView.dumpWholeTable(out); %>
            </td>
            <td>
            <div style="width:150px;margin-top:15px">
                <% buttons.dumpButtons(out); %>
            </div>
            </td>
        </tr>
    </table>

    <iframe id="templateDetails" style="width:100%; height:1100; position:relative; visibility:visible"
            scrolling="no" marginwidth="0" frameborder="0" src="<%=MxOptions.URL_BASE%>/home/MxBlank.html"></iframe>

<% MxHtmlUtil.dumpBodyEnd(out); %>

  </body>
</html>
