<%@ page
    import="java.util.Vector,
            javax.swing.tree.TreeModel,
            javax.swing.tree.TreePath,
            javax.swing.tree.TreeSelectionModel,
            javax.swing.tree.DefaultTreeModel,
            javax.swing.tree.DefaultMutableTreeNode,
            com.hp.mx.core.controllers.VCRepositoryController,
            com.hp.mx.core.querymanager.components.SWTreeEventData,
            com.hp.mx.html.core.MxHtmlUtil,
            com.hp.mx.html.core.MxTreeUtil,
            com.hp.mx.portal.ui.*"
%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="vcRepositoryBean" class="com.hp.mx.portal.settings.VCRepositorySetup" scope="session"/>
<jsp:useBean id="ussTreeView" class="com.hp.mx.html.tree.MxTreeView" scope="session" />
<jsp:useBean id="ussExpansionModel" class="com.hp.mx.html.tree.MxDefaultTreeExpansionModel" scope="session" />
<jsp:useBean id="ussTreeController" class="com.hp.mx.html.tree.MxTreeController" scope="session" />
<jsp:useBean id="ussSelectionModel" class="javax.swing.tree.DefaultTreeSelectionModel" scope="session" />
<jsp:useBean id="vcrResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="initialPSPInstallBean" class="com.hp.mx.portal.taskandjob.InitialPSPInstall.InitialPSPInstallBean" scope="session" />
<jsp:useBean id="updateSystemSoftwareBean" class="com.hp.mx.core.tools.swmaintenance.UpdateSystemSoftwareBean" scope="session" />

<%!
    public String treeDomId = "ID_MY_CATALOG_TREE";
    private TreeModel myTreeModel = null;
    private boolean error = false;
    private String errorStr = "";
    private int supportPackOnly = 0;
%>

<%
    MxBean.jspInit(request, response);

    boolean enableNextButton = false;
    if (ussTreeController.checkUrlForControllerMessages(request, out))
   {
       if (request.getParameter(ussTreeController.URL_PARAM_SELECTION) != null)
       {
           out.println("<script language='javascript'>");
           out.println("   parent.parent.treeSelectionChanged(" + ussSelectionModel.getSelectionCount() + ");");
           out.println("</script>");
       }
       return;
   }

    vcrResourceSettings.init(loginBean, "VCRepositorySetup");

    int treeType = 0;
    int treeHeight = 130;
    String param1 = request.getParameter("treeType");
    String param2 = request.getParameter("treeHeight");

    // If a tree type has been passed in, get the int
    // value for it
    if (param1 != null)
    {
        treeType = Integer.parseInt(param1);
        supportPackOnly = treeType & VCRepositoryController.SWTREE_WINDOWS_SUPPORT_PACKS_ONLY;
    }

    // If a tree height has been passed in, get the int
    // value for it
    if (param2 != null)
    {
        treeHeight = Integer.parseInt(param2);
    }

    // Get the tree data
    SWTreeEventData treeData = vcRepositoryBean.returnSelectedRepository();

    if (treeData != null)
    {
        DefaultMutableTreeNode root = treeData.getRoot();

        if (root != null)
        {
            if (root.getChildCount() > 0)
            {
                // There is a valid catalog tree
                myTreeModel = new DefaultTreeModel(treeData.getRoot());
                ussSelectionModel.clearSelection();
                ussTreeController.setTreeModel(myTreeModel);

                // Set up the tree for the first time
                if (ussTreeController.isFirstTime())
                {
                    ussTreeView.setId(treeDomId);
                    ussTreeView.setUrlHandler(request.getRequestURI());

                    ussTreeController.setLocale(loginBean.getLocale());
                    ussTreeController.setExpansionModel(ussExpansionModel);
                    ussTreeController.setTreeView(ussTreeView);
                }

                // For the system software tree, use multi-select
                ussTreeController.setSelectionModel(ussSelectionModel);
                ussSelectionModel.setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);

                // set up selections
                // Update Software/Firmware tree
                Vector components = updateSystemSoftwareBean.getComponentList();
                Vector osList = updateSystemSoftwareBean.getOSList();
                Vector divisionList = updateSystemSoftwareBean.getDivisionList();
                if (components != null && components.size() > 0)
                {
                    enableNextButton = true;
                    for (int i=0; i<components.size(); i++)
                    {
                        String szId = vcRepositoryBean.getTagIdFromComponent((String)components.get(i),
                                                                             (String)osList.get(i),
                                                                             (String)divisionList.get(i));

                        TreePath path = MxTreeUtil.getPathFromId(myTreeModel, szId);
                        ussSelectionModel.addSelectionPath(path);
                        ussTreeController.expandPathUpToId(szId);
                    }
                }
            }
            else
            {
                // Tree has no elements. Display the appropriate error message, depending
                // whether the tree is a Support Pack tree or not
                error = true;
                if (supportPackOnly != 0)
                    errorStr = "display.nosupportpacks";
                else
                    errorStr = "display.emptytree";
            }
        }
        else
        {
            // Not a valid catalog tree, find the error
            myTreeModel = null;
            int opStat = treeData.getOpStat();
            error = true;
            errorStr = "retrieve.generalerror";
        }
    }
    else
    {
        // This should never happen
        error = true;
        errorStr = "retrieve.generalerror";
    }
%>

<HTML>
    <HEAD>
    <link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>

    <SCRIPT>
    function myTreeChanged(szIdTree, szId, bSelected)
    {
        parent.treeSelectionChanged(count);
    }

    </SCRIPT>
    <% MxHtmlUtil.dumpHeadBegin(out); %>
    <% ussTreeView.dumpHeadContent(out); %>
    <% MxHtmlUtil.dumpHeadEnd(out); %>
    </HEAD>

    <BODY>

    <%
    // Display the error, if there was one
    if (error)
    {
        error = false;
        out.println("<font class='errorTextBold'>");
        out.println("<br>"+vcrResourceSettings.getString(errorStr));
        out.println("</font>");
        return;
    }
    %>

    <%
    if (myTreeModel != null)
    {
    %>

    <div style="padding-left:8px;padding-bottom:6px">
        <% ussTreeView.dumpExpansionButtons(out); %>
    </div>

    <div id="catalogTree" style="width:100%; overflow:auto;height:<%=treeHeight %>; border:1px solid black; padding:2px">
        <% ussTreeView.dumpTree(out); %>
    </div>

    <%
        if (enableNextButton)
        {
    %>
        <SCRIPT>
            parent.enableNextButton(true);
        </SCRIPT>
    <%
        }
    }
    %>

    <% MxHtmlUtil.dumpBodyEnd(out); %>
    </BODY>
</HTML>
