<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="javax.swing.table.AbstractTableModel" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="updateSystemSoftwareBean" class="com.hp.mx.core.tools.swmaintenance.UpdateSystemSoftwareBean" scope="session" />
<jsp:useBean id="ussComponentSelectionModelRepositories" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="ussComponentTableViewRepositories" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="ussComponentControllerRepositories" class="com.hp.mx.html.table.MxTableController" scope="session"/>

<%
    MxBean.jspInit(request, response);

    int index = 0;

    // do we need to abort?
    if (ussComponentControllerRepositories.checkUrlForControllerMessages(request, out)) return;

    // get the direction to move the component
    // in the table - 'up', 'down', or 'none'
    // 'none' is set for new table
    String direction = request.getParameter("direction");

    // get the selected index and
    // set it in the table model
    if (!direction.equals("none"))
    {
        Thread.sleep(1000);
        int tableModelIndices[] = ussComponentSelectionModelRepositories.getSelectedIndices();
        if (tableModelIndices.length >0)
        {
            index = tableModelIndices[0];
            updateSystemSoftwareBean.selectComponentRow(index);
        }
    }

    // set up the selected components table items
    int moved = updateSystemSoftwareBean.setSelectedComponentsTableItems(direction);

    AbstractTableModel tableModel = updateSystemSoftwareBean.getSelectedComponentsTableModel();
    ussComponentControllerRepositories.setTableModel(tableModel);

    // setup the display of the Repository Setup table model
    if (ussComponentControllerRepositories.isFirstTime())
    {
        ussComponentSelectionModelRepositories.setSelectionMode(MxTableSelectionModel.SINGLE_SELECTION);

        ussComponentTableViewRepositories.setId("ID_MY_USS_COMPONENT_TABLE");
        ussComponentTableViewRepositories.setUrlHandler(request.getRequestURI());

        ussComponentControllerRepositories.setSelectionModel(ussComponentSelectionModelRepositories);
        ussComponentControllerRepositories.setTableView(ussComponentTableViewRepositories);
    }

    // Highlight the selected row
    if (moved != index)
    {
        updateSystemSoftwareBean.selectComponentRow(moved);
        ussComponentSelectionModelRepositories.setSelectedIndex(moved, true);
    }

    // Table of Repositories
    //
    // TITLE == 19 pixels.  Each target line == 18 pixels. We will display 10 devs max
    // if there are fewer than 10 devs, create height as appropriate
    int titleHeight  = 20; //19;
    int rowHeight    = 17; //18;
    int maxDisplayed = 5;

    int numDevs     = updateSystemSoftwareBean.getNumComponents();

    // MAX == 199 (default)
    int divHeight    = (rowHeight * ((numDevs < maxDisplayed) ? numDevs : maxDisplayed)) + titleHeight;
%>

<html>
    <head>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>

        <script>
            // tell the MxTable to "refresh in place"
            function loadPage()
            {
                // tell the table to update its content
                MxTableRefreshInPlace('ID_MY_USS_COMPONENT_TABLE');
            }

            // resize the MxTable to be flush with the right browser edge
            function myResize()
            {
                var w = Math.max(0, MxBrowserGetBodyWidth(-NETSCAPE_SCROLLBAR_WIDTH, 0));
                MxTableSetWidth('ID_MY_USS_COMPONENT_TABLE', w);
            }
        </script>

        <% MxHtmlUtil.dumpHeadBegin(out); %>
        <% ussComponentTableViewRepositories.dumpHeadContent(out); %>
        <% MxHtmlUtil.dumpHeadEnd(out); %>
    </head>

    <body onResize='myResize()'>
        <%
        ussComponentTableViewRepositories.dumpWholeTable(out);
        %>
        <script>
        MxTableSetHeight("ID_MY_USS_SETUP_TABLE",120);
        </script>

    <% MxHtmlUtil.dumpBodyEnd(out); %>
    </body>
</html>
