/////////////////////////////////////////////////
// defines
/////////////////////////////////////////////////
var ACTION_TIMEOUT               = 250;   //  0.25 seconds
var RESIZE_TIMEOUT               = 750;   //  0.75 second
var REFRESH_TIMEOUT              = 10000; // 10.00 seconds
var SELF_FOCUS_CHECK_TIMEOUT     = 250;   //  0.25 seconds
var UNLOCK_PAUSE_TIMEOUT         = 10000;
var AUTH_CHECK_TIMEOUT           = 30000;

var IFRAME_SWITCH_TIMEOUT        = 2250;  //  2.25 seconds
var JOBFORMATTER_IFRAME_HEIGHT   = 900;
var FORMAT_FRAME_1               = 0;
var FORMAT_FRAME_2               = 1;

// this value is used for X-WINDOWS tools.  The Task Results will refresh
// a maximum number of times until the refreshes stop; no point in continuing
// to refresh if the user is expected to have the X-Window open for quite some
// time
var MAX_REFRESH_WAIT_COUNT       = 5;

// this value is used for refreshing the Task Results.  When an update first
// signals that the Job has stopped, this value is the number of additional
// times a refresh will occur to ensure that the task results are displaying
// the latest status information
var REFRESH_STOPPED_JOB_COUNT    = 2;

var BTN_APPLY_TARGETS            = 0;
var BTN_CANCEL_TARGETS           = 1;
var BTN_ADD_TARGETS              = 2;
var BTN_REMOVE_TARGETS           = 3;
var BTN_NO_BUTTON                = 4;
var BTN_CUSTOM_1                 = 5; // usually "Next"/"Run Now"
var BTN_CUSTOM_2                 = 6; // usually reserved for "Schedule"
var BTN_CUSTOM_3                 = 7; // usually "Prev"

var SELECT_LIST                  = 0;
var SELECT_INDIVIDUAL            = 1;
var SELECT_SEARCH                = 2;

var NETSCAPE_SCROLLBAR_WIDTH     = 37;
var DEFAULT_SCROLLBAR_WIDTH      = 20;

var NUM_REFINEMENT_CELLS         = 6;

var JOB_FORMAT_BASIC             = 0;
var JOB_FORMAT_FULL              = 1;
var JOB_FORMAT_PRINT             = 2;

var ERROR_FROM_TASKWIZARD        = 0;
var ERROR_FROM_TASKANDJOB        = 1;

var TITLE_HEIGHT_MULTIPLIER      = 1.25;  // 25% more than a rowHeight
var TABLE_TITLE_DEFAULT_HEIGHT   = 21;
var TASK_JOBS_TABLE_WIDTH        = 400;

var TASK_LIST_MIN_DISPLAYED      = 2;
var TASK_LIST_MAX_DISPLAYED      = 10;

var TASK_JOB_LIST_MIN_DISPLAYED  = 1;
var TASK_JOB_LIST_MAX_DISPLAYED  = 3;

var TARGET_LIST_MIN_DISPLAYED    = 2;
var TARGET_LIST_MAX_DISPLAYED    = 5;

var JOB_LIST_MIN_DISPLAYED       = 2;
var JOB_LIST_MAX_DISPLAYED       = 10;

var NODE_BUCKET_MIN_DISPLAYED    = 2;
var NODE_BUCKET_MAX_DISPLAYED    = 10;

var MOUSE_CURSOR_HOURGLASS       = "wait";
var MOUSE_CURSOR_POINTER         = "default";

///////////////////////////////
// m_OnKeyDown()
///////////////////////////////
function m_OnKeyDown(e)
{
    var keycode    = null;
    var srcElement = null;

    if (window.event)
    {
        keycode    = window.event.keyCode;
        srcElement = window.event.srcElement;
    }
    else if (e)
    {
        keycode    = e.which;
        srcElement = e.target;
    }
    else
    {
        return true;
    }

    if (keycode == 8)  // backspace
    {
        if ((srcElement != null) && (srcElement.disabled == false) && (srcElement.readOnly == false) && (srcElement.getAttribute("type") == "text"))
        {
            // ok to perform action if fired from a TextEdit field
            return true;
        }

        // do not perform this action for any other field or non-field
        return false;
    }

    // go ahead and perform this action - not a backspace
    return true;
}
/////////////////////////////////////////////////
// setMouseCursor()
/////////////////////////////////////////////////
function setMouseCursor(style)
{
    document.body.style.cursor = style;
}
/////////////////////////////////////////////////
// enableButton()
/////////////////////////////////////////////////
function enableButton(btn, enable)
{
    if (btn == null)
    {
        return;
    }

    if (ourButtonManager == null)
    {
        return;
    }

    if (enable == true)
    {
        ourButtonManager.enableButton(btn);
    }
    else
    {
        ourButtonManager.disableButton(btn);
    }
}
/////////////////////////////////////////////////
// redrawElement()
/////////////////////////////////////////////////
function redrawElement(e)
{
    if (e == null)
    {
        return;
    }

    e.style.display = 'none';
    e.style.display = 'block';
}
/////////////////////////////////////////////////
// displayQueryListSystemNames()
/////////////////////////////////////////////////
function displayQueryListSystemNames(queryID)
{
    var windowWidth  = 325;
    var windowHeight = 310;
    var left         = (screen.width - windowWidth) / 2;
    var top          = (screen.height - windowHeight) / 2;

    window.open("/mxportal/taskandjob/queryListSystemNames.jsp?queryID=" + queryID,
                "systemNames",
                "top=" + top + ",left=" + left + ",width=" + windowWidth + ",height=" + windowHeight, true);
}
/////////////////////////////////////////////////
// displayJobListSystemNames()
/////////////////////////////////////////////////
function displayJobListSystemNames(jobID)
{
    var windowWidth  = 325;
    var windowHeight = 310;
    var left         = (screen.width - windowWidth) / 2;
    var top          = (screen.height - windowHeight) / 2;

    window.open("/mxportal/taskandjob/queryListSystemNames.jsp?jobID=" + jobID,
                "systemNames",
                "top=" + top + ",left=" + left + ",width=" + windowWidth + ",height=" + windowHeight, true);
}
/////////////////////////////////////////////////
// askOption()
/////////////////////////////////////////////////
function askOption(timeStamp)
{
    var windowWidth  = 350;
    var windowHeight = 210;
    var left         = (screen.width - windowWidth) / 2;
    var top          = (screen.height - windowHeight) / 2;

    var windowID     = null;

    windowID = window.open("/mxportal/taskandjob/optionMessage.jsp?taskAndJobTimeStamp=" + timeStamp,
                           "option",
                           "top=" + top + ",left=" + left + ",width=" + windowWidth + ",height=" + windowHeight, true);
    return windowID;
}
/////////////////////////////////////////////////
// checkForInvalidCharacters()
/////////////////////////////////////////////////
function checkForInvalidCharacters(name)
{
    var success = true;

    if (name == null)
    {
        return success;
    }

    var invalidChars  = new Array();
    var i             = 0;
    // These are the only ones we need to check for in the browser, all other
    // invalid characters are checked for in the taskWizardBean.
    invalidChars[i++] = "\"";
    invalidChars[i++] = "\'";
    invalidChars[i++] = "+";
    invalidChars[i++] = "\\";

    for (i = 0; i < name.length; i++)
    {
        var ch = name.charAt(i);

        for (var j = 0; j < invalidChars.length; j++)
        {
            if (ch == invalidChars[j])
            {
                success = false;
            }
        }
    }

    return success;
}
//////////////////////////////
// switchFrames()
//////////////////////////////
function switchFrames()
{
    var iframe  = document.getElementById('jobFormatter');
    var iframe2 = document.getElementById('jobFormatter2');
    var element = null;

    if (currentFormatFrame == FORMAT_FRAME_1)
    {
        iframe2.style.height     = JOBFORMATTER_IFRAME_HEIGHT;
        iframe.style.height      = 0;
        iframe.style.visibility  = 'hidden';
        iframe2.style.visibility = 'visible';

        if (iframe2.contentWindow.setOurIFrameHeight != null)
        {
            iframe2.contentWindow.setOurIFrameHeight();
        }
    }
    else
    {
        iframe.style.height      = JOBFORMATTER_IFRAME_HEIGHT;
        iframe2.style.height     = 0;
        iframe2.style.visibility = 'hidden';
        iframe.style.visibility  = 'visible';

        if (iframe.contentWindow.setOurIFrameHeight != null)
        {
            iframe.contentWindow.setOurIFrameHeight();
        }
    }

    currentFormatFrame = !currentFormatFrame;
}
//////////////////////////////
// getIframeTop()
//////////////////////////////
function getIframeTop(doc)
{
    if (doc == null)
    {
        return null;
    }

    // if we find this constant, this is the parent page
    if (doc.IFRAME_TOP != null)
    {
        return doc;
    }

    // look one level up
    return getIframeTop(doc.parent);
}
//////////////////////////////
// setMinWidth()
//////////////////////////////
function setMinWidth(minWidth)
{
    var doc = getIframeTop(this);

    if (doc.minWidth < minWidth)
    {
        doc.minWidth = minWidth;
    }
}
