/////////////////////////////////////////////////
// defines for the Target Selection Page
/////////////////////////////////////////////////
var EVENT_LISTS           = 0;
var SYSTEM_LISTS          = 1;
var BOTH_LISTS            = 2;

var ITEM_TYPE_NODE        = 0;
var ITEM_TYPE_QUERY       = 1;
var ITEM_TYPE_COLLECTION  = 2;
var ITEM_TYPE_GROUP       = 3;

/////////////////////////////////////////////////
// displaySelectTargetsButtons()
/////////////////////////////////////////////////
function displaySelectTargetsButtons()
{
    document.write("<br>");
    document.write("<table id='topButtonTable' border='0' cellspacing='0' cellpadding='0' style='width:100%'>");
    document.write("<tr>");
    document.write("<td style='width:100%' nowrap></td>");
    document.write("<td id='btn1' align='right' nowrap></td>");
    document.write("<td id='btn2' align='right' nowrap></td>");
    document.write("<td id='btn2_1' align='right' nowrap></td>");
    document.write("<td id='btn3' align='right' nowrap></td>");
    document.write("<td id='btn4' align='right' nowrap></td>");
    document.write("</tr>");
    document.write("</table>");

    document.write("<table id='bottomButtonTable' border='0' cellspacing='0' cellpadding='0' style='width:100%'>");
    document.write("<tr id='hrRow' style='visibility:hidden'>");
    document.write("<td colspan='3'><hr></td>")
    document.write("</tr>");
    document.write("<tr id='applyRow' style='visibility:hidden'>");
    document.write("<td nowrap style='width:100%' valign='bottom'><b>");
    document.write(addTargetsBy);
    document.write("</b></td>");
    document.write("<td id='btn1b' align='right' nowrap></td>");
    document.write("<td id='btn2b' align='right' nowrap></td>");
    document.write("</tr>");
    document.write("</table>");

    if ((nodesSelected == true) || (nodesRequired == false))
    {
        // If this tool has defined "lockTargetSelection", then don't display
        // 'Add Targets' or 'Remove Targets' button; Do this only if we are from
        // Task Wizard
        if (selectionLocked == false)
        {
            populateButtonCell(document.getElementById("btn2"), BTN_ADD_TARGETS);
            populateButtonCell(document.getElementById("btn2_1"), BTN_REMOVE_TARGETS);
        }

        populateButtonCell(document.getElementById("btn1b"), BTN_NO_BUTTON);
    }
    else
    {
        populateButtonCell(document.getElementById("btn2"), BTN_NO_BUTTON);
        populateButtonCell(document.getElementById("btn1b"), BTN_NO_BUTTON);
        populateButtonCell(document.getElementById("btn2b"), BTN_APPLY_TARGETS, null, null, "applyTop");
    }

    // default settings for "user custom button 3"
    if (btn3Text == 'null')
    {
        populateButtonCell(document.getElementById("btn1"), BTN_NO_BUTTON);
    }
    else
    {
        populateButtonCell(document.getElementById("btn1"), BTN_CUSTOM_3, btn3Text, btn3Function);
    }

    // default settings for "user custom button 1"
    if (btn1Text == 'null')
    {
        populateButtonCell(document.getElementById("btn3"), BTN_NO_BUTTON);
    }
    else
    {
        populateButtonCell(document.getElementById("btn3"), BTN_CUSTOM_1, btn1Text, btn1Function);
    }

    // default settings for "user custom button 2"  "Next Button"
    if (btn2Text == 'null')
    {
        populateButtonCell(document.getElementById("btn4"), BTN_NO_BUTTON);
    }
    else
    {
        populateButtonCell(document.getElementById("btn4"), BTN_CUSTOM_2, btn2Text, btn2Function);
    }
}
/////////////////////////////////////////////////
// displaySelectTargetsBottomButtons()
/////////////////////////////////////////////////
function displaySelectTargetsBottomButtons()
{
    document.write("<table id='bottomButtons' border='0' cellspacing='0' cellpadding='0' style='width:100%; visibility:hidden'>");
    document.write("<tr>");
    document.write("<td style='width:100%' nowrap></td>");
    document.write("<td id='btn1c' align='right' nowrap></td>");
    document.write("<td id='btn2c' align='right' nowrap></td>");
    document.write("</tr>");
    document.write("</table>");

    if ((nodesSelected == true) || (nodesRequired == false))
    {
        populateButtonCell(document.getElementById("btn1c"), BTN_CANCEL_TARGETS, null, null, "cancelBottom");
        populateButtonCell(document.getElementById("btn2c"), BTN_APPLY_TARGETS, null, null, "applyBottom");
    }
    else
    {
        populateButtonCell(document.getElementById("btn1c"), BTN_NO_BUTTON);
        populateButtonCell(document.getElementById("btn2c"), BTN_APPLY_TARGETS, null, null, "applyBottom");
    }
}
/////////////////////////////////////////////////
// showDivider()
/////////////////////////////////////////////////
function showDivider(show)
{
    var e1 = document.getElementById('hrRow');
    var e2 = document.getElementById('applyRow');

    if (show == true)
    {
        e1.style.visibility = 'visible';
        e2.style.visibility = 'visible';
    }
    else
    {
        e1.style.visibility = 'hidden';
        e2.style.visibility = 'hidden';
    }
}
/////////////////////////////////////////////////
// removeNodes()
/////////////////////////////////////////////////
function removeNodes()
{
    ourButtonManager.disableButtonById("remove");
    // disable the "Remove Targets" button
    document.getElementById("action").contentWindow.document.location.replace("/mxportal/taskandjob/removeSelectedNodes.jsp?timeStamp=" + timeStamp);
}
/////////////////////////////////////////////////
// populateButtonCell()
/////////////////////////////////////////////////
function populateButtonCell(cell, btn, customBtnText, customBtnFunction, btnID)
{
    var html = "";
    var id   = "";

    if ((customBtnFunction == null) || (customBtnFunction == 'null'))
    {
        customBtnFunction = "";
    }

    switch (btn)
    {
        case BTN_REMOVE_TARGETS:
            id   = (btnID == null) ? "remove" : btnID;
            html = ourButtonManager.makeMxButtonMed(id, removeTargets, 'removeNodes()', false, false, true);
            break;
        case BTN_APPLY_TARGETS:
            id   = (btnID == null) ? "apply" : btnID;
            html = ourButtonManager.makeMxButtonMed(id, apply, 'applyChangeTargets()', false, false, true);
            break;
        case BTN_CANCEL_TARGETS:
            id   = (btnID == null) ? "cancel" : btnID;
            html = ourButtonManager.makeMxButton(id, cancel, 'toggleChangeTargets()');
            break;
        case BTN_ADD_TARGETS:
            id   = (btnID == null) ? "add" : btnID;
            html = ourButtonManager.makeMxButton(id, addTargets, 'toggleChangeTargets()');
            break;
        case BTN_CUSTOM_1:  // NEXT/SCHEDULE/RUNNOW
            id   = (btnID == null) ? "customBtn1" : btnID;
            // if we are not from the task wizard, then wrap this custom function in our function
            // to allow for the popup dialog to remove invalid targets
            if (taskWizard == null)
            {
                html = ourButtonManager.makeMxButton(id, customBtnText, "wrapperFunction1()");
            }
            else
            {
                html = ourButtonManager.makeMxButton(id, customBtnText, customBtnFunction);
            }
            break;
        case BTN_CUSTOM_2:  // NEXT/SCHEDULE/RUNNOW
            id   = (btnID == null) ? "customBtn2" : btnID;
            // if we are not from the task wizard, then wrap this custom function in our function
            // to allow for the popup dialog to remove invalid targets
            if (taskWizard == null)
            {
                html = ourButtonManager.makeMxButton(id, customBtnText, "wrapperFunction2()");
            }
            else
            {
                html = ourButtonManager.makeMxButton(id, customBtnText, customBtnFunction);
            }
            break;
        case BTN_CUSTOM_3:  // PREVIOUS
            id   = (btnID == null) ? "customBtn3" : btnID;
            // if we are not from the task wizard, then wrap this custom function in our function
            // to allow for the popup dialog to remove invalid targets
            if (taskWizard == null)
            {
                html = ourButtonManager.makeMxButton(id, customBtnText, "wrapperFunction3()");
            }
            else
            {
                html = ourButtonManager.makeMxButton(id, customBtnText, customBtnFunction);
            }
            break;
        case BTN_NO_BUTTON:
        default:
            break;
    }

    if (cell != null)
    {
        cell.innerHTML = html;
    }

    if (btn != BTN_NO_BUTTON)
    {
        ourButtonManager.initButtonById(id);

        if (btn == BTN_REMOVE_TARGETS)
        {
            // if there are selected items, be sure the "remove" button is properly enabled
            var num = document.getElementById("nodeBucket").contentWindow.numSelectedRows;

            if (num > 0)
            {
                ourButtonManager.enableButtonById(id);
            }
        }
    }
}
/////////////////////////////////////////////////
// buildApplyChangeBaseURL()
/////////////////////////////////////////////////
function buildApplyChangeBaseURL()
{
    var urlParams = "?";

    if ((btn1Text != null) && (btn1Text != ""))
    {
        urlParams += ("btn1Text=" + encodeURIComponent(btn1Text) + "&btn1Function=" + btn1Function + "&");
    }

    if ((btn2Text != null) && (btn2Text != ""))
    {
        urlParams += ("btn2Text=" + encodeURIComponent(btn2Text) + "&btn2Function=" + btn2Function + "&");
    }

    if ((btn3Text != null) && (btn3Text != ""))
    {
        urlParams += ("btn3Text=" + encodeURIComponent(btn3Text) + "&btn3Function=" + btn3Function + "&");
    }

    urlParams += ("listType=" + listType + "&");

    // need to add selectionType
    urlParams += ("selectionType=" + selectionType + "&");

    // add timeStamp
    urlParams += ("timeStamp=" + timeStamp);

    return urlParams;
}
/////////////////////////////////////////////////
// buildURLString()
/////////////////////////////////////////////////
function buildURLString()
{
    var urlParams = null;

    // if we're running for the Task Wizard - maintain all of its parameters
    if (parent.PARENT_PAGE != null)
    {
        urlParams = parent.buildWizardParams();
    }
    else // otherwise - maintain all parmeters important to us
    {
        urlParams = buildApplyChangeBaseURL();
    }

    urlParams += "&apply=1";

    return urlParams;
}
/////////////////////////////////////////////////
// applyChangeTargets()
/////////////////////////////////////////////////
function applyChangeTargets()
{
    // if we have tree shown, do selectGroup.jsp, and have that file then call this function to perform actual "apply"
    //
    // look for displayFunction() on "displayGroupContents.jsp" in the "selectionFrame" <IFRAME>, which
    // in in the "targetSelectionMenu" <IFRAME>
    //
    // If this function is found, call it and exit.  The function will call this function again after
    // it has removed the displayFunction() this function looks for
    var iframe = document.getElementById("targetSelectionMenu").contentWindow.document.getElementById("selectionFrame");

    if ((iframe != null) && (iframe.contentWindow.applyFunction != null))
    {
        iframe.contentWindow.applyFunction();
        return;
    }

    showBottomButtons(false);
    location.replace("/mxportal/taskandjob/targetSelection.jsp" + buildURLString());
}
/////////////////////////////////////////////////
// toggleChangeTargets()
/////////////////////////////////////////////////
function toggleChangeTargets()
{
    var iframe = document.getElementById("targetSelectionMenu");

    if (changeTargetsOpen == true)
    {
        // we are closing the "Change Targets Page" using the "Cancel" button
        // Therefore, restore the Global selection to that the Task Wizard
        // has saved
        var action = document.getElementById("action");
        action.contentWindow.document.location.replace("/mxportal/taskandjob/restoreGlobalSelection.jsp?timeStamp=" + this.timeStamp);

        iframe.style.visibility = "hidden";
        changeTargetsOpen       = false;

        // set dropdown back to initial selection
        iframe.contentWindow.document.getElementById("listSelector2").options[0].selected = true;
        // ensure checkbox for "entire" is unchecked
        clearCheckbox(iframe.contentWindow);
        showEntireCheckbox(false, iframe.contentWindow);

        // get the selectionFrame <iframe> and set to MxBlank and "hidden"
        iframe = iframe.contentWindow.document.getElementById("selectionFrame");
        iframe.contentWindow.document.location.replace("/mxportal/home/MxBlank.html");
        iframe.style.visibility = "hidden";

        showDivider(false);
        showBottomButtons(false);

        populateButtonCell(document.getElementById("btn2"), BTN_ADD_TARGETS);
        populateButtonCell(document.getElementById("btn2_1"), BTN_REMOVE_TARGETS);
        populateButtonCell(document.getElementById("btn1b"), BTN_NO_BUTTON);
        populateButtonCell(document.getElementById("btn2b"), BTN_NO_BUTTON);

        // if the user "cancel"'s changes, enable the "Next" & "Prev" buttons
        // only do this if there are no fail reasons listed in The Bucket
        var bucketIframe = document.getElementById("nodeBucket");

        if ((bucketIframe == null) || (bucketIframe.contentWindow.allAreInvalidSelections() == false))
        {
            ourButtonManager.enableButtonById('customBtn3'); // PREV
            ourButtonManager.enableButtonById('customBtn1'); // SCHEDULE
            ourButtonManager.enableButtonById('customBtn2'); // NEXT
        }
    }
    else
    {
        iframe.style.visibility = "visible";
        changeTargetsOpen       = true;

        showDivider(true);

        populateButtonCell(document.getElementById("btn2"), BTN_NO_BUTTON);
        populateButtonCell(document.getElementById("btn2_1"), BTN_NO_BUTTON);
        populateButtonCell(document.getElementById("btn1b"), BTN_CANCEL_TARGETS);
        populateButtonCell(document.getElementById("btn2b"), BTN_APPLY_TARGETS, null, null, "applyTop");

        // while the user is making changes, we'll disable the "Next" & "Prev" buttons
        ourButtonManager.disableButtonById('customBtn3'); // PREV
        ourButtonManager.disableButtonById('customBtn1'); // SCHEDULE
        ourButtonManager.disableButtonById('customBtn2'); // NEXT
    }
}
/////////////////////////////////////////////////
// clearCheckbox()
/////////////////////////////////////////////////
function clearCheckbox(iframe)
{
    var cb  = null;
    var doc = this;

    if (iframe != null)
    {
        doc = iframe;
    }

    cb = doc.document.getElementById('entireCheckbox');

    if (cb.src.indexOf(doc.checkMarks[doc.CHECKMARK_SELF]) != -1)
    {
        cb.src = doc.checkMarks[doc.CHECKMARK_EMPTY];
    }
}
/////////////////////////////////////////////////
// selectEntireGroup()
/////////////////////////////////////////////////
function selectEntireGroup()
{
    var checked = false;
    var cb      = document.getElementById('entireCheckbox');

    if (cb.src.indexOf(checkMarks[CHECKMARK_EMPTY]) != -1)
    {
        cb.src  = checkMarks[CHECKMARK_SELF];
        checked = true;
    }
    else
    {
        cb.src  = checkMarks[CHECKMARK_EMPTY];
    }

    // item:
    //  queryID = id
    //     node = node
    //
    // select    == true | false (req)
    // id        == queryID | collectionID | groupID
    // type      == selection type (req)
    //    node       : name
    //    query      : id
    //    collection : id (using 'name' in ALPHA)
    // timestamp == timestamp (req)
    // name      == name
    //
    // QUAKE BETA - if ID == 0, treat as MxCollection
    var select = document.getElementById("listSelector2");

    var id     = getSelectedGroupID(select);
    var type   = getSelectedGroupType(select);

    var params  = "?select="    + checked;          // true | false
        params += "&id="        + id;               // groupID
        params += "&type="      + type;             // groupType
        params += "&timeStamp=" + parent.timeStamp; // timeStamp

    // QUAKE BETA - TO BE REMOVED - get the name of the "collection" to populate dummy collection
    params += "&name=" + encodeURIComponent(getSelectedGroupName(select));

    // select the LIST in the Global Selection Object
    document.getElementById("action").contentWindow.document.location.replace("/mxportal/taskandjob/selectGroup.jsp" + params);

    if (checked == true)
    {
        // hide node list
        document.getElementById("selectionFrame").contentWindow.document.location.replace("/mxportal/home/MxBlank.html");
        // hide the "Cancel" and "Apply" buttons at the bottom of the page
        showBottomButtons(false);
    }
    else
    {
        // show node list
        checkListSelection(bNoAuth);
        // hide the "Cancel" and "Apply" buttons at the bottom of the page
        showBottomButtons(true);
    }

    // give param to "enable/disable apply button"
    // selectGroup.jsp will enable this button after it is finished
    // selecting the entire group
    parent.enableApplyButton(false);
}
/////////////////////////////////////////////////
// checkListSelection() INDIVIDUAL NODES SELECTED
/////////////////////////////////////////////////
function checkListSelection(noAuth)
{
    // &nbsp; ==> character code = 160

    // because the "index" is not a numeric number - we don't
    // have to obtain the 'text' from the element.  It is
    // the select.value we want (text value)
    var select          = document.getElementById("listSelector2");
    var listIndex       = select.value;

    // whenever the dropdown is changed, uncheck the "entire" checkbox
    clearCheckbox();

    // blank out any showing list
    document.getElementById("selectionFrame").contentWindow.document.location.replace("/mxportal/home/MxBlank.html");

    // always hide these, they will be displayed if required
    showEntireCheckbox(false);
    bShowEntireCheckbox = false;
    showBottomButtons(false);

    // if "index" == 0, then hide "selectionFrame" and "select entire" checkbox
    if (listIndex == 0)
    {
        // QUAKE "- select -" initial option
        // disable buttons
        ourButtonManager.disableButton(parent.document.getElementById('applyTop'));
        ourButtonManager.disableButton(parent.document.getElementById('applyBottom'));
    }
    else
    {
        // set timeout to perform new list selection: set to 2s for Mozilla browsers
        var timeout = 0;

        if (MxBrowserIsGecko() == true)
        {
            timeout = IFRAME_SWITCH_TIMEOUT;
        }

        // only show the "entire" checkbox if the selectionType is empty
        // OR contains "list"
        if ((parent.selectionType == "") || ((parent.selectionType.indexOf("list") != -1) && (listIndex.indexOf("query") != -1)))
        {
            bShowEntireCheckbox = true;
            // update text to "select entire"
            updateSelectionText(select);
        }

        // only show the "entire" checkbox if the selectionType is empty
        // OR contains "collection"
        if ((parent.selectionType == "") || ((parent.selectionType.indexOf("collection") != -1) && (listIndex.indexOf("collection") != -1)))
        {
            bShowEntireCheckbox = true;
            // update text to "select entire"
            updateSelectionText(select);
        }

        // disable the "APPLY" button
        ourButtonManager.disableButton(parent.document.getElementById('applyTop'));
        ourButtonManager.disableButton(parent.document.getElementById('applyBottom'));

        var func = null;

        // if it is not a Query selected, show the contents of the Collection
        if (listIndex.indexOf("queryID=") == -1)
        {
            func = "displayCollection('" + listIndex + "', " + noAuth + ");";
            // QUAKE - display contents of Collection
            setTimeout(func, timeout);
            // show the "Cancel" and "Apply" buttons at the bottom of the page
            showBottomButtons(true);
        }
        else
        {
            // display the contents of Query
            // if selectionType doesn't contain "individual", don't show node list
            if ((parent.selectionType == "") || (parent.selectionType.indexOf("individual") != -1))
            {
                // if we are going to show a NODE LIST, then restore the global selection
                // with what we already have selected.  If it is an Event List that is selected
                // the NODE LIST will clear out the global selection before rendering
                document.getElementById("action").contentWindow.document.location.replace("/mxportal/taskandjob/restoreGlobalSelection.jsp?timeStamp=" + parent.timeStamp);

                func = "displayNodeList('" + listIndex + "', " + noAuth + ");";

                setTimeout(func, timeout);
                // show the "Cancel" and "Apply" buttons at the bottom of the page
                showBottomButtons(true);
            }
            else
            {
                // since we're not going to show the node list, then we need to show the "itself" checkbox
                showEntireCheckbox(bShowEntireCheckbox);
            }
        }
    }
}
/////////////////////////////////////////////////
// showEntireCheckbox()
/////////////////////////////////////////////////
function showEntireCheckbox(show, iframe)
{
    var doc = this;

    if (iframe != null)
    {
        doc = iframe;
    }

    var display = 'visible';

    if ((show != null) && (show == false))
    {
        display = 'hidden';
    }

    doc.document.getElementById("entireCheckbox").style.visibility = display;
    doc.document.getElementById("entireText").style.visibility     = display;
}
/////////////////////////////////////////////////
// updateSelectionText()
/////////////////////////////////////////////////
function updateSelectionText(select)
{
    document.getElementById("entireText").innerHTML = '&nbsp;<b>' + parent.selectText + ' "' + getSelectedGroupName(select) + '" ' + parent.itselfText + '</b>';
}
/////////////////////////////////////////////////
// selectBaseCollection()
/////////////////////////////////////////////////
function selectBaseCollection()
{
    var timeout = 0;

    if (MxBrowserIsGecko() == true)
    {
        timeout = IFRAME_SWITCH_TIMEOUT;
    }

    setTimeout("displayCollection()", timeout);
}
/////////////////////////////////////////////////
// displayCollection()
/////////////////////////////////////////////////
function displayCollection(listIndex, noAuth)
{
    // collectionID ; collectionName ; contextPath
    var params = null;
    var oID    = null;
    var iframe = null;
    var height = parent.clientHeight;

    var url    = "/mxportal/taskandjob/displayGroupContents.jsp?";

    if (listIndex != null)
    {
        params = listIndex.split(";");
        oID    = params[0].split("=");

        url   += "collectionID=";
        url   += oID[1];
        url   += "&";
    }

    url   += "listType=";
    url   += parent.listType;
    url   += "&selectionType=";
    url   += parent.selectionType;

    url   += "&timeStamp=";
    url   += parent.timeStamp;
    url   += "&height=";
    url   += (height - 85);

    if ((noAuth != null) && (noAuth == true))
    {
        url += "&noAuth=1";
    }

    // resize the Target Selection Menu <iframe> to accomidate a nodelist
    iframe = parent.document.getElementById("targetSelectionMenu");
    if (height != null)
    {
        iframe.style.height = height + 35;
        redrawElement(iframe);
    }

    iframe = document.getElementById("selectionFrame");
    iframe.style.width = '100%';

    // change the height of the <iframe> to accomidate a nodelist
    if (height != null)
    {
        iframe.style.height = height - 25;
        redrawElement(iframe);
    }

    iframe.style.visibility = "visible";

    iframe.contentWindow.document.location.replace(url);

    // now display the "Cancel" and "Apply" buttons at the bottom of the page
    iframe = parent.document.getElementById('targetSelectionMenu');

    if (iframe.style.visibility == 'visible')
    {
        showBottomButtons(true);
    }
}
/////////////////////////////////////////////////
// displayNodeList()
/////////////////////////////////////////////////
function displayNodeList(listIndex, noAuth)
{
    var listID   = null;
    var listName = null;
    var listType = null;

    // queryID & queryName
    var params = listIndex.split(";");

    listID     = params[0].split("=");
    listName   = params[1].split("=");
    listType   = params[2].split("=");

    var pageName = null;

    if (listType[1] == "DeviceViews")
    {
        pageName = "viewContentsDevices";
    }
    else if (listType[1] == "ClusterViews")
    {
        pageName = "viewContentsClusters";
    }
    else if (listType[1] == "EventViews")
    {
        pageName        = "viewContentsEvents";
    }

    var queryID      = listID[1];
    var topMenuIndex = 1;

    var url = "/ui/jsp/XeHdr.jsp";

    var params  = "PageName="      + pageName;
    params     += "&viewid="       + queryID;
    params     += "&topMenuIndex=" + topMenuIndex;
    params     += "&ViewType="     + listType[1];

    params     += "&suppressInteractionButtons=1";
    params     += "&suppressSaveAs=1";
    params     += "&suppressCustomize=1";
    params     += "&suppressViewAs=1";
    params     += "&suppressHeader=1";
    params     += "&selectionOnly=1";

    params     += "&timeStamp=" + parent.timeStamp;

    if ((noAuth != null) && (noAuth == true))
    {
        params += "&authFilter=false";
    }

    url += "?" + params;

    // disable the "APPLY" button
    ourButtonManager.disableButton(parent.document.getElementById('applyTop'));
    ourButtonManager.disableButton(parent.document.getElementById('applyBottom'));

    // display selected list
    var iframe = null;
    var height = parent.clientHeight;

    // resize the Target Selection Menu <iframe> to accomidate a nodelist
    iframe = parent.document.getElementById("targetSelectionMenu");
    if (height != null)
    {
        iframe.style.height = height + 35;
        redrawElement(iframe);
    }

    iframe = document.getElementById("selectionFrame");
    iframe.style.width = '100%';

    // change the height of the <iframe> to accomidate a nodelist
    if (height != null)
    {
        iframe.style.height = height - 25;
        redrawElement(iframe);
    }

    iframe.style.visibility = "visible";

    iframe.contentWindow.document.location.replace(url);

    // now display the "Cancel" and "Apply" buttons at the bottom of the page
    iframe = parent.document.getElementById('targetSelectionMenu');

    if (iframe.style.visibility == 'visible')
    {
        showBottomButtons(true);
    }
}
/////////////////////////////////////////////////
// getSelectedGroupName()
//
// ID   = params[0]
// NAME = params[1];
// TYPE = params[2];
//
/////////////////////////////////////////////////
function getSelectedGroupName(select)
{
    if (select == null)
    {
        return null;
    }

    var params   = select.value.split(";");
    var listName = params[1].split("=");

    return listName[1];
}
/////////////////////////////////////////////////
// getSelectedGroupID()
//
// ID   = params[0]
// NAME = params[1];
// TYPE = params[2];
//
/////////////////////////////////////////////////
function getSelectedGroupID(select)
{
    if (select == null)
    {
        return null;
    }

    var params = select.value.split(";");
    var listID = params[0].split("=");

    return listID[1];
}
/////////////////////////////////////////////////
// getSelectedGroupType()
/////////////////////////////////////////////////
function getSelectedGroupType(select)
{
    if (select == null)
    {
        return;
    }

    var value = select.value;

    if (value.indexOf("queryID=") != -1)
    {
        return ITEM_TYPE_QUERY;
    }
    else if (value.indexOf("collectionID=") != -1)
    {
        return ITEM_TYPE_COLLECTION;
    }
    else
    {
        return ITEM_TYPE_GROUP;
    }
}
/////////////////////////////////////////////////
// showBottomButtons()
/////////////////////////////////////////////////
function showBottomButtons(show)
{
    var table = document.getElementById('bottomButtons');

    // if table == null, try one level up
    if (table == null)
    {
        table = parent.document.getElementById('bottomButtons');
    }

    // if it is still null, then don't do anything
    if (table == null)
    {
        return;
    }

    if (show == true)
    {
        table.style.visibility = 'visible';
    }
    else
    {
        table.style.visibility = 'hidden';
    }
}
///////////////////////////////
// removeInstance()
///////////////////////////////
function removeInstance(timeStamp)
{
    document.getElementById("action").contentWindow.document.location.replace("/mxportal/taskandjob/removeTaskWizardInstance.jsp?timeStamp=" + timeStamp);
}
