<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="portalBean" class="com.hp.mx.portal.ui.MxPortalBean" scope="session" />

<%@ page import="com.hp.mx.core.client.MxJobClient"%>
<%@ page import="com.hp.mx.core.jobmanager.MxJob"%>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID"%>
<%@ page import="com.hp.mx.core.objectmodel.MxGUID"%>
<%@ page import="com.hp.mx.dtf.MxTargetStatus"%>
<%@ page import="com.hp.mx.html.core.MxButtons"%>
<%@ page import="com.hp.mx.html.core.MxDefaultTag"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.portal.core.MxObjList"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxCollectionExpander"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxListToSystemNames"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>
<%@ page import="java.util.List"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    MxTaskAndJobResourceBundle rb = new MxTaskAndJobResourceBundle(loginBean.getLocale());

    // If queryID == null, then get the list of comma separates nodes on the URL <-- HERE
    String queryID   = request.getParameter("queryID");
    String jobID     = request.getParameter("jobID");
    String nodes     = request.getParameter("nodes");

    // if jobID != null, get raw-targets from jobObject
    if (jobID != null)
    {
        MxJobClient jobClient = loginBean.getJobClient();
        MxJob       job       = null;

        try
        {
            job = jobClient.getJob(jobID);
        }
        catch (Throwable e)
        {
        }

        if (job != null)
        {
            MxTargetStatus status[] = job.getTargetStatusArrayReadOnly();
            StringBuffer   buf      = new StringBuffer(300);

            for (int i = 0; i < status.length; i++)
            {
                buf.append(status[i].getHostname());

                if ((i + 1) < status.length)
                {
                    buf.append(",");
                }
            }

            nodes = buf.toString();
        }
    }

    // if the windowID is passed, read comma-separated node list from the portalBean
    String windowID = request.getParameter("windowID");

    if (windowID != null)
    {
        MxObjList list = portalBean.retrieveSelectionsById(windowID, loginBean);
        nodes          = list.toCommaSepList(MxObjList.USE_HOST_NAMES).toString();
    }

    MxListToSystemNames  queryNames      = new MxListToSystemNames(loginBean, 0);
    MxCollectionExpander collectionNames = new MxCollectionExpander(loginBean);
    List                 systemNames     = null;
    String               groupName       = null;

    // this LUID could be an MxCollection or a Query MxObjectID
    if (queryID != null)
    {
        // if the "queryID" is < 1000, then it's a INT
        if (queryID.length() != 32) // digits
        {
            if (queryNames.setQueryID(Integer.parseInt(queryID)) == true)
            {
                systemNames = queryNames.executeQuery();
                groupName   = queryNames.getQueryName();
            }
        }
        else
        {
            MxObjectID oid = new MxObjectID(new MxGUID(queryID));

            if (queryNames.setQueryOID(oid) == true)
            {
                systemNames = queryNames.executeQuery();
                groupName   = queryNames.getQueryName();
            }

            if (collectionNames.setCollection(oid) == true)
            {
                systemNames  = collectionNames.getCollectionMembersNames();
                groupName    = collectionNames.getCollection().getDisplayName(loginBean.getLocale());
            }
        }
    }
    else if (nodes != null)
    {
        queryNames.setQueryNames(nodes);
        systemNames = queryNames.getSystemNames();
    }

    StringBuffer title          = new StringBuffer(100);
    int          tableHeight    = 190;
    int          MAX_LIST_WIDTH = 32;
    int          ROW_HEIGHT     = 22;

    if (groupName != null)
    {
        title.append(rb.getString("QUERY_LIST_1"));
        title.append(" <b>");
        // we'll add one character at a time.  if we have not
        // encountered a space by the time we reach the end
        // of a line, then we'll insert a hyphen (-) and a space ( )
        // and continue; otherwise, we'll just continue.
        boolean foundSpace = false;

        for (int i = 0; i < groupName.length(); i++)
        {
            char ch = groupName.charAt(i);

            if (ch == ' ')
            {
                foundSpace = true;
            }

            title.append(ch);

            if (((i + 1) % MAX_LIST_WIDTH) == 0)
            {
                if (foundSpace == false)
                {
                    title.append("- ");
                }
                else
                {
                    foundSpace = false;
                }
            }
        }

        // calculate table height for systems listed
        int rows = (title.length() / MAX_LIST_WIDTH) - 1;
        tableHeight -= (rows * ROW_HEIGHT);

        title.append("</b> ");
        title.append(rb.getString("QUERY_LIST_2"));
        title.append(":");
    }
    else
    {
        title.append(rb.getString("QUERY_LIST_3"));
        title.append(":");
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("closeBtn", rb.getString("OK_BUTTON"), "window.close()"));
%>

<html>
    <head>
        <title>
<%
    if (groupName != null)
    {
        %><%= groupName %><%
    }
%>
        </title>
        <link type='text/css' rel='stylesheet' href='<%= MxOptions.URL_BASE %>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            // focusMe()
            function focusMe()
            {
                setTimeout('self.focus()', SELF_FOCUS_CHECK_TIMEOUT);
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    buttons.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onload='focusMe()' marginwidth='0'
                             marginheight='0'
                             topmargin='0'
                             bottommargin='0'
                             leftmargin='0'
                             rightmargin='0'>
        <br>
        <table border='0' cellspacing='0' cellpadding='0' style='width:325'>
            <tr>
                <td rowspan='5' style='width:5'></td>
                <td style='width:250' align='left'><%= title.toString() %></td>
                <td rowspan='5' style='width:5'></td>
            </tr>
            <tr>
                <td>&nbsp;</td>
            </tr>
            <tr>
                <td valign='top' class='schedule-td' style='width:315; height:<%= tableHeight %>'>
                    <div style='height:<%= tableHeight %>; width:315; overflow:auto'>
                        <table border='0' cellspacing='0' cellpadding='0' style='width:295'>
<%
    if (systemNames != null)
    {
        StringBuffer buf = new StringBuffer(500);

        for (int i = 0; i < systemNames.size(); i++)
        {
            buf.append("<tr>");
            buf.append("<td style='width:3' nowrap></td>");
            buf.append("<td nowrap>");
            buf.append(systemNames.get(i));
            buf.append("</td>");
            buf.append("<td style='width:3' nowrap></td>");
            buf.append("</tr>");
        }

        try
        {
            out.println(buf.toString());
        }
        catch (Throwable e)
        {
        }
    }
%>
                        </table>
                    </div>
                </td>
            </tr>
            <tr>
                <td>&nbsp;</td>
            </tr>
        </table>

        <div style="margin-top:15px;margin-right:15px">
<%
    buttons.dumpButtons(out);
%>
        </div>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
