<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>
<jsp:useBean id="selectionBean" class="com.hp.mx.portal.core.MxObjSelections" scope="session"/>

<%@ page import="com.hp.mx.html.core.MxButton"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    int     success    = MxTaskWizardInstance.NO_SAVE_ERROR;
    boolean apply      = (request.getParameter("apply") != null);
    boolean prev       = (request.getParameter("prev") != null);
    boolean err        = (request.getParameter("err") != null);
    String  taskWizard = request.getParameter("taskWizard");
    String  snapOff    = request.getParameter("snapoff");

    String               timeStamp  = request.getParameter("timeStamp");
    MxTaskWizardInstance inst       = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    // if we are back from a "Prev", then restore 'myWizardSelections'
    if (prev == true)
    {
        inst.restoreGlobalSelection();
    }

    // Save the MxObjSelections (global selection object) to the MxTaskWizardInstance associated
    // with the "timestamp" value passed in.  Create an MxTaskWizardInstance if one is not found;
    // this is true when actions use the Target Selection Page outside of the Task Wizard
    //
    // If the MxTaskWizardInstance is created for a snapOff window, then the global selection object
    // will be cloned and will not affect the global selection object associated with the main
    // SIM portal window
    //
    // "listCleared" - this param may be depricated.  If a tool indicated that it did not
    // want the user to be able to make "List" selections, (MAX TARGETS) any selected List
    // would be removed from the global selection so it would not be initially displayed in the
    // node bucket
    //
    int maxTargets = MxTaskWizardInstance.NO_MAX_TARGETS;
    //
    // NO NEED TO DO this if we are back from a PREV or APPLY
    if ((apply == false) && (prev == false) && (err == false))
    {
        // check for a "max-targets" on the URL.  Set in the Wizard if found.
        //
        // MAX TARGETS implies a restriction for INDIVIDUAL selection.
        //
        if (request.getParameter("max-targets") != null)
        {
            try
            {
                maxTargets = Integer.parseInt(request.getParameter("max-targets"));
            }
            catch (Throwable e)
            {
            }
        }
        else
        {
            if (inst != null)
            {
                maxTargets = inst.getMaxTargets();
            }
        }

        taskWizardBean.initTargetSelection(selectionBean, loginBean, (taskWizard != null), timeStamp, maxTargets, snapOff);

        // re-get the instance object, in case it was just created
        inst = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);
    }
    else
    {
        maxTargets = inst.getMaxTargets();
    }

    // now get the resource bundle
    MxTaskAndJobResourceBundle rb = inst.getRB();

    // if applying, set selection - else, get selection
    if (apply == true)
    {
        // clear the flag to show the Task Edit Message
        inst.clearEditTaskMessage();
    }

    // save any new selected Nodes - grab the GLOBAL selection, which should have been
    // set if we are editing a Task, otherwise use existing for new Task
    success = inst.saveSelectedNodes();

    String selectedNodes = inst.getSelectedNodesString();

    // get filtering requests
    String listType      = request.getParameter("listType");
    String selectionType = request.getParameter("selectionType");

    // ensure "selectionType" is a supported value
    if (selectionType == null)
    {
        if (maxTargets == MxTaskWizardInstance.NO_MAX_TARGETS)
        {
            selectionType = "";
        }
        else
        {
            selectionType = "individual";
        }
    }
    else
    {
        // check for valid values
        if ((selectionType.equalsIgnoreCase("list")            == false) &&
            (selectionType.equalsIgnoreCase("individual")      == false) &&
            (selectionType.equalsIgnoreCase("collection")      == false) &&
            (selectionType.equalsIgnoreCase("list collection") == false) &&
            (selectionType.equalsIgnoreCase("collection list") == false))
        {
            selectionType = "";
        }
    }

    // ensure "listType" is a supported value
    if (listType == null)
    {
        listType = "systemLists eventLists";
    }
    else
    {
        // check for valid values
        if ((listType.equalsIgnoreCase("systemLists") == false) &&
            (listType.equalsIgnoreCase("eventLists")  == false))
        {
            listType = "systemLists eventLists";
        }
    }

    // check for custom button text & function
    String btn1Text       = request.getParameter("btn1Text");
    String btn1Function   = request.getParameter("btn1Function");
    // This is the one that will be used by developers
    String btn2Text       = request.getParameter("btn2Text");
    String btn2Function   = request.getParameter("btn2Function");
    // 3rd custom button
    String btn3Text       = request.getParameter("btn3Text");
    String btn3Function   = request.getParameter("btn3Function");

    // check for flag that informs this page not to enforce a non-empty bucket
    String  targetsRequired = request.getParameter("targetsRequired");
    boolean nodesRequired   = true;

    if ((targetsRequired != null) && (targetsRequired.equals("false") == true))
    {
        nodesRequired = false;
    }

    int     numSelectedNodes = inst.getNumNodesSelected();
    boolean nodesSelected    = (numSelectedNodes > 0);
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/targetSelection.js'></script>
        <script language='javascript' type='text/javascript'>
            // to allow scrollbars to appear when horizontal scrolling is needed
            var IFRAME_TOP = true;
            var minWidth   = 0;
            // save the timeStamp
            var timeStamp    = "<%=timeStamp%>";
            var taskWizard   = <%=taskWizard%>;
            // used to properly set the <iframe> height for the node list
            var clientHeight = 0;
            var clientWidth  = 0;
            var query        = "<%=request.getQueryString().replaceFirst("&prev=1", "")%>";
            //////////////////////////////////////////////
            // saveClientHeight()
            //////////////////////////////////////////////
            function saveClientHeight()
            {
                var iframe = MxPortalGetWorkspaceFrame();

                if (iframe != null)
                {
                    clientHeight = iframe.contentWindow.document.body.clientHeight;
                    clientWidth  = iframe.contentWindow.document.body.clientWidth;
                    setTimeout('saveClientHeight()', RESIZE_TIMEOUT);
                }
            }
            //////////////////////////////////////////////
            // resource string for targetSelection.js
            //////////////////////////////////////////////
            var apply           = '<%=rb.getString("APPLY_BUTTON")%>';
            var cancel          = '<%=rb.getString("CANCEL_BUTTON")%>';
            var addTargets      = '<%=rb.getString("ADD_TARGETS")%>';
            var removeTargets   = '<%=rb.getString("REMOVE_TARGETS")%>';
            var addTargetsBy    = '<%=rb.getString("ADD_TARGETS_BY")%>';
            var selectText      = '<%=rb.getString("SELECT_TEXT")%>';
            var itselfText      = '<%=rb.getString("ITSELF_TEXT")%>';
            //////////////////////////////////////////////
            // button text in javascript
            //////////////////////////////////////////////
            var btn1Text           = '<%=btn1Text%>';
            var btn1Function       = '<%=btn1Function%>';
            var btn2Text           = '<%=btn2Text%>';
            var btn2Function       = '<%=btn2Function%>';
            var btn3Text           = '<%=btn3Text%>';
            var btn3Function       = '<%=btn3Function%>';
            var listType           = '<%=listType%>';
            var selectionType      = '<%=selectionType%>';
            var numInvalidTargets  = 0;
            var invalidTargetsText = '';
            var toolAuth           = true;
            var nodeAuth           = true;
            var authErrorMsg       = '<%=rb.getString("NO_AUTH_ERROR_4")%>';
            //////////////////////////////////////////////
            // wrapperFunction1()
            //////////////////////////////////////////////
            function wrapperFunction1()
            {
                if (customTSPFunction() == true)
                {
                    <%=btn1Function%>;
                }
            }
            //////////////////////////////////////////////
            // wrapperFunction2()
            //////////////////////////////////////////////
            function wrapperFunction2()
            {
                if (customTSPFunction() == true)
                {
                    <%=btn2Function%>;
                }
            }
            //////////////////////////////////////////////
            // wrapperFunction3()
            //////////////////////////////////////////////
            function wrapperFunction3()
            {
                if (customTSPFunction() == true)
                {
                    <%=btn3Function%>;
                }
            }
            //////////////////////////////////////////////
            // function called when user is leaving (forward) TSP
            //////////////////////////////////////////////
            function customTSPFunction()
            {
                // if there is a tool/node auth error - display to user and do not continue
                if ((toolAuth == false) || (nodeAuth == false))
                {
                    alert(authErrorMsg);
                    return false;
                }

                // if the user has invalid selections in their selection bucket,
                // then we inform them that if they continue, the invalid selections
                // will be removed
                var answer = true;

                if (numInvalidTargets > 0)
                {
                    answer = confirm(invalidTargetsText);

                    if (answer == true)
                    {
                        var url = "<%=MxOptions.URL_BASE%>/taskandjob/scrubSelections.jsp?timeStamp=<%=timeStamp%>&taskWizard=<%=taskWizard%>";
                        // we use the parent's "action" iframe because this page is going away
                        parent.document.getElementById("action").contentWindow.document.location.replace(url);
                        // small delay before returning
                        for (var i = 0; i < 6000; i++) {}
                    }
                }

                return answer;
            }
            //////////////////////////////////////////////
            // params for Target Selection
            //////////////////////////////////////////////
            var nodesRequired     = <%=nodesRequired%>;
            var nodesSelected     = <%=nodesSelected%>;
            var somethingSelected = (nodesSelected == true);
            var changeTargetsOpen = false;
            // the string of selected nodes to display
            var selectedNodes     = "<%=selectedNodes%>";
            var selectionLocked   = false;

            if (taskWizard != null)
            {
                // if we're from Task Wizard, check for "lockTargetSelection" tool attribute
                selectionLocked = <%=inst.isToolTargetLocked()%>;
                // update task wizard with persistent information
                findTaskWizardParent(this).selectedNodes = selectedNodes;
            }
            //////////////////////////////////////////////
            // if there are no nodes selected, open the "selectionMenu"
            //////////////////////////////////////////////
            if (nodesRequired == true)
            {
                if (somethingSelected == false)
                {
                    changeTargetsOpen = true;
                }
            }
            /////////////////////////////////////////////////
            // enableApplyButton()
            /////////////////////////////////////////////////
            function enableApplyButton(enable)
            {
                if (enable == true)
                {
                    ourButtonManager.enableButton(document.getElementById('applyTop'));
                    ourButtonManager.enableButton(document.getElementById('applyBottom'));
                }
                else
                {
                    ourButtonManager.disableButton(document.getElementById('applyTop'));
                    ourButtonManager.disableButton(document.getElementById('applyBottom'));
                }
            }
            /////////////////////////////////////////////////
            // getTimeStamp()
            /////////////////////////////////////////////////
            function getTimeStamp()
            {
                 return timeStamp;
            }
            /////////////////////////////////////////////////
            // setTableHeight()
            /////////////////////////////////////////////////
            function setTableHeight()
            {
                // if this IFRAME does not exist, then there is nothing more to do
                var nodeBucket = document.getElementById('nodeBucket');
                if (nodeBucket == null)
                {
                    return;
                }

                var iframe       = document.getElementById('DPI');
                var rowHeight    = iframe.contentWindow.getCellHeight();
                var titleHeight  = iframe.contentWindow.getTitleHeight();

                var rowsDisplayed = <%= numSelectedNodes %>;

                if ((rowsDisplayed < NODE_BUCKET_MIN_DISPLAYED) && (rowsDisplayed > 0))
                {
                    rowsDisplayed = NODE_BUCKET_MIN_DISPLAYED;
                }

                if (rowsDisplayed > NODE_BUCKET_MAX_DISPLAYED)
                {
                    rowsDisplayed = NODE_BUCKET_MAX_DISPLAYED;
                }

                var divHeight = (rowHeight * rowsDisplayed) + titleHeight;
                nodeBucket.style.height = divHeight;
            }
            ///////////////////////////////
            // myIframeSet()
            ///////////////////////////////
            function myIframeSet()
            {
                var windowWidth = MxPortalGetWorkspaceFrame().offsetWidth - NETSCAPE_SCROLLBAR_WIDTH;
                var newWidth    = (minWidth >= windowWidth) ? minWidth : '100%';

                // set width of our <iframe>
                document.getElementById('topButtonTable').style.width     = newWidth;
                document.getElementById('bottomButtonTable').style.width  = newWidth;

                parent.document.getElementById(this.name).style.width = newWidth;

                setTimeout('myIframeSet()', RESIZE_TIMEOUT);
            }
            /////////////////////////////////////////////////
            // myResize()
            /////////////////////////////////////////////////
            function myResize()
            {
                redrawElement(document.getElementById('bottomButtonTable'));
            }
            /////////////////////////////////////////////////
            // scrollTop()
            /////////////////////////////////////////////////
            function scrollTop()
            {
                parent.scrollTo(0, 0);
            }
            /////////////////////////////////////////////////
            // myOnLoad()
            /////////////////////////////////////////////////
            function myOnLoad()
            {
                myIframeSet();
                setTableHeight();
                scrollTop();
                MxPortalManageMenuRefreshSelections();
            }
            /////////////////////////////////////////////////
            // myOnUnload()
            /////////////////////////////////////////////////
            function myOnUnload()
            {
                parent.document.getElementById(this.name).style.width = '100%';
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <!-- if we find "no-show" on the URL - don't perform regular target selection page actions -->
<%
    if (request.getParameter("no-show") != null)
    {
%>
    <body>
        <script language='javascript' type='text/javascript'>
            parent.loadFirstPage();
        </script>
    </body>
<%
    }
    else
    {
%>
    <body onload='myOnLoad()' onunload='myOnUnload()' onresize='myResize()'>
        <script language='javascript' type='text/javascript'>
            // if we find the "taskWizard" url parameter, then set the Task Wizard Step Text
            if (taskWizard != null)
            {
                var text = null;

                if (somethingSelected == true)
                {
                    if (<%= inst.getToolTargetsEvents() %> == true)
                    {
                        text = '<%= inst.getToolTargetEventVerifyString() %>';
                    }
                    else
                    {
                        text = '<%= inst.getToolTargetSystemVerifyString() %>';
                    }
                }
                else
                {
                    if (<%= inst.getToolTargetsEvents() %> == true)
                    {
                        text = '<%= inst.getToolTargetEventSelectString() %>';
                    }
                    else
                    {
                        text = '<%= inst.getToolTargetSystemSelectString() %>';
                    }
                }

                setWizardStepText(text);
            }
            else
            {
                // if we're being used outside of the Task Wizard, inform whoever
                // is using us what the selection state is
                if (parent.selectionFull != null)
                {
                    parent.selectionFull(somethingSelected);
                }
            }
        </script>
<%
    inst.displayBucket(out);
%>
        <br/>
<%
    // display target selection NOTE if this is a task being edited
    inst.dumpEditTaskMessage(out);
%>
        <script language='javascript' type='text/javascript'>
            // display the Wizard buttons appropriate for this page
            displaySelectTargetsButtons();
            // if we're from the Task Wizard, clear any submit name
            if (taskWizard != null)
            {
                setFormSubmitName('');
            }
        </script>

        <iframe id='targetSelectionMenu' name='targetSelectionMenu' style='width:100%; height:420; position:relative; visibility:hidden'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

        <script language='javascript' type='text/javascript'>
            displaySelectTargetsBottomButtons();
        </script>

        <iframe id='DPI' name='DPI' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/taskandjob/DPI.html'>
        </iframe>
        <iframe id='action' name='action' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

        <script language='javascript' type='text/javascript'>
            saveClientHeight();
            //////////////////////////////////////////////
            // load the selection menu with the proper radio option selected
            // Also pass the listType for building the drop-down selection boxes
            //////////////////////////////////////////////
            var iframe = document.getElementById('targetSelectionMenu');
            var url    = '<%=MxOptions.URL_BASE%>/taskandjob/selectionMenu.jsp?listType=' + listType +
                         '&selectionType=' + selectionType + '&timeStamp=' + timeStamp;

            iframe.contentWindow.location.replace(url);
            //////////////////////////////////////////////
            // if "changeTargetsOpen" = true, display the change targets page
            //////////////////////////////////////////////
            if (changeTargetsOpen == true)
            {
                iframe.style.visibility = 'visible';
                showDivider(true);
            }
            //////////////////////////////////////////////
            // if there are no nodes selected or there is at least one (1)
            // node that isn't appropriate for the Tool, disable the "next" button
            //
            // don't do this if the Tool doesn't require targets
            //////////////////////////////////////////////
            if (nodesRequired == true)
            {
                if (somethingSelected == false)
                {
                    ourButtonManager.disableButtonById('customBtn1'); // Schedule
                    ourButtonManager.disableButtonById('customBtn2'); // Next/Run Now
                    ourButtonManager.disableButtonById('customBtn3'); // Prev
                }
            }
        </script>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
<%
    }  // end if "no-show"
%>
</html>
