<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>
<jsp:useBean id="selectionBean" class="com.hp.mx.portal.core.MxObjSelections" scope="session"/>
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.html.core.MxButton"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_AUTHORIZATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    // set header info
    MxBean.jspInit(request, response);
    rbsettings.init(loginBean, "MxSettings");

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    int     success    = MxTaskWizardInstance.NO_SAVE_ERROR;
    boolean apply      = (request.getParameter("apply") != null);
    boolean prev       = (request.getParameter("prev") != null);
    String  taskWizard = request.getParameter("taskWizard");
    String  snapOff    = request.getParameter("snapoff");

    String               timeStamp  = request.getParameter("timeStamp");
    MxTaskWizardInstance inst       = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    // Save the MxObjSelections (global selection object) to the MxTaskWizardInstance associated
    // with the "timestamp" value passed in.  Create an MxTaskWizardInstance if one is not found;
    // this is true when actions use the Target Selection Page outside of the Task Wizard
    //
    // If the MxTaskWizardInstance is created for a snapOff window, then the global selection object
    // will be cloned and will not affect the global selection object associated with the main
    // SIM portal window
    //
    // "listCleared" - this param may be depricated.  If a tool indicated that it did not
    // want the user to be able to make "List" selections, (MAX TARGETS) any selected List
    // would be removed from the global selection so it would not be initially displayed in the
    // node bucket
    //
    int maxTargets = MxTaskWizardInstance.NO_MAX_TARGETS;
    //
    // NO NEED TO DO this if we are back from a PREV or APPLY
    if ((apply == false) && (prev == false))
    {
        // check for a "max-targets" on the URL.  Set in the Wizard if found.
        //
        // MAX TARGETS implies a restriction for INDIVIDUAL selection.
        //
        if (request.getParameter("max-targets") != null)
        {
            try
            {
                maxTargets = Integer.parseInt(request.getParameter("max-targets"));
            }
            catch (Throwable e)
            {
            }
        }

        taskWizardBean.initTargetSelection(selectionBean, loginBean, (taskWizard != null), timeStamp, maxTargets, snapOff);

        inst = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);
        inst.clearWizardSelections();  // Clear the slections for potential next time

    }
    else
    {
        maxTargets = inst.getMaxTargets();
    }

    // re-get the instance object, in case it was just created
    //inst = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);
    // now get the resource bundle
    MxTaskAndJobResourceBundle rb = inst.getRB();

    // if applying, set selection - else, get selection
    if (apply == true)
    {
        // clear the flag to show the Task Edit Message
        inst.clearEditTaskMessage();
    }

    // save any new selected Nodes - grab the GLOBAL selection, which should have been
    // set if we are editing a Task, otherwise use existing for new Task
    success = inst.saveSelectedNodes();

    String selectedNodes = inst.getSelectedNodesString();

    // get filtering requests
    String listType      = request.getParameter("listType");
    String selectionType = request.getParameter("selectionType");

    // ensure "selectionType" is a supported value
    if (selectionType == null)
    {
        if (maxTargets == MxTaskWizardInstance.NO_MAX_TARGETS)
        {
            selectionType = "";
        }
        else
        {
            selectionType = "individual";
        }
    }
    else
    {
        // check for valid values
        if ((selectionType.equalsIgnoreCase("list")            == false) &&
            (selectionType.equalsIgnoreCase("individual")      == false) &&
            (selectionType.equalsIgnoreCase("collection")      == false) &&
            (selectionType.equalsIgnoreCase("list collection") == false) &&
            (selectionType.equalsIgnoreCase("collection list") == false))
        {
            selectionType = "";
        }
    }

    // ensure "listType" is a supported value
    if (listType == null)
    {
        listType = "systemLists eventLists";
    }
    else
    {
        // check for valid values
        if ((listType.equalsIgnoreCase("systemLists") == false) &&
            (listType.equalsIgnoreCase("eventLists")  == false))
        {
            listType = "systemLists eventLists";
        }
    }

    // check for custom button text & function
    String btn1Text       = request.getParameter("btn1Text");
    String btn1Function   = request.getParameter("btn1Function");
    // This is the one that will be used by developers
    String btn2Text       = request.getParameter("btn2Text");
    String btn2Function   = request.getParameter("btn2Function");
    // 3rd custom button
    String btn3Text       = request.getParameter("btn3Text");
    String btn3Function   = request.getParameter("btn3Function");

    // check for flag that informs this page not to enforce a non-empty bucket
    String  targetsRequired = request.getParameter("targetsRequired");
    boolean nodesRequired   = true;

    if ((targetsRequired != null) && (targetsRequired.equals("false") == true))
    {
        nodesRequired = false;
    }

    int     numSelectedNodes = inst.getNumNodesSelected();
    boolean nodesSelected    = (numSelectedNodes > 0);
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/targetSelection.js'></script>
        <script language='javascript' type='text/javascript'>
            // added by mjbalunis
            var IFRAME_TOP = true;
            var minWidth   = 0;


            var doneSelecting = <%= (request.getParameter("apply") != null) %>;
            if (doneSelecting)
            {
                <%
                    String applyFunction = request.getParameter("applyFunction");
                %>
                <%= applyFunction %>
                location.replace("<%=MxOptions.URL_BASE%>/home/MxBlank.html");
            }


            // save the timeStamp
            var timeStamp    = "<%= timeStamp %>";
            // used to properly set the < iframe> height for the node list
            var clientHeight = 0;
            var clientWidth  = 0;
            var query        = "<%= request.getQueryString().replaceFirst("&prev=1", "") %>";
            //////////////////////////////////////////////
            // saveClientHeight()
            //////////////////////////////////////////////
            function saveClientHeight()
            {
                var iframe = MxPortalGetWorkspaceFrame();

                if (iframe != null)
                {
                    clientHeight = iframe.contentWindow.document.body.clientHeight;
                    clientWidth  = iframe.contentWindow.document.body.clientWidth;
                    setTimeout('saveClientHeight()', RESIZE_TIMEOUT);
                }
            }
            //////////////////////////////////////////////
            // resource string for targetSelection.js
            //////////////////////////////////////////////
            var apply           = '<%=rb.getString("APPLY_BUTTON")%>';
            var cancel          = '<%=rb.getString("CANCEL_BUTTON")%>';
            var addTargets      = '<%=rb.getString("ADD_TARGETS")%>';
            var removeTargets   = '<%=rb.getString("REMOVE_TARGETS")%>';
            var addTargetsBy    = '<%=rb.getString("ADD_TARGETS_BY")%>';
            var selectText      = '<%=rb.getString("SELECT_TEXT")%>';
            var itselfText      = '<%=rb.getString("ITSELF_TEXT")%>';
            //////////////////////////////////////////////
            // button text in javascript
            //////////////////////////////////////////////
            var btn1Text          = '<%=btn1Text%>';
            var btn1Function      = '<%=btn1Function%>';
            var btn2Text          = '<%=btn2Text%>';
            var btn2Function      = '<%=btn2Function%>';
            var btn3Text          = '<%=btn3Text%>';
            var btn3Function      = '<%=btn3Function%>';
            var listType          = '<%=listType%>';
            var selectionType     = '<%=selectionType%>';
            //////////////////////////////////////////////
            // params for Target Selection
            //////////////////////////////////////////////
            var nodesRequired     = <%=nodesRequired%>;
            var nodesSelected     = <%=nodesSelected%>;
            var somethingSelected = (nodesSelected == true);
            var changeTargetsOpen = false;
            // the string of selected nodes to display
            var selectedNodes     = "<%=selectedNodes%>";
            var selectionLocked   = false;

            if (<%= taskWizard %> != null)
            {
                // if we're from Task Wizard, check for "lockTargetSelection" tool attribute
                selectionLocked = <%= inst.isToolTargetLocked() %>;
                // update task wizard with persistent information
                findTaskWizardParent(this).selectedNodes = selectedNodes;
            }
            //////////////////////////////////////////////
            // if there are no nodes selected, open the "selectionMenu"
            //////////////////////////////////////////////
            if (nodesRequired == true)
            {
                if (somethingSelected == false)
                {
                    changeTargetsOpen = true;
                }
            }
            /////////////////////////////////////////////////
            // enableApplyButton()
            /////////////////////////////////////////////////
            function enableApplyButton(enable)
            {
                if (enable == true)
                {
                    ourButtonManager.enableButton(document.getElementById('applyTop'));
                    ourButtonManager.enableButton(document.getElementById('applyBottom'));
                }
                else
                {
                    ourButtonManager.disableButton(document.getElementById('applyTop'));
                    ourButtonManager.disableButton(document.getElementById('applyBottom'));
                }
            }
            /////////////////////////////////////////////////
            // getTimeStamp()
            /////////////////////////////////////////////////
            function getTimeStamp()
            {
                 return timeStamp;
            }
            /////////////////////////////////////////////////
            // setTableHeight()
            /////////////////////////////////////////////////
            function setTableHeight()
            {
                // if this IFRAME does not exist, then there is nothing more to do
                var nodeBucket = document.getElementById('nodeBucket');
                if (nodeBucket == null)
                {
                    return;
                }

                var iframe       = document.getElementById('DPI');
                var rowHeight    = iframe.contentWindow.getCellHeight();
                var titleHeight  = iframe.contentWindow.getTitleHeight();

                var rowsDisplayed = <%= numSelectedNodes %>;

                if ((rowsDisplayed < NODE_BUCKET_MIN_DISPLAYED) && (rowsDisplayed > 0))
                {
                    rowsDisplayed = NODE_BUCKET_MIN_DISPLAYED;
                }

                if (rowsDisplayed > NODE_BUCKET_MAX_DISPLAYED)
                {
                    rowsDisplayed = NODE_BUCKET_MAX_DISPLAYED;
                }

                var divHeight = (rowHeight * rowsDisplayed) + titleHeight;
                nodeBucket.style.height = divHeight;
            }
            /////////////////////////////////////////////////
            // myOnLoad()
            /////////////////////////////////////////////////
            function myOnLoad()
            {
                setTableHeight();
                MxPortalManageMenuRefreshSelections();
            }
            /////////////////////////////////////////////////
            // displaySelectTargetsButtons()
            // (Overrides function in targetSelection.js)
            /////////////////////////////////////////////////
            function displaySelectTargetsButtons()
            {
                document.write("<br>");
                document.write("<table border='0' cellspacing='0' cellpadding='0' style='width:100%'>");
                document.write("<tr>");
                document.write("<td style='width:100%' nowrap></td>");
                document.write("<td id='btn1' align='right' nowrap></td>");
                document.write("<td id='btn2' align='right' nowrap></td>");
                document.write("<td id='btn2_1' align='right' nowrap></td>");
                document.write("<td id='btn3' align='right' nowrap></td>");
                document.write("<td id='btn4' align='right' nowrap></td>");
                document.write("</tr>");
                document.write("</table>");

                document.write("<table border='0' cellspacing='0' cellpadding='0' style='width:100%'>");
                document.write("<tr id='hrRow' style='visibility:hidden'>");

                document.write("<td colspan='5'><hr></td>")

                document.write("</tr>");
                document.write("<tr id='applyRow' style='visibility:hidden'>");
                document.write("<td style='width:100%' nowrap valign='bottom'><b>");
                document.write(addTargetsBy);
                document.write("</b></td>");
                document.write("<td id='btn1b' align='right' nowrap></td>");
                document.write("<td id='btn2b' align='right' nowrap></td>");
                document.write("</tr>");
                document.write("</table>");

                if ((nodesSelected == true) || (nodesRequired == false))
                {
                    // If this tool has defined "lockTargetSelection", then don't display
                    // 'Add Targets' or 'Remove Targets' button; Do this only if we are from
                    // Task Wizard
                    if (selectionLocked == false)
                    {
                        populateButtonCell(document.getElementById("btn2"), BTN_ADD_TARGETS);
                        //populateButtonCell(document.getElementById("btn2_1"), BTN_REMOVE_TARGETS);
                    }

                    populateButtonCell(document.getElementById("btn1b"), BTN_NO_BUTTON);
                }
                else
                {
                    populateButtonCell(document.getElementById("btn2"), BTN_NO_BUTTON);
                    populateButtonCell(document.getElementById("btn1b"), BTN_NO_BUTTON);
                    populateButtonCell(document.getElementById("btn2b"), BTN_APPLY_TARGETS, null, null, "applyTop");
                }

                // default settings for "user custom button 3"
                if (btn3Text == 'null')
                {
                    populateButtonCell(document.getElementById("btn1"), BTN_NO_BUTTON);
                }
                else
                {
                    populateButtonCell(document.getElementById("btn1"), BTN_CUSTOM_3, btn3Text, btn3Function);
                }

                // default settings for "user custom button 1"
                if (btn1Text == 'null')
                {
                    populateButtonCell(document.getElementById("btn3"), BTN_NO_BUTTON);
                }
                else
                {
                    populateButtonCell(document.getElementById("btn3"), BTN_CUSTOM_1, btn1Text, btn1Function);
                }

                // default settings for "user custom button 2"
                if (btn2Text == 'null')
                {
                    populateButtonCell(document.getElementById("btn4"), BTN_NO_BUTTON);
                }
                else
                {
                    //populateButtonCell(document.getElementById("btn4"), BTN_CUSTOM_2, btn2Text, btn2Function);
                }
            }
            /////////////////////////////////////////////////
            // applyChangeTargets()
            /////////////////////////////////////////////////
            function applyChangeTargets()
            {
                // if we have tree shown, do selectGroup.jsp, and have that file then call this function to perform actual "apply"
                //
                // look for displayFunction() on "displayGroupContents.jsp" in the "selectionFrame" < IFRAME>, which
                // in in the "targetSelectionMenu" < IFRAME>
                //
                // If this function is found, call it and exit.  The function will call this function again after
                // it has removed the displayFunction() this function looks for
                var iframe = document.getElementById("targetSelectionMenu").contentWindow.document.getElementById("selectionFrame");
                if ((iframe != null) && (iframe.contentWindow.applyFunction != null))
                {
                    iframe.contentWindow.applyFunction();
                    return;
                }

                showBottomButtons(false);
                location.replace("/mxportal/taskandjob/targetSelectionNoBucket.jsp" + buildURLString() + "&applyFunction=<%= applyFunction %>");
            }
            /////////////////////////////////////////////////
            // showDivider()
            /////////////////////////////////////////////////
            function showDivider(show)
            {
                //var e1 = document.getElementById('hrRow');
                var e2 = document.getElementById('applyRow');

                if (show == true)
                {
                    //e1.style.visibility = 'visible';
                    e2.style.visibility = 'visible';
                }
                else
                {
                    //e1.style.visibility = 'hidden';
                    e2.style.visibility = 'hidden';
                }
            }
            /////////////////////////////////////////////////
            // toggleChangeTargets()
            /////////////////////////////////////////////////
            function toggleChangeTargets()
            {

                var iframe = document.getElementById("targetSelectionMenu");

                if (changeTargetsOpen == true)
                {
                    // we are closing the "Change Targets Page" using the "CANCEL" button
                    parent.scrollMe(-400);
                    document.location.replace("<%=MxOptions.URL_BASE%>/home/MxBlank.html");
                }
                else
                {
                    iframe.style.visibility = "visible";
                    changeTargetsOpen       = true;

                    showDivider(true);

                    // Bottom Buttons
                    populateButtonCell(document.getElementById("btn2"), BTN_NO_BUTTON);
                    populateButtonCell(document.getElementById("btn2_1"), BTN_NO_BUTTON);
                    populateButtonCell(document.getElementById("btn1b"), BTN_CANCEL_TARGETS);
                    populateButtonCell(document.getElementById("btn2b"), BTN_APPLY_TARGETS, null, null, "applyTop");

                    // while the user is making changes, we'll disable the "Next" & "Prev" buttons
                    ourButtonManager.disableButtonById('customBtn3'); // PREV
                    ourButtonManager.disableButtonById('customBtn1'); // SCHEDULE
                    ourButtonManager.disableButtonById('customBtn2'); // NEXT
                }
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <!-- if we find "no-show" on the URL - don't perform regular target selection page actions -->
<%
    if (request.getParameter("no-show") != null)
    {
%>
    <body>
        <script language='javascript' type='text/javascript'>
            parent.loadFirstPage();
        </script>
    </body>
<%
    }
    else
    {
%>
    <body onLoad='myOnLoad()'>
        <hr/>
        <font class="mx-subheader-nosep"><%=rbsettings.getString("auth.addSystems.pageTitle")%></font><br>
        <script language='javascript' type='text/javascript'>
            // display the Wizard buttons appropriate for this page
            displaySelectTargetsButtons();
        </script>

        <iframe id='targetSelectionMenu' name='targetSelectionMenu' style='width:100%; height:420; position:relative; visibility:hidden'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

        <script language='javascript' type='text/javascript'>
            displaySelectTargetsBottomButtons();
        </script>

        <iframe id='DPI' name='DPI' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/taskandjob/DPI.html'>
        </iframe>
        <iframe id='action' name='action' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

        <script language='javascript' type='text/javascript'>
            saveClientHeight();
            //////////////////////////////////////////////
            // load the selection menu with the proper radio option selected
            // Also pass the listType for building the drop-down selection boxes
            //////////////////////////////////////////////
            var iframe = document.getElementById('targetSelectionMenu');
            var url    = '<%=MxOptions.URL_BASE%>/taskandjob/selectionMenu.jsp?listType=' + listType +
                         '&selectionType=' + selectionType + '&timeStamp=' + timeStamp + "&noAuth=1";

            iframe.contentWindow.location.replace(url);
            //////////////////////////////////////////////
            // if "changeTargetsOpen" = true, display the change targets page
            //////////////////////////////////////////////
            if (changeTargetsOpen == true)
            {
                iframe.style.visibility = 'visible';
                showDivider(true);
            }
            //////////////////////////////////////////////
            // if there are no nodes selected or there is at least one (1)
            // node that isn't appropriate for the Tool, disable the "next" button
            //
            // don't do this if the Tool doesn't require targets
            //////////////////////////////////////////////
            if (nodesRequired == true)
            {
                if (somethingSelected == false)
                {
                    ourButtonManager.disableButtonById('customBtn1'); // Schedule
                    ourButtonManager.disableButtonById('customBtn2'); // Next/Run Now
                    ourButtonManager.disableButtonById('customBtn3'); // Prev
                }
            }
            // Automatically show the Add Targets controls
            changeTargetsOpen=false;
            toggleChangeTargets();
        </script>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
<%
    }  // end if "no-show"
%>
</html>
