<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.core.jobmanager.MxDefaultJobFormatter"%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobMessages"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);

    inst.checkTimers();

    int totalNumJobs = inst.getTotalNumJobs();
    int numJobs      = inst.getNumJobs();

    // resource bundle
    MxTaskAndJobResourceBundle rb = inst.getRB();

    StringBuffer total = new StringBuffer();
    total.append(numJobs);

    if (totalNumJobs != numJobs)
    {
        total.append(" ");
        total.append(rb.getString("OF"));
        total.append(" ");
        total.append(totalNumJobs);
    }

    // get the state the "All Jobs" buttons should be in
    // we'll set the button states after this Job is selected
    boolean btnStates[] = inst.getButtonStateForSelectedJob();

    // get the number of targets for the currently selected task.  we will decrease the frequency of the refresh rate
    // proportional to the number of targets the JOB targets.
    //
    // base refresh == 10 seconds
    // for each chunk of 15 targets beyond the first, we will add 1 second to the refresh interval
    //
    // the updateAllJobs.jsp file will need to update the # of targets for the currently
    // selected JOB

    // get the number of targets for the selected job
    int     numTargets       = inst.getSelectedJobNumTargets();
    boolean defaultFormatter = (inst.getJobFormatter() instanceof MxDefaultJobFormatter);
    int     addSeconds       = 0;

    if ((defaultFormatter == true) && (inst.isSelectedJobRunning() == true) && (numTargets >= 15))
    {
        addSeconds = numTargets / 15;
    }
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/AutoRefreshingSessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/allTasks.js'></script>
        <script language='javascript' type='text/javascript'>
            // set the Table height based off of a CELL height given the users font size (DPI)
            function setTableHeight()
            {
                var rowsDisplayed = <%=numJobs%>;

                if ((rowsDisplayed < JOB_LIST_MIN_DISPLAYED) && (rowsDisplayed > 0))
                {
                    rowsDisplayed = JOB_LIST_MIN_DISPLAYED;
                }

                if (rowsDisplayed > JOB_LIST_MAX_DISPLAYED)
                {
                    rowsDisplayed = JOB_LIST_MAX_DISPLAYED;
                }

                var divHeight = (parent.iconRowHeight * rowsDisplayed) + parent.titleHeight;
                parent.MxTableSetHeight('ID_MY_TABLE', divHeight);
            }
            // update in the parent, Number of Jobs and divHeight (MxTable)
            function updateInfo()
            {
                // set refresh timeout based off of numTargets for currently selected job
                parent.refreshTimeout = (REFRESH_TIMEOUT + (<%=addSeconds%> * 1000)); // to get millis
                // if we have (0) jobs, display the text.  Otherwise, display the Table
                displayEmptyTable((<%=totalNumJobs%> == 0), parent);

                if (parent.hidden == 'null')
                {
                    // set the height of the MxTable
                    setTableHeight();
                    // update the number of Jobs
                    var td = parent.document.getElementById('total');
                    if (td != null)
                    {
                        td.innerHTML = '<b><%=rb.getString("TOTAL")%>:</b>&nbsp;<%=total.toString()%>';
                    }
                    // if we added the first item in this table we needs to select
                    // the item
                    var iframe = parent.document.getElementById('jobResults');
                    // if this is null, our jobResults page is not present.
                    if (iframe.style.visibility == 'hidden')
                    {
                        parent.selectJob(JOB_FORMAT_FULL, <%= taskAndJobTimeStamp %>);
                    }
                    else
                    {
                        // set the button states for the Selected Task - do after we update
                        // the selected Task info
                        if (<%=btnStates[0]%> == true)
                        {
                            ourButtonManager.enableButton(parent.document.getElementById('btnStop'));
                        }
                        else
                        {
                            ourButtonManager.disableButton(parent.document.getElementById('btnStop'));
                        }
                        // if the "deleteOpen" flag == true, do not update the button status for "delete"
                        if (parent.deleteOpen == false)
                        {
                            if (<%=btnStates[1]%> == true)
                            {
                                ourButtonManager.enableButton(parent.document.getElementById('btnDelete'));
                            }
                            else
                            {
                                ourButtonManager.disableButton(parent.document.getElementById('btnDelete'));
                            }
                        }
                    }
                }
                else
                {
                    // if we added the first item in this table we needs to select
                    // the item
                    var iframe = parent.document.getElementById('jobResults');
                    // if this is null, our jobResults page is not present.
                    if (iframe.style.visibility == 'hidden')
                    {
                        parent.selectJob(JOB_FORMAT_FULL, <%= taskAndJobTimeStamp %>);
                    }
                }
                // as the last step, inform the parent page that we are finished refreshing
                parent.refreshed = true;
            }
<%
    MxTaskAndJobMessages msg          = inst.getMessages();
    boolean              refreshError = inst.getJobRefreshError();
    boolean              displayError = inst.getDisplayError();

    if (refreshError == true)
    {
        inst.clearRefreshError();
    }
%>
            if (<%=refreshError%> == true)
            {
                if (<%=totalNumJobs%> > 0)
                {
                    parent.selectJob(JOB_FORMAT_FULL, <%= taskAndJobTimeStamp %>);
                }
                else
                {
                    parent.document.getElementById('jobResults').style.visibility = 'hidden';
                }

                if (<%=displayError%> == true)
                {
                    alert("<%=msg.getMessage()%>");
                }
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='updateInfo()'>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
