<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobMessages"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);

    int totalNumJobs = inst.getTotalNumJobs();
    int numJobs      = inst.getNumJobs();

    // resource bundle
    MxTaskAndJobResourceBundle rb = inst.getRB();

    StringBuffer total = new StringBuffer();
    total.append(numJobs);

    if (totalNumJobs != numJobs)
    {
        total.append(" ");
        total.append(rb.getString("OF"));
        total.append(" ");
        total.append(totalNumJobs);
    }

    // get the state the "All Jobs" buttons should be in
    // we'll set the button states after this Job is selected
    boolean btnStates[] = inst.getButtonStateForSelectedJob();
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/AutoRefreshingSessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/allTasks.js'></script>
        <script language='javascript' type='text/javascript'>
            // set the Table height based off of a CELL height given the users font size (DPI)
            function setTableHeight()
            {
                var rowsDisplayed = <%=numJobs%>;

                if ((rowsDisplayed < TASK_JOB_LIST_MIN_DISPLAYED) && (rowsDisplayed > 0))
                {
                    rowsDisplayed = TASK_JOB_LIST_MIN_DISPLAYED;
                }

                if (rowsDisplayed > TASK_JOB_LIST_MAX_DISPLAYED)
                {
                    rowsDisplayed = TASK_JOB_LIST_MAX_DISPLAYED;
                }

                var divHeight = (parent.parent.iconRowHeight * rowsDisplayed) + parent.parent.titleHeight;
                parent.MxTableSetHeight('ID_MY_TABLE', divHeight);
            }
            // update in the parent, Number of Tasks and divHeight (MxTable)
            function hideTaskInstanceResults()
            {
                var iframe = parent.parent.document.getElementById('taskInstanceResults');

                iframe.style.visibility = 'hidden';
                iframe.style.height     = 0;
                iframe.contentWindow.document.location.replace('<%=MxOptions.URL_BASE%>/home/MxBlank.html');
            }
            //
            function updateInfo()
            {
                // if we have (0) jobs, display the text.  Otherwise, display the Table
                displayEmptyTable((<%= totalNumJobs %> == 0), parent);
                // set the height of the MxTable
                setTableHeight();
                parent.setTableWidth();
                parent.setOurIFrameHeight();
                // update Task Result <table> info
                var tdSrc  = document.getElementById('taskResultInfo');
                var tdDest = parent.document.getElementById('taskResultInfo');

                if ((tdSrc != null) && (tdDest != null))
                {
                    tdDest.innerHTML = tdSrc.innerHTML;
                }

                // update the number of Jobs
                td = parent.document.getElementById('total');

                if (td != null)
                {
                    td.innerHTML = '<b><%=rb.getString("TOTAL")%>:</b>&nbsp;<%=total.toString()%>';
                }

                // if this is null, our jobResults page is not present.
                if (<%=totalNumJobs%> > 0)
                {
                    if (parent.parent.document.getElementById('taskInstanceResults').style.visibility == 'hidden')
                    {
                        parent.selectJob(JOB_FORMAT_BASIC, <%=taskAndJobTimeStamp%>);
                    }
                    else
                    {
                        // set the button states for the Selected Task - do after we update
                        // the selected Task info
                        if (<%=btnStates[0]%> == true)
                        {
                            ourButtonManager.enableButton(parent.document.getElementById('btnStop'));
                        }
                        else
                        {
                            ourButtonManager.disableButton(parent.document.getElementById('btnStop'));
                        }

                        // if the "deleteOpen" flag == true, do not update the button status for "delete"
                        if (parent.deleteOpen == false)
                        {
                            if (<%=btnStates[1]%> == true)
                            {
                                ourButtonManager.enableButton(parent.document.getElementById('btnDelete'));
                            }
                            else
                            {
                                ourButtonManager.disableButton(parent.document.getElementById('btnDelete'));
                            }
                        }
                    }
                }
                else
                {
                    hideTaskInstanceResults();
                }
            }
<%
    MxTaskAndJobMessages msg          = inst.getMessages();
    boolean              refreshError = inst.getJobRefreshError();
    boolean              displayError = inst.getDisplayError();

    if (refreshError == true)
    {
        inst.clearRefreshError();
    }
%>
            if (<%=refreshError%> == true)
            {
                if (<%=totalNumJobs%> > 0)
                {
                    parent.selectJob(JOB_FORMAT_BASIC, <%= taskAndJobTimeStamp %>);
                }
                else
                {
                    hideTaskInstanceResults();
                }

                if (<%=displayError%> == true)
                {
                    alert("<%=msg.getMessage()%>");
                }
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='updateInfo()'>

        <table border='0' cellpadding='0' cellspacing='0' style='width:100%'>
            <tr>
                <td id='taskResultInfo' nowrap>
<%
    inst.dumpTaskResultInfo(out);
%>
                </td>
            </tr>
        </table>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
