<!-- ---------------------------------------------------------------------- -->
<!--  Put all your Java imports here -->
<!-- ---------------------------------------------------------------------- -->

<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all your taglib imports here -->
<!-- ---------------------------------------------------------------------- -->

<%@ taglib uri="/com/hp/mx/taglibs/" prefix="mxtag" %>

<!-- ---------------------------------------------------------------------- -->
<!--  Create all your beans here -->
<!-- ---------------------------------------------------------------------- -->

<!--  REQUIRED: This bean is used (later) to verify that this page is allowed to run -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<!--  DO NOT COPY: These are example beans -->
<jsp:useBean id="actionList" class="com.hp.mx.portal.core.MxActionList" scope="session" />
<jsp:useBean id="rbPortal" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<!--  DO NOT COPY: These are example beans -->
<!--  For beans that need to be session beans, but that are not to be shared with -->
<!--  other pages, use names that ensure they will be unique -->
<jsp:useBean id="template_treeView" class="com.hp.mx.html.tree.MxTreeView" scope="session" />
<jsp:useBean id="template_treeExpansionModel" class="com.hp.mx.html.tree.MxDefaultTreeExpansionModel" scope="session" />
<jsp:useBean id="template_treeController" class="com.hp.mx.html.tree.MxTreeController" scope="session" />

<!-- ---------------------------------------------------------------------- -->
<!--  Put one block of initialization Java code here -->
<!--  In general, keep Java code to a minimum. Put Java code into JavaBeans. -->
<!-- ---------------------------------------------------------------------- -->

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // EXAMPLE (DO NOT ACCIDENTALLY COPY THE PRIVILEGE): This aborts the page
    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_AUTHORIZATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
 <% }

    // EXAMPLE: follow references to this bean for i18n support using resource bundles
    rbPortal.init(loginBean, "MxPortal");

    // example code continues:

    if (template_treeController.isFirstTime())
    {
        template_treeView.setId("ID_TOOLS_TREE");
        template_treeView.setUrlHandler(request.getRequestURI());

        template_treeController.setExpansionModel(template_treeExpansionModel);
        template_treeController.setTreeView(template_treeView);
    }

    if (template_treeController.checkUrlForControllerMessages(request, out))
       return;

    if (actionList.size() == 0 || request.getParameter("refresh") != null)
        actionList.populate(loginBean);

    template_treeController.setTreeModel(actionList.getTreeModel());
%>

<!-- ---------------------------------------------------------------------- -->
<!--  From here on, this is a well-formed HTML file -->
<!-- ---------------------------------------------------------------------- -->

<html>

<!-- ---------------------------------------------------------------------- -->
<!--  The HEAD block contains meta tags, the TITLE, style sheet links, -->
<!--  JavaScript links, and JavaScript code. -->
<!-- ---------------------------------------------------------------------- -->

<head>

<!-- ---------------------------------------------------------------------- -->
<!--  Most pages are displayed inside of frames or iframe, so the only -->
<!--  place the TITLE is displayed is in the browser history list. -->
<!--  Still, that is important. -->
<!-- ---------------------------------------------------------------------- -->

<title>rbPortal.get("tools.title")</title>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all UI component head blocks here (these consist of style sheets -->
<!--  and JavaScript links) -->
<!-- ---------------------------------------------------------------------- -->

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% template_treeView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
<mxtag:MxTabs dumpHeadContent="true"/>

<!-- ---------------------------------------------------------------------- -->
<!--  Any additional style sheets links go here -->
<!-- ---------------------------------------------------------------------- -->

<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxTools.css'>

<!-- ---------------------------------------------------------------------- -->
<!--  Any additional JavaScript links go here -->
<!-- ---------------------------------------------------------------------- -->

<!--  COMMONLY USED: This includes the browser-based portal API -->
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

<!--  EXAMPLE -->
<script src="<%=MxOptions.MXHTML_BASE%>/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all additional JavaScript here -->
<!-- ---------------------------------------------------------------------- -->

<script language="JavaScript" type="text/javascript">

function myOnLoad()
{
    // EXAMPLE (DO NOT ACCIDENTALLY COPY THE TOPIC): This sets the help context.
    MxPortalWorkspaceSetHelpTopic("use_node_select");

    setTimeout("myOnResize()", 100);
}

function myOnResize()
{
    resize_w();
    resize_h();
}

function resize_w()
{
    var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
    MxTreeSetWidth("ID_TOOLS_TREE", w);
}

function resize_h()
{
    var h_total = Math.max(0, MxBrowserGetBodyHeight(0, 0));
    var h_tabs = document.getElementById("ID_TABS").offsetHeight;
    var h_top = document.getElementById("TOP_PART").offsetHeight;
    var h = Math.max(0, h_total - h_tabs - h_top);

    MxTreeSetHeight("ID_TOOLS_TREE", h);
}

</script>

</head>

<!-- ---------------------------------------------------------------------- -->
<!--  The HEAD block ends here -->
<!-- ---------------------------------------------------------------------- -->

<!-- ---------------------------------------------------------------------- -->
<!--  The BODY block begins here -->
<!-- ---------------------------------------------------------------------- -->

<body class="tools-body" onLoad="myOnLoad()" onResize="myOnResize()">
<div class="body-proxy" id="ID_BODY_PROXY">

<!--  communication frame  -->
<iframe id="ID_COMM_SERVER" style="display:none" src="MxBlank.html"></iframe>

<div id="ID_TABS" class="tools-tabs">
    <mxtag:MxTabs selection="XXX">
    <% // organizer.dumpTabs(loginBean, out); %>
    </mxtag:MxTabs>
</div>

<div id="TOP_PART">
    <div class="tools-control">
        <a href="javascript:MxTreeExpandAll('ID_TOOLS_TREE')"><img title='<%=rbPortal.get("tools.expand-all")%>' border="0" src="<%=MxOptions.URL_BASE%>/images/menu_expand.gif"></a>
        <a href="javascript:MxTreeCollapseAll('ID_TOOLS_TREE')"><img title='<%=rbPortal.get("tools.collapse-all")%>' border="0" src="<%=MxOptions.URL_BASE%>/images/menu_collapse.gif"></a>
    </div>
</div>

<% template_treeView.dumpTree(out); %>

</div>
</body>

<!-- ---------------------------------------------------------------------- -->
<!--  The BODY block ends here -->
<!-- ---------------------------------------------------------------------- -->

</html>
