<%--
/*-------------------------------------------------------------------------
---- Copyright 1997, 2003 Hewlett-Packard Corporation
---------------------------------------------------------------------------
----
---- Title: AssignEventTo.jsp
----
---- Package:  www.ui.jsp
----
---- Description: Enable the user to enter an assignee for the selected
----                    event(s)
----
----------------------------------------------------------------------------
---- Date: 5/1/2003
---------------------------------------------------------------------------
---- $ProjectName: $
---- $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/AssignEventTo.jsp,v 1.31 2005/05/31 23:53:43 farley Exp $
----------------------------------------------------------------------------*/
--%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="selectionBean" class="com.hp.mx.portal.core.MxObjSelections" scope="session"/>
<jsp:useBean id="resourceBean" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%@ page import="java.util.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="com.hp.mx.database.DatabaseManager" %>
<%@ page import="com.hp.mx.html.core.*" %>

<%@ include file="EventCommonAPI.jsp" %>

<%!
    private void releaseThisDBConnection( Connection myConnection, Statement myStatement, ResultSet myResultSet )
    {
        // Make sure we're a good boy and free our database connection
        if (myResultSet != null)
        {
            try
            {
                myResultSet.close();
            }
            catch (SQLException myException)
            {
            }
        }
        if (myStatement != null)
        {
            try
            {
                myStatement.close();
            }
            catch (SQLException myException)
            {
            }
        }
        if (myConnection != null)
        {
            try
            {
                DatabaseManager.getDefaultDatabase().releaseConnection(myConnection);
            }
            catch (SQLException myException)
            {
            }
        }
    }

    private int getAllExistingAssigneeCount()
    {
        int nNumberOfAssignees = 0;

        Statement sqlStatement   = null;
        Connection sqlConnection = null;
        ResultSet sqlResultSet   = null;


        try
        {

            // connect to the database
            sqlConnection = DatabaseManager.getDefaultDatabase().getConnection( "AssignEventTo.getAllExistingAssigneeCount()" );

            // obtain a connection to the database so that we can execute a statement
            sqlStatement = sqlConnection.createStatement();

            // Get all available assignees from DB
            sqlResultSet = sqlStatement.executeQuery( "select distinct AssignedTo from notices" );

            // the ResultSet points to *before* the first row so you have to call "next" once...

            while (sqlResultSet.next())
            {
                String strOneAssigneeName = sqlResultSet.getString(1);


                if ( (strOneAssigneeName != null) && (strOneAssigneeName.equals( "" ) == false) &&
                     (strOneAssigneeName.equals( " " ) == false) )
                {
                    nNumberOfAssignees++;
                }
            }

            sqlResultSet.close();
            sqlStatement.close();
            sqlResultSet = null;
            sqlStatement = null;
        }
        catch( SQLException sqlException )
        {
        }
        finally
        {
            // make sure we're a good boy or girl and free our database connection
            releaseThisDBConnection( sqlConnection, sqlStatement, sqlResultSet );

            return( nNumberOfAssignees );
        }
    }

    private void getAllExistingAssigneeNames( String[] allAssigneeNames )
    {
        int nNumberOfAssignees = 0;

        Statement sqlStatement   = null;
        Connection sqlConnection = null;
        ResultSet sqlResultSet   = null;


        try
        {
            // connect to the database
            sqlConnection = DatabaseManager.getDefaultDatabase().getConnection( "AssignEventTo.getAllExistingAssigneeNames()" );

            // obtain a connection to the database so that we can execute a statement
            sqlStatement = sqlConnection.createStatement();

            // Get all available assignees from DB
            sqlResultSet = sqlStatement.executeQuery( "select distinct AssignedTo from notices" );

            // the ResultSet points to *before* the first row so you have to call "next" once...

            while (sqlResultSet.next())
            {
                String strOneAssigneeName = sqlResultSet.getString(1);


                if ( (strOneAssigneeName != null) && (strOneAssigneeName.equals( "" ) == false) &&
                     (strOneAssigneeName.equals( " " ) == false) )
                {
                    allAssigneeNames[ nNumberOfAssignees ] = strOneAssigneeName;
                    nNumberOfAssignees++;
                }
            }

            sqlResultSet.close();
            sqlStatement.close();
            sqlResultSet = null;
            sqlStatement = null;
        }
        catch( SQLException sqlException )
        {
        }
        finally
        {
            // make sure we're a good boy or girl and free our database connection
            releaseThisDBConnection( sqlConnection, sqlStatement, sqlResultSet );
        }
    }

    private int findLongestStrLengthIndex( String[] data, int dataCount )
    {
        int strLenIndex = 0;
        int strLen = 0;

        strLen = data[0].length();
        strLenIndex = 0;

        for ( int i = 1; i < dataCount; i++ )
            if ( strLen < data[i].length() )
            {
                strLen = data[i].length();
                strLenIndex = i;
            }

        return( strLenIndex );
    }

    private void buildHTMLOptionTag( JspWriter out, String[] optionValues, int numOfOptions, int maxStrLenIndex )
    {
        for ( int i = 0; i < numOfOptions; i++ )
        {
            try
            {
                out.write( "\t\t<option value=\"" );
                out.write( optionValues[i] );
                out.write( "\"" );
                out.write( ">" );

                if ( i == maxStrLenIndex )
                {
                    int maxStrLen = optionValues[i].length();
                    String paddedString = optionValues[i];

                    if ( maxStrLen < 25 )
                        for ( int j = 36 - maxStrLen; j > 0; j-- )
                            paddedString = paddedString.concat( " " );

                    out.write( MxHtmlUtil.encodeHtmlEntities(paddedString) );
                }
                else
                {
                    out.write( MxHtmlUtil.encodeHtmlEntities(optionValues[i]) );
                }

                out.write( "</option>\r\n" );
                out.write( "\r\n" );
            }
            catch( java.io.IOException exc ) {}
        }
    }

    private String ifOneIsSelectedGetAssigneeName( MxObjSelections eventSelections )
    {
        String oneName = "";
        AlertObject alertDataObj = null;

        MxObjList selectedEventNodes = getSelectedEventNodes( eventSelections );

        if ( selectedEventNodes.size() == 1 )
        {
            AlertController myController = getMyAlertController();
            MxObj oneSelectionObj = selectedEventNodes.get( 0 );
            int nOneSelectionID = oneSelectionObj.getAsId( MxObj.TYPE_EVENT );

            try
            {
                alertDataObj = myController.getAlert( nOneSelectionID );
            }
            catch( Exception e ) { return( "" ); }

            oneName = alertDataObj.getAssignedTo();
            if ( oneName == null )
                oneName = "";
        }

        return ( oneName );
    }
%>

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);
    resourceBean.init(loginBean,"ViewEvents");

    int numOfExistingAssignees = 0;
    int maxStrLen = 0;
    int maxStrLenIndex = 0;
    String oneAssigneeName = "";
    String debugText = "NONE!";

    oneAssigneeName = ifOneIsSelectedGetAssigneeName( selectionBean );

    numOfExistingAssignees = getAllExistingAssigneeCount();
    String[] allExistingAssigneeNames = new String[ numOfExistingAssignees ];

    if ( numOfExistingAssignees > 0 )
    {
        getAllExistingAssigneeNames( allExistingAssigneeNames );

        maxStrLenIndex = findLongestStrLengthIndex( allExistingAssigneeNames, numOfExistingAssignees );
        maxStrLen = allExistingAssigneeNames[ maxStrLenIndex ].length();
        if ( maxStrLen < 25 )
        {
            maxStrLen = 25;
        }
        else
        {
            maxStrLen += 3;
        }
    }
    else
    {
        maxStrLen = 25;
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("okButtonID", resourceBean.getString("ViewEvents.ButtonOK"),
                                      "assignEventsClicked()"));
    buttons.addMxTag(new MxDefaultTag("cancelButtonID", resourceBean.getString("ViewEvents.ButtonCancel"),
                                      "cancelAssignEventTo()"));
%>

<html>

    <head>
        <link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>
        <script src="../javascript/EventScript.js"></script>
        <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
        <script language="JavaScript" type="text/javascript">

        function assignEventsClicked()
        {
            var assigneeName = "";
            var isNewAssigneeName = eval( "document.getElementById( \"newAssigneeRadioID\" ).checked" );

            if ( isNewAssigneeName == true )
            {
                assigneeName = eval( "document.getElementById( \"newAssigneeInputID\" ).value" );
            }
            else
            {
                assigneeName = eval( "document.getElementById( \"existingAssigneeSelectID\" ).value" );
            }
            MxPortalWorkspaceSetHelpTopicEx( "monitor_nav_eventView" );
            parent.assignEventsTo(assigneeName);
        }

        function cancelAssignEventTo()
        {
            parent.document.getElementById("ID_EDIT_EVENT_SPACE").contentWindow.document.location.replace("EmptyFrame.jsp?iframe=true");
            MxPortalWorkspaceSetHelpTopic( "monitor_nav_eventView" );
        }

        </script>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body onLoad="OnLoadForAssignToSpace()" onResize="OnResizeForNewEditEventSpace()" onUnload="OnUnloadForNewEditEventSpace()">

        <div class="NewEditEventSpace" id="NewEditEventSpaceID">
            <br>
            <hr>

            <table border="0" cellpadding="0" cellspacing="0" style="width:100%">
                <tr>
                    <td style="width:2%" nowrap><font class="subwindow-header">
                    <%= resourceBean.getString("ViewEvents.SubTitleAssignTo") %>&nbsp;</font></td>
                </tr>
            </table>

            <div>
                <table border="0" cellpadding="0" cellspacing="5">
                    <tr>
                        <td><input type="radio" checked id="newAssigneeRadioID" name="newAssigneeRadio" value="newAssignee" onClick="enableInputBox()" />&nbsp;</td>
                        <td><%= resourceBean.getString("ViewEvents.NewAssignee") %>&nbsp;&nbsp;</td>
                        <td><input type="text" maxlength=50 size=<%= maxStrLen %> id="newAssigneeInputID" name="newAssigneeName" value='<%= oneAssigneeName %>' onKeyUp="enableOKButton( 'newAssigneeInputID' )" /></td>
                    </tr>

                    <tr>
                        <td><input type="radio" id="existingAssigneeRadioID" name="existingAssigneeRadio" value="existingAssignee" onClick="enableSelectBox()" />&nbsp;</td>
                        <td><%= resourceBean.getString("ViewEvents.ExistingAssignee") %>&nbsp;&nbsp;</td>
                        <td>
                            <select id="existingAssigneeSelectID" name="existingAssignee" />
<%
                            if ( numOfExistingAssignees > 0 )
                                buildHTMLOptionTag( out, allExistingAssigneeNames, numOfExistingAssignees, maxStrLenIndex );
%>
                            </select>
                        </td>
                    </tr>
                </table>
            </div>

            <div id="EDIT_EVENT_BUTTONS" style="margin-top:15px">
                <% buttons.dumpButtons(out); %>
            </div>
        </div>

<script>
    enableOKButton( 'newAssigneeInputID' );
    MxPortalRefreshStatusOverview();
</script>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>

</html>
