<%--
/*-------------------------------------------------------------------------
---- Copyright 1997, 2003 Hewlett-Packard Corporation
---------------------------------------------------------------------------
----
---- Title: EventCommonAPI.jsp
----
---- Package:  www.ui.jsp
----
---- Description: Common API used to retreive/update AlertObject
----
----------------------------------------------------------------------------
---- Date: 5/1/2003
---------------------------------------------------------------------------
---- $ProjectName: $
---- $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/EventCommonAPI.jsp,v 1.21 2005/07/30 15:00:31 klee Exp $
----------------------------------------------------------------------------*/
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="
    java.util.*,
    com.hp.mx.core.objectmodel.MxObjectPersistenceException,
    com.hp.mx.portal.alerts.handlers.GenericNoticeHandler,
    com.hp.mx.portal.alerts.handlers.NoticeHandlerInterface,
    com.hp.mx.portal.core.*,
    com.hp.mx.portal.ui.*,
    com.hp.mx.core.controllers.AlertController,
    com.hp.mx.core.alertmanager.AlertObject,
    com.hp.mx.core.alertmanager.AlertState,
    com.hp.mx.core.alertmanager.AlertTypeObject,
    com.hp.mx.core.alertmanager.AlertPersistenceException,
    com.hp.mx.core.alertmanager.UndefinedAlertException,
    com.hp.mx.core.alertmanager.UndefinedAlertTypeException,
    com.hp.mx.core.alertmanager.InvalidAlertException,
    com.hp.mx.core.subjects.usermanager.MxUser"
%>

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);
%>

<%!
    // Global variables
    int     g_NotEnoughPrivilege = 1;
    int     g_EventHasBeenDeleted = 2;
    int     g_DeviceAssociatedWithEventBeenDeleted = 3;

    private MxObjList getSelectedEventNodes( MxObjSelections eventSelections )
    {
        return( eventSelections.getByType( MxObj.TYPE_EVENT ) );
    }

    private void getIDsFromSelections( MxObjList selectedEventNodes, int nSelectionIDs[] )
    {
        int     nNumOfSelections = 0;
        MxObj   oneSelectionObj;

        nNumOfSelections = selectedEventNodes.size();

        for (int i = 0; i < nNumOfSelections; i++ )
        {
            nSelectionIDs[i] = 0;
            oneSelectionObj = selectedEventNodes.get( i );
            nSelectionIDs[i] = oneSelectionObj.getAsId( MxObj.TYPE_EVENT );
        }
    }

    private AlertController getMyAlertController()
    {
        try
        {
            return ( AlertController.getDefaultController() );
        }
        catch( MxObjectPersistenceException exc ) { return( null ); }
    }

    private void updateAssignee( AlertController myController, int nSelectionIDs[], int nNumOfSelections, String newAssignee )
    {
        try
        {
            for ( int i = 0; i < nNumOfSelections; i++ )
            {
                AlertObject alertDataObj = myController.getAlert( nSelectionIDs[i] );
                alertDataObj.setAssignedTo( newAssignee );
                try
                {
                    myController.updateAlert( alertDataObj );
                }
                catch( AlertPersistenceException exc ) {}
            }
        }
        catch( UndefinedAlertException exc ) {}
    }


    private void updateComments( AlertController myController, int nSelectionIDs[], int nNumOfSelections, String newComments )
    {
        try
        {
            for ( int i = 0; i < nNumOfSelections; i++ )
            {
                AlertObject alertDataObj = myController.getAlert( nSelectionIDs[i] );
                alertDataObj.setComments( newComments );
                try
                {
                    myController.updateAlert( alertDataObj );
                }
                catch( AlertPersistenceException exc ) {}
            }
        }
        catch( UndefinedAlertException exc ) {}
    }


    private boolean setStateToClear( AlertController myController, int nSelectionIDs[], int nNumOfSelections, String reasonWhyNotAllCleared )
    {
        boolean isOK = true;

        try
        {
            for ( int i = 0; i < nNumOfSelections; i++ )
            {
                AlertObject alertDataObj = myController.getAlert( nSelectionIDs[i] );

                if ( alertDataObj.getState() == AlertState.INPROGRESS.getEventStateId() )
                {
                    reasonWhyNotAllCleared = "pending";
                    isOK = false;
                }
                else
                {
                    // Test if there is no assignee. If so initialize to "".  Otherwise the applet will show as "null" string
                    if ( alertDataObj.getAssignedTo() == null )
                    {
                        alertDataObj.setAssignedTo( "" );
                    }

                    // Test if there is no comments.  Iff so initialize to "".  Otherwise the applet will show as "null" string
                    if ( alertDataObj.getComments() == null )
                    {
                        alertDataObj.setComments( "" );
                    }

                    alertDataObj.setState( AlertState.CLEARED.getEventStateId() );
                }

                try
                {
                    myController.updateAlert( alertDataObj );
                }
                catch( AlertPersistenceException exc ) { return( false ); }
            }
        }
        catch( UndefinedAlertException exc ) { return( false ); }

        return( isOK );
    }


    private boolean deleteEvents( AlertController myController, int nSelectionIDs[], int nNumOfSelections, String reasonWhyNotAllDeleted )
    {
        boolean isOK = true;

        try
        {
            for ( int i = 0; i < nNumOfSelections; i++ )
            {
                AlertObject alertDataObj = myController.getAlert( nSelectionIDs[i] );

                // Check if it is discovered event.  If so cannot delete
                if ( alertDataObj.getState() == 1 )
                {
                    reasonWhyNotAllDeleted = "discovery events";
                    isOK = false;
                }
                else
                {
                    try
                    {
                        myController.removeAlert( nSelectionIDs[i] );
                    }
                    catch ( UndefinedAlertTypeException exc ) { return( false ); }
                    catch ( AlertPersistenceException exc ) { return( false ); }
                    catch ( InvalidAlertException exc ) { return( false ); }
                }
            }
        }
        catch( UndefinedAlertException exc ) { return( false ); }

        return( isOK );
    }



    private void getHTMLForEventType( JspWriter out, String titleStr, String alertTypeShortDesc )
    {
         try
        {
            out.write( "<font class=\"subwindow-header\">" );
            out.write( titleStr );
            out.write( " " + alertTypeShortDesc + "</font>\r\n" );
            out.write( "<br><br><br>" );
        }
        catch( java.io.IOException exc ) {}
    }


    private int viewEventDetails( int alertID, JspWriter out, HttpSession session, MxLoginBean loginBean, ResourceBundle bundle )
    {
        AlertController myController = getMyAlertController();
        AlertObject alertDataObj = null;
        AlertTypeObject alertTypeObj = null;
        NoticeHandlerInterface eventTypeHandler = null;
        String errorStr = new String( "A_OK" );
        MxUser user = loginBean.getMxUser();

        try
        {
            alertDataObj = myController.getAlert( alertID );
        }
        catch ( UndefinedAlertException exc ) {}

        if ( alertDataObj != null )
        {
            Locale locale= loginBean.getLocale();


            String titleStr = ( String ) bundle.getObject( "ViewEventDetails.Title" );

            try
            {
                alertTypeObj = myController.getAlertType( alertDataObj.getType(), locale );

                if ( alertTypeObj == null )
                    return( g_EventHasBeenDeleted );
            }
            catch( UndefinedAlertTypeException exc ) {}

            if ( ( alertTypeObj.getPrivilegeLevel() == null ) || ( user.hasPrivilege( alertTypeObj.getPrivilegeLevel() ) ) )
            {
                try
                {
                    eventTypeHandler = alertTypeObj.getHandlerClass();
                }
                catch( Exception exc )
                {
                    return( g_EventHasBeenDeleted );
                }

                getHTMLForEventType( out, titleStr, alertTypeObj.getShortDescription() );
                eventTypeHandler.setTaskClient(loginBean.getTaskClient());
                try
                {
                    eventTypeHandler.getHTML( alertDataObj, out, locale, loginBean.getTimeZone(), user, GenericNoticeHandler.HTML_MSG_BROWSER_LINKS );
                }
                catch ( NullPointerException exc )
                {
                    return( g_DeviceAssociatedWithEventBeenDeleted );
                }

                return( 0 );
            }

            return( g_NotEnoughPrivilege );
        }

        return( g_EventHasBeenDeleted );
    }


    private void displayEventDetailsPrintButton ( JspWriter out, String buttonPrintEventDetails, String closeEventDetails, int alertID )
    {
        MxButtons buttons = new MxButtons();
        buttons.clearMxTags();

        try
        {
            out.write( "<div style=\"margin-top:15px\">\r\n" );
            buttons.addMxTag(new MxDefaultTag("printEventDetailsButtonID", buttonPrintEventDetails, "loadPrintPreviewEventDetails(" + String.valueOf( alertID )+ ")"));
            buttons.addMxTag(new MxDefaultTag("closeEventDetailsButtonID", closeEventDetails, "parent.closeEventDetailSpace()"));
            buttons.dumpButtons(out);
            out.write( "\r\n" );
            out.write( "</div>\r\n" );
        }
        catch( java.io.IOException exc ) {}
    }
%>




