<%--
/*-------------------------------------------------------------------------
---- Copyright 1997, 2003 Hewlett-Packard Corporation
---------------------------------------------------------------------------
----
---- Title: PrintPreviewEventDetails.jsp
----
---- Package:  www.ui.jsp
----
---- Description: Display the event details in separate browser that will be
----                    used to print the data
----
----------------------------------------------------------------------------
---- Date: 5/1/2003
---------------------------------------------------------------------------
---- $ProjectName: $
---- $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/PrintPreviewEventDetails.jsp,v 1.15 2005/04/28 00:42:11 pehavens Exp $
----------------------------------------------------------------------------*/
--%>

<%@ page import="com.hp.mx.core.nodemanager.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.*" %>

<jsp:useBean id="selectionBean" class="com.hp.mx.portal.core.MxObjSelections" scope="session"/>
<jsp:useBean id="loginBean" scope="session" class="com.hp.mx.portal.ui.MxLoginBean"/>
<jsp:useBean id="PrintPreviewEventDetailsRes" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />


<%@ include file="EventCommonAPI.jsp" %>

<%

    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);

    PrintPreviewEventDetailsRes.init(loginBean,"ViewEventDetails");

    String errorAlert = "A_OK";

    // get all the resources for this page
    ResourceBundle bundle = PrintPreviewEventDetailsRes.getBundle();
    String printReportTitle = ( String ) bundle.getObject( "ViewEventDetails.PrintReportTitle" );
%>

<html>
    <head>

        <link type='text/css' rel='stylesheet' href='../StyleSheets/ViewEventDetails.css'>
        <script src="../javascript/EventScript.js"></script>

        <title>
            <%= printReportTitle %>
        </title>

    </head>

    <body>
<%
    int alertId = 0;

    try
    {
        alertId = Integer.parseInt( request.getParameter( "alertID" ) );
    }
    catch( NumberFormatException exc ) {}


    int returnCode = viewEventDetails( alertId, out, session, loginBean, bundle );

    if ( returnCode != 0 )
    {
        if ( returnCode == g_NotEnoughPrivilege )
            errorAlert = ( String ) bundle.getObject( "ViewEventDetails.NotEnoughPrivilege" );
        else if ( returnCode == g_EventHasBeenDeleted )
            errorAlert = ( String ) bundle.getObject( "ViewEventDetails.EventHasBeenDeleted" );
        else errorAlert = ( String ) bundle.getObject( "ViewEventDetails.DeviceAssociatedWithEventBeenDeleted" );

%>
        <script>
            alert( '<%= errorAlert %>' );
            window.close();
        </script>
<%
    }
%>

    </body>
</html>
