<%--
/*-------------------------------------------------------------------------
---- Copyright 1997, 2001 Compaq Computer Corporation
---------------------------------------------------------------------------
----
---- Title: viewLoader.java
----
---- Package:  www.ui.jsp
----
---- Description: Query display page loader
----
----------------------------------------------------------------------------
---- Date: 6/27/2000
----------------------------------------------------------------------------
---- $ProjectName: j:/maple/coreWap.pj $
---- $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/ViewsLoader.jsp,v 1.68.4.1 2005/09/21 18:12:20 klee Exp $
----------------------------------------------------------------------------*/
--%>

<%@ page import="java.io.IOException" %>
<%@ page import="com.hp.mx.core.client.MxCollectionClient" %>
<%@ page import="com.hp.mx.core.objectmodel.MxGUID" %>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID" %>
<%@ page import="com.hp.mx.core.querymanager.*" %>
<%@ page import="com.hp.mx.portal.session.UserSession" %>
<%@ page import="com.hp.mx.html.table.MxTableController" %>
<%@ page import="com.hp.mx.portal.list.MxSystemsListRenderer" %>
<%@ page import="com.hp.mx.portal.list.MxSystemsListInstance" %>
<%@ page import="com.hp.mx.html.table.MxTableView2" %>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="XEUtil" scope="session" class="com.hp.mx.portal.applet.utilities.XeJspUtil"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="systemsListsBean" class="com.hp.mx.portal.list.MxSystemsLists" scope="session"/>

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization
    // and page caching)
    MxBean.jspInit(request, response);

    String szMyTimeStamp = null;
    String szTaskWizardTimeStamp = null;
    boolean bRetainSelection = false;
    boolean bSelectionOnly = false;
    boolean bGridView = false;

    // Used to determine whether or not to bypass authorizations and show the
    // full list of nodes. This will only work if the user has FULL rights and
    // is intended to allow the user to authorize himself for more nodes.
    boolean bNoAuthFilter = false;

    String szRetainSelectionParam = null;
    String szSelectionOnlyParam = null;
    String szNoAuthFilter = null;

    try
    {
        Integer viewId = new Integer(-1);
        UserSession userSession = loginBean.getXeUserSession();
        String viewIdStr =  request.getParameter("viewid");
        if (null != viewIdStr)
        {
            viewId  = new Integer(viewIdStr);
        }

        // Create a timestap to be used with the Instance repository
        szMyTimeStamp = systemsListsBean.getNewTimeStamp();

        // Check to see if the URL is specifying the viewMode, this overrides user preference
        String szViewMode = request.getParameter("viewMode");
        String szTreeViewId = request.getParameter("treeViewId");
        if (szTreeViewId != null)
            viewIdStr = szTreeViewId;

        if (szViewMode == null)
        {
            String szDefaultView = request.getParameter("defaultView");
            if (szDefaultView != null)
            {
                if (szDefaultView.equals("treeview"))
                    szViewMode = "tree";
                else if (szDefaultView.equals("iconview"))
                    szViewMode = "icon";
                else
                    szViewMode = "details";
            }
        }

        // See if we were called with a timeStamp parameter for use with task wizard selection
        szTaskWizardTimeStamp = request.getParameter("timeStamp");
        szRetainSelectionParam = request.getParameter("retainSelection");
        szSelectionOnlyParam = request.getParameter("selectionOnly");
        szNoAuthFilter = request.getParameter("authFilter");


        if (szNoAuthFilter != null)
        {
            bNoAuthFilter = true;
        }

        if (szRetainSelectionParam != null)
        {
            bRetainSelection = true;
        }

        if (szSelectionOnlyParam != null)
        {
            bSelectionOnly = true;
        }

        if (szViewMode != null && szViewMode.equalsIgnoreCase("icon"))
        {
            bGridView = true;
        }


        String viewType =   (String) session.getAttribute("AppLoader.ViewType");
        if ((viewType != null) && (viewType.equalsIgnoreCase("EventViews")))
            viewType = View.EVENT_VIEWS;
        else if ((viewType != null) && (viewType.equalsIgnoreCase("CollectionTree")))
            viewType = "collectionTree";
        else if ((viewType != null) && (viewType.equalsIgnoreCase("ListTree")))
            viewType = "listTree";
        else
            viewType = View.DEVICE_VIEWS;

        MxUser curUser =  loginBean.getMxUser();

        String baseStr = "view."+viewIdStr;

        if (viewType != null && viewType.equals("collectionTree") &&
              (szViewMode != null && szViewMode.equals("tree")))
        {
            String collectionLUID = request.getParameter("collectionLUID");
            String szRetainSelection = "";
            if (bRetainSelection)
                szRetainSelection = "&retainSelection=true";
            out.println("<iframe id='TREE_FRAME' class='tree-iframe-border' src='/mxportal/home/MxCollectionTreeView.jsp?collectionLUID=" + collectionLUID + szRetainSelection + "' width='100%' height='100%'></iframe>");
            out.println("<script language=\"JAVASCRIPT\">treeIsInitialized();</script>");
        }
        else if ((viewType != null && (viewType.equals("listTree"))) ||
                    (szViewMode != null && szViewMode.equals("tree")))
        {
            String szRetainSelection = "";
            String szExpandAll = "";
            if (bRetainSelection)
                szRetainSelection = "&retainSelection=true";
            if (request.getParameter("expandAll") != null)
                szExpandAll = "&expandAll=true";
            out.println("<iframe id='TREE_FRAME' class='tree-iframe-border' src='/mxportal/home/MxTreeView.jsp?queryId=" + viewIdStr + szRetainSelection + szExpandAll + "' width='100%' height='100%'></iframe>");
            out.println("<script language=\"JAVASCRIPT\">treeIsInitialized();</script>");
        }
        else
        {
            MxSystemsListInstance systemsListInst = new MxSystemsListInstance(loginBean,
                                                                             userSession,
                                                                             viewId,
                                                                             szMyTimeStamp,
                                                                             szTaskWizardTimeStamp,
                                                                             bRetainSelection,
                                                                             bSelectionOnly,
                                                                             bNoAuthFilter,
                                                                             bGridView);
            if (viewType != null && viewType.equals("collectionTree"))
            {
                // If this is the table view of a collection, create a dynamic
                // query for the flattened nodes in the collection
                String collectionLUID = request.getParameter("collectionLUID");
                MxCollectionClient collClient = loginBean.getCollectionClient();
                MxObjectID oCollId = new MxObjectID(new MxGUID(Long.parseLong(collectionLUID)));
                Query newQuery = collClient.createDynamicQuery(oCollId);
                viewId = new Integer(newQuery.getQueryId());
                systemsListInst.setViewId(viewId);
            }

            // place the instance of the systems list into the repository
            systemsListsBean.putInstance((Object)systemsListInst, szMyTimeStamp);

            try
            {
                systemsListInst.initializeTableView();
            }
            catch (Exception e)
            {
                System.out.println("MxSystemsListInstance.initializeTableView - failed");
                System.out.println(e);
                return;
            }

            MxTableView2 tableView = systemsListInst.getSystemListTableView();
            MxTableController tableController = systemsListInst.getSystemsListTableController();

            MxHtmlUtil.dumpHeadBegin(out);
            tableView.dumpHeadContent(out);
            MxHtmlUtil.dumpHeadEnd(out);
            try
            {
                systemsListInst.dumpStatusPanel(out);
            }
            catch (IOException ex)
            {
                System.out.println("Unable to dump Summary Panel");
                System.out.println(ex);
            }

            tableController.dumpWholeTable(out);
    %>
<script src="<%=MxOptions.URL_BASE%>/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script language="JavaScript" type="text/javascript">


// used for the "onUnload" function to remove instances
var thisTimeStamp = "<%=szMyTimeStamp%>";

function mySystemListSelectionChanged(szIdTable, iRow, bSelected)
{
    var selectionCount = MxTableGetSelectionCount(szIdTable);

    if (selectionCount >= 1)
    {
        selectionMade();
    }
    else
    {
        var bIsUpdate = (iRow == null && bSelected == null)
        selectionCleared(bIsUpdate);
    }
}

function mySystemListAutoUpdate(szIdTable)
{
    myOnResize();
    if (!MxTableIsEmpty("<%=MxSystemsListInstance.ID_SYSTEM_LIST_TABLE%>"))
    {
        ourButtonManager.enableButtonById("<%=MxSystemsListRenderer.ID_PRINT_BUTTON%>");
    }
    else
    {
        ourButtonManager.disableButtonById("<%=MxSystemsListRenderer.ID_PRINT_BUTTON%>");
    }

    document.getElementById("<%=MxSystemsListRenderer.ID_AUTO_UPDATE_IFRAME%>").contentWindow.document.location.replace(
        "MxTableViewActions.jsp?systemListTimeStamp=" + <%=szMyTimeStamp%> + "&autoUpdate=true");
}

function updateStatusPanel(szStatusPanelHtml)
{
    document.getElementById("<%=MxSystemsListRenderer.ID_STATUS_SUMMARY_PANEL%>").innerHTML = szStatusPanelHtml;
}

function tableOnLoad()
{
    <% tableView.dumpOnLoadContent(out); %>
}

function clearEvents()
{
    clearEventsWork("<%=szMyTimeStamp%>");
}

function deleteEvents()
{
    deleteEventsWork("<%=szMyTimeStamp%>");
}

function enterComments(commentsToAdd)
{
    enterCommentsWork(commentsToAdd, "<%=szMyTimeStamp%>");
}

function assignEventsTo(assignee)
{
    assignEventsToWork(assignee, "<%=szMyTimeStamp%>");
}
</script>
<%
        }

        MxHtmlUtil.dumpBodyEnd(out);
    }
    catch (Exception ex)
    {
        ex.printStackTrace();
    }
%>
<script language="JavaScript" type="text/javascript">

function deleteButtonClicked()
{
    tableDeleteWork("<%=szMyTimeStamp%>");
}

function printButtonClicked()
{
    tablePrintWork("<%=szMyTimeStamp%>");
}

</script>
