<%--
//-------------------------------------------------------------------------------
//---- © 2003 Hewlett-Packard Development Group, L.P.
//-------------------------------------------------------------------------------
// Author: George Chuang
//
// Description: Ping Node Result Page
//-------------------------------------------------------------------------------
// $ProjectName: j:/maple/coreWap.pj $
// $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/pingResult.jsp,v 1.22 2005/04/01 23:24:07 chuangg Exp $
//-------------------------------------------------------------------------------
--%>

<%@ page import="com.hp.mx.html.core.*,
            com.hp.mx.portal.ui.*,
            com.hp.mx.utilities.*,
            java.util.*,
            java.io.*"
%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="rbPing" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);

    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    rbPing.init(loginBean,"PingResult");
    String tblTitle = rbPing.getString("PingResult.Title");
    String hdrName = rbPing.getString("PingResult.hdrName");
    String hdrType = rbPing.getString("PingResult.hdrType");
    String hdrAddress = rbPing.getString("PingResult.hdrAddress");
    String hdrProduct = rbPing.getString("PingResult.hdrProduct");
    String hdrOSName = rbPing.getString("PingResult.hdrOSName");
    String hdrResult = rbPing.getString("PingResult.hdrResult");
    String lbl1 = rbPing.getString("PingResult.PingLabel");
    String hdrTime = rbPing.getString("PingResult.hdrTime");
    String unknown = rbPing.getString("PingResult.Unknown");
%>

<html>
    <head>
        <title><%=tblTitle%></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxTable.css'>
        <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

        <script language='javascript' type='text/javascript'>

        var rowIndex = 1;

        function updateStatus(theTime)
        {
            document.getElementById("pingStatus").innerHTML="";
            document.getElementById("pingTime").innerHTML="<%=rbPing.getString("PingResult.TimeLabel")%>" + "  " + theTime;
        }

        function addCell(oRow, value, errFlag, cellIndex)
        {
            newCell = oRow.insertCell(cellIndex);
            if (newCell != null)
            {
                newCell.className = "mxtable-content";
                if ( errFlag!="" )
                {
                    newCell.style.color = "red";
                }
                if ( value == "" )
                    value = "<%=unknown%>";
                newCell.innerHTML = value;
            }
        }

        function addRow(devName,devType,devAddr,productName,osName,devResult,responseTime)
        {
            newRow = document.getElementById("tableResult").insertRow(rowIndex++);
            if ( newRow != null )
            {
                //newRow.WIDTH = "100%";
                newCellNum = 0;
                addCell(newRow,devName,"",newCellNum++);
                addCell(newRow,devType,"",newCellNum++);
                addCell(newRow,devAddr,"",newCellNum++);
                addCell(newRow,productName,"",newCellNum++);
                addCell(newRow,osName,"",newCellNum++);
                errFlag = "error";
                if ( devResult=="" )
                {
                    devResult = "<%=rbPing.getString("PingResult.CannotPing")%>";
                }
                else if ( devResult=="0" )
                {
                    errFlag = "";
                    devResult = "<%=rbPing.getString("PingResult.Replied")%>";
                }
                else if ( devResult=="1" )
                {
                    devResult = "<%=rbPing.getString("PingResult.TiimeOut")%>";
                }
                else if ( devResult=="2" )
                {
                    devResult = "<%=rbPing.getString("PingResult.DevDeleted")%>";
                }
                else
                {
                    devResult = "<%=rbPing.getString("PingResult.NoAddr")%>";
                }
                addCell(newRow,devResult,errFlag,newCellNum++);
                if ( responseTime=="0" )
                {
                    responseTime = "<1";
                }
                addCell(newRow,responseTime+" msec","",newCellNum++);
            }

            //doScroll is for IE only
            //document.body.doScroll("scrollbarDown");
        }

        function myOnLoad()
        {
            MxPortalWorkspaceSetHelpTopic("useTools_devicePing");
        }

        </script>

        <% MxHtmlUtil.dumpHeadBegin(out); %>
        <% MxHtmlUtil.dumpHeadEnd(out); %>
    </head>

    <body onLoad='myOnLoad();'>

        <!-- Display the title and timestamp. -->

        <table width="100%" border="0" cellspacing="0" cellpadding="0">
            <tr width="100%">
                <td><H5><%=tblTitle%></H5></td>
                <td id="pingTime" align="RIGHT" style="font-size:8.5pt"></td>
                <td id="pingStatus" align="RIGHT"><H5><%=lbl1%></H5></td>
            </tr>
        </table>

        <!-- Display results -->

        <table class="mxtable-outer" width="100%" id="tableResult" cellspacing="0" cellpadding="0">
            <tr>
                <td width="15%" class="mxtable-header"><%=hdrName%></td>
                <td width="14%" class="mxtable-header"><%=hdrType%></td>
                <td width="14%" class="mxtable-header"><%=hdrAddress%></td>
                <td width="15%" class="mxtable-header"><%=hdrProduct%></td>
                <td width="14%" class="mxtable-header"><%=hdrOSName%></td>
                <td width="14%" class="mxtable-header"><%=hdrResult%></td>
                <td width="14%" class="mxtable-header-last"><%=hdrTime%></td>
            </tr>
        </table>

        <BR>

        <% MxHtmlUtil.dumpBodyEnd(out); %>
    </body>
</html>
