<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="common.xsl"></xsl:include>
	<xsl:template name="BladeEnclosure">
		<!-- Rack View Enclosure -->
		<tr>
			<xsl:call-template name="renderFrontView">
			  </xsl:call-template>
		</tr>
		<tr>
			<td width="20">&#160;</td>
		</tr>
		<!--Shankar<tr>
			<xsl:call-template name="renderRearView">
			  </xsl:call-template>
		</tr>-->
	</xsl:template>
	
	<xsl:template name="PowerSupplyEnclosure">
		<xsl:param name="repeat">0</xsl:param>
		<!-- Enclosure 3 Front View -->
		<!--<xsl:if test="$repeat=2">
			<xsl:value-of select="//I18N/L10NFrontView"/>
		</xsl:if>-->
		<tr>
			<td>
				<table class="systemStatusTable" cellspacing="0" cellpadding="0" align="center" border="0">
				<xsl:attribute name="powerZone"><xsl:value-of select="Common/PowerZone"/></xsl:attribute>
					<xsl:attribute name="id"><xsl:value-of select="@name"/></xsl:attribute>
					<tbody>
						<tr>
							<td>
								<table width="240" cellspacing="0" cellpadding="0" border="0">
									<xsl:attribute name="height">
										<xsl:choose>
											<xsl:when test="@type='1U'">
												<xsl:text>22</xsl:text>
											</xsl:when>
											<xsl:otherwise>
												<xsl:text>53</xsl:text>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:attribute>
									<xsl:attribute name="id">
										<xsl:value-of select="@name"/>
											<xsl:text>4</xsl:text>
									</xsl:attribute>
									<tbody>
										<tr>
											<xsl:for-each select="PowerSupplyUnit">
												<xsl:call-template name="renderPU">
													<xsl:with-param name="repeat" select="$repeat"/>
												</xsl:call-template>
											</xsl:for-each>
										</tr>
									</tbody>
								</table>
							</td>
						</tr>
					</tbody>
				</table>
			</td>
		</tr>
		<tr>
			<td width="30">&#160;&#160;&#160;</td>
		</tr>
		<!--Shankar<xsl:if test="$repeat=2">
			<tr>
				<td><xsl:value-of select="//I18N/L10NRearView"/></td>
			</tr>
		</xsl:if>
		<xsl:if test="number($repeat) > 1">
			<xsl:call-template name="PowerSupplyEnclosure">
				<xsl:with-param name="repeat" select="$repeat - 1"/>
			</xsl:call-template>
		</xsl:if>-->
	</xsl:template>
	<xsl:template match="/">
		<xsl:call-template name="Head"/>
		<td width="500">
			<table>
				<tbody>
					<xsl:for-each select="*">
						<tr>
							<xsl:if test="name(.)='BladeEnclosure'">
								<td align="left">
											<xsl:value-of select="//I18N/L10NViewAs"/>
												<select ID="idSelectView" size="1" onchange="onViewChange(this);">
										<xsl:for-each select="Attribute[@Section='NavigationURL']">
											<xsl:choose>
												<xsl:when test="./@Selected='No'">
													<option>
														<xsl:attribute name="value"><xsl:value-of select="./Value"/></xsl:attribute>
														<xsl:value-of select="./Name"/>
													</option>
												</xsl:when>
												<xsl:otherwise>
													<option selected="selected">
														<xsl:attribute name="value"><xsl:value-of select="./Value"/></xsl:attribute>
														<xsl:value-of select="./Name"/>
													</option>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:for-each>
									</select>
								</td>
							</xsl:if>
						</tr>
						<xsl:call-template name="Section">
								<xsl:with-param name="sectionNameDisplay"><xsl:value-of select="//I18N/L10NSystemStatus"/></xsl:with-param>
							<xsl:with-param name="sectionName">
								<xsl:text>System Status</xsl:text>
							</xsl:with-param>
						</xsl:call-template>
						<xsl:call-template name="Section">
							<xsl:with-param name="sectionNameDisplay"><xsl:value-of select="//I18N/L10NIdentification"/></xsl:with-param>
							<xsl:with-param name="sectionName">
								<xsl:text>Identification</xsl:text>
							</xsl:with-param>
						</xsl:call-template>
						<xsl:if test="name(.)='PowerSupplyEnclosure'">
							<xsl:call-template name="Section">
								<xsl:with-param name="sectionNameDisplay"><xsl:value-of select="//I18N/L10NPowerAndThermal"/></xsl:with-param>
								<xsl:with-param name="sectionName">
									<xsl:text>Power and Thermal</xsl:text>
								</xsl:with-param>
							</xsl:call-template>
							<xsl:call-template name="PowerSupplyUnit"/>
						</xsl:if>
					</xsl:for-each>
				</tbody>
			</table>
		</td>
		<td>
			<xsl:for-each select="*">
				<table cellspacing="0" cellpadding="0" align="center" border="0" id="table1">
					<!-- start of container table-->
					<tbody>
						<tr>
							<td bgcolor="#CCCCCC" style="FONT-WEIGHT: bold; CURSOR: default; COLOR: white; BORDER-BOTTOM: #484848 2px solid; BACKGROUND-COLOR: #666666">
								<xsl:text> </xsl:text>
								<img height="13" width="13" align="top" border="0">
									<xsl:attribute name="title"><xsl:value-of select="./@titleStatus"/></xsl:attribute>
									<xsl:attribute name="src"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="./@status"/><xsl:text>.gif</xsl:text></xsl:attribute>
								</img>
								<xsl:text>&#160;</xsl:text>
								<xsl:value-of select="@name"/>
							</td>
						</tr>
						<xsl:if test="name(.)='BladeEnclosure'">
							<tr>
								<td align="left" bgcolor="#CCCCCC">
									<div style="BORDER-RIGHT: #000000 1px solid; BORDER-LEFT: #000000 1px solid; ">
										<table cellspacing="0" cellpadding="0" border="0" id="table2">
											<tbody>
												<tr>
													<td>
														<table cellspacing="0" cellpadding="0" border="0" id="table3">
															<tbody>
																<tr>
																	<td>
																		<table cellspacing="8" cellpadding="0" border="0" id="table4">
																			<tbody>
																				<tr>
																					<td>
									<xsl:value-of select="//I18N/L10NSelect"/>
								</td>
																				</tr>
																				<tr>
																					<td>
																						<input type="checkbox" name="allservers" value="ON" onclick="applySelection(this)"/> 
									<xsl:value-of select="//I18N/L10NAllBlades"/>
								</td>
																				</tr>
																				<tr>
																					<xsl:if test="./@type='p-class'">
																					<td>
																						<input type="checkbox" name="allswitches" value="ON" onclick="applySelection(this)"/> 
								<xsl:value-of select="//I18N/L10NAllInterconnectSwitches"/></td>
																					</xsl:if>
																				</tr>
																			</tbody>
																		</table>
																	</td>
																</tr>
															</tbody>
														</table>
													</td>
												</tr>
											</tbody>
										</table>
									</div>
								</td>
							</tr>
						</xsl:if>
						<tr>
							<td align="center">
								<div style="BORDER-RIGHT: #000000 1px solid; BORDER-LEFT: #000000 1px solid; BORDER-BOTTOM: #000000 1px solid">
									<!--Table 1-->
									<table class="window-border-table-small" cellspacing="0" cellpadding="0" border="0" id="table5">
										<tbody>
											<tr>
												<td bgcolor="#CCCCCC" align="center" colspan="2">
													<!--Shankar<xsl:attribute name="height"><xsl:choose><xsl:when test="name(.)='BladeEnclosure'"><xsl:text>260</xsl:text></xsl:when><xsl:otherwise><xsl:text>400</xsl:text></xsl:otherwise></xsl:choose></xsl:attribute>-->
													<xsl:attribute name="height"><xsl:text>200</xsl:text></xsl:attribute><!--Shankar : Added this instead of previous line-->
													<div style="margin-top:-1px;padding:10px;">
														<xsl:attribute name="id"><xsl:value-of select="@name"/></xsl:attribute>
														<table class="window-border-table-small" cellspacing="0" cellpadding="0" border="0">
															<xsl:attribute name="id"><xsl:value-of select="@name"/></xsl:attribute>
															<tbody>
																<tr>
																	<td bgcolor="#CCCCCC" align="left" height="219">
																		<div style="PADDING-RIGHT: 10px; MARGIN-TOP: -1px; PADDING-LEFT: 10px; PADDING-BOTTOM: 10px; PADDING-TOP: 10px">
																			<table cellspacing="0" cellpadding="0" border="0">
																				<xsl:attribute name="id"><xsl:value-of select="@name"/></xsl:attribute>
																				<tbody>
																					<xsl:choose>
																						<xsl:when test="name(.)='BladeEnclosure'">
																							<xsl:call-template name="BladeEnclosure"/>
																						</xsl:when>
																						<xsl:otherwise>
																							<xsl:call-template name="PowerSupplyEnclosure">
																								<xsl:with-param name="repeat" select="number(2)"/>
																							</xsl:call-template>
																						</xsl:otherwise>
																					</xsl:choose>
																				</tbody>
																			</table>
																		</div>
																	</td>
																</tr>
															</tbody>
														</table>
													</div>
												</td>
											</tr>
										</tbody>
									</table>
								</div>
							</td>
						</tr>
					</tbody>
				</table>
			</xsl:for-each>
		</td>
	</xsl:template>
</xsl:stylesheet>
