<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="common.xsl"></xsl:include>

	<xsl:template name="BladeEnclosure">
		<xsl:param name="repeat">0</xsl:param>
		<!-- Rack View Enclosure -->
		<xsl:call-template name="renderFrontView">
			  </xsl:call-template>
		<!--Shankar<td width="24">&#160;</td>
		<xsl:call-template name="renderRearView">
			  </xsl:call-template>-->
		<td width="20">&#160;</td>
		<td valign="top" nowrap="">
			<table class="pad1x10" cellspacing="0" cellpadding="0" border="0">
				<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>6</xsl:text></xsl:attribute>
				<xsl:for-each select="Attribute[@Section='System Status' and (@location='Both' or @location='RackView')]">
					<xsl:call-template name="Attribute"/>
				</xsl:for-each>
				<xsl:for-each select="Attribute[@Section='Identification'  and (@location='Both' or @location='RackView')]">
					<xsl:call-template name="Attribute"/>
				</xsl:for-each>
			</table>
		</td>
	</xsl:template>
	<xsl:template name="PowerSupplyEnclosure">
		<xsl:param name="repeat">0</xsl:param>
		<!-- Enclosure 3 Front View -->
		<td>
			<table cellspacing="0" cellpadding="0" align="center" border="0">
				<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>3</xsl:text></xsl:attribute>
				<tbody>
					<tr>
						<td>
							<!--<xsl:if test="$repeat=2">
								<xsl:value-of select="//I18N/L10NFrontView"/>
							</xsl:if>-->
							<!--Shankar<xsl:if test="$repeat=1">
								<xsl:value-of select="//I18N/L10NRearView"/>
							</xsl:if>-->
							<table class="systemStatusTable" width="250" cellspacing="0" cellpadding="0" border="0">
								<xsl:attribute name="powerZone"><xsl:value-of select="Common/PowerZone"/></xsl:attribute>
								<xsl:attribute name="height">
									<xsl:choose>
										<xsl:when test="@type='1U'">
											<xsl:text>29</xsl:text>
										</xsl:when>
										<xsl:otherwise>
											<xsl:text>62</xsl:text>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:attribute>
								<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>4</xsl:text></xsl:attribute>
								<tbody>
									<tr>
										<xsl:for-each select="PowerSupplyUnit">
											<xsl:call-template name="renderPU">
												<xsl:with-param name="repeat" select="$repeat"/>
											</xsl:call-template>
										</xsl:for-each>
									</tr>
								</tbody>
							</table>
						</td>
						<td align="center" width="26">&#160;&#160;&#160;</td>

						<!--<xsl:if test="number($repeat) > 1">
							<xsl:call-template name="PowerSupplyEnclosure">
								<xsl:with-param name="repeat" select="$repeat - 1"/>
							</xsl:call-template>
						</xsl:if>-->
						<xsl:if test="$repeat=2"><!--Shankarchanged 1 to 2 here to show attributes on rack view at 2 itself-->
							<td valign="top" nowrap="">
								<table class="powerThermalAttributeTable" cellspacing="0" cellpadding="0" border="0">
									<xsl:for-each select="Attribute[@Section='Power and Thermal' and (@location='Both' or @location='RackView')]">
										<xsl:if test="./@displayAsProgress='true'">
											<xsl:attribute name="powerConsumedName"><xsl:value-of select="./Name">
										</xsl:value-of></xsl:attribute>
											<xsl:attribute name="powerConsumedValue"><xsl:value-of select="./Value">
										</xsl:value-of></xsl:attribute>
										</xsl:if>
									</xsl:for-each>
									<tbody>
										<xsl:attribute name="id"><xsl:value-of select="@name"/></xsl:attribute>
										<xsl:for-each select="Attribute[@Section='Identification' and (@location='Both' or @location='RackView')]">
											<xsl:call-template name="Attribute"/>
										</xsl:for-each>
										<xsl:for-each select="Attribute[@Section='Power and Thermal' and (@location='Both' or @location='RackView')]">
											<xsl:choose>
												<xsl:when test="./@displayAsProgress='true'">
									</xsl:when>
												<xsl:otherwise>
													<xsl:call-template name="Attribute"/>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:for-each>
									</tbody>
								</table>
							</td>
						</xsl:if>
					</tr>
				</tbody>
			</table>
		</td>
	</xsl:template>
	
	<xsl:template match="/">
		<xsl:call-template name="Head"/>
		<!-- <font size="2"> -->
			<table>
				<tr>
					<!--Shankar<td width="20">&#160;
</td>
				</tr>
				<tr>
					<td align="left" width="10">
</td> Commenting this out to centre align the rack view-->
					<xsl:if  test="/Rack[@Empty!='true']">
					<!--Shankar<td align="left">Commenting this out to centre align the rack view-->
						<table cellspacing="0" cellpadding="0" align="center" border="0" id="table1">
							<!-- start of container table-->
							<tbody>
								<tr>
									<td align="left">
										<table cellspacing="0" cellpadding="0" border="0" id="table2">
											<tbody>
												<tr>
													<td>
														<table cellspacing="0" cellpadding="0" border="0" id="table3">
															<tbody>
																<tr>
																	<td align="left">
																	<xsl:value-of select="//I18N/L10NViewAs"/>
									<select ID="idSelectView" size="1" onchange="onViewChange(this);">
																			<xsl:for-each select="//Rack/Attribute[@Section='NavigationURL']">
																				<xsl:choose>
																					<xsl:when test="./@Selected='No'">
																						<option>
																							<xsl:attribute name="value"><xsl:value-of select="./Value"/></xsl:attribute>
																							<xsl:value-of select="./Name"/>
																						</option>
																					</xsl:when>
																					<xsl:otherwise>
																						<option selected="selected">
																							<xsl:attribute name="value"><xsl:value-of select="./Value"/></xsl:attribute>
																							<xsl:value-of select="./Name"/>
																						</option>
																					</xsl:otherwise>
																				</xsl:choose>
																			</xsl:for-each>
																		</select>
																	</td>
																</tr>
																<tr>
																	<td align="left"><xsl:value-of select="//I18N/L10NSelect"/>:</td>
																	<td>
																		<table cellspacing="8" cellpadding="0" border="0" id="table4">
																			<tbody>
																				<tr>
																					<td>
																						<input type="checkbox" name="allservers" value="ON" onclick="applySelection(this)"/> 
								<xsl:value-of select="//I18N/L10NAllBlades"/></td>
																					<td>
																						<input type="checkbox" name="allswitches" value="ON" onclick="applySelection(this)"/> 
								<xsl:value-of select="//I18N/L10NAllInterconnectSwitches"/></td>
																				</tr>
																			</tbody>
																		</table>
																	</td>
																</tr>
															</tbody>
														</table>
													</td>
												</tr>
											</tbody>
										</table>
									</td>
								</tr>
								<tr>
									<td align="middle">
										<div style="BORDER-RIGHT: #000000 1px solid; BORDER-LEFT: #000000 1px solid; BORDER-BOTTOM: #000000 1px solid">
											<!--Table 1-->
											<table class="window-border-table-small" cellspacing="0" cellpadding="0" border="0" id="table5"><!--shankar changed width from 720 to 500 to avoid white space on the middle-->
												<tbody>
													<xsl:for-each select="/Rack/*">
														<xsl:choose>
															<xsl:when test="name(.)='BladeEnclosure'">
																<tr>
																	<td style="FONT-WEIGHT: bold; CURSOR: default; COLOR: white; BORDER-BOTTOM: #484848 2px solid; BACKGROUND-COLOR: #666666">
																		<xsl:text> </xsl:text>
																		<img height="13" width="13" align="top" border="0">
																			<xsl:attribute name="title"><xsl:value-of select="./@titleStatus"/></xsl:attribute>
																			<xsl:attribute name="src"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="./@status"/><xsl:text>.gif</xsl:text></xsl:attribute>
																		</img>
																		<xsl:text>&#160;</xsl:text>
																		<a style="text-decoration: none">
																			<xsl:attribute name="href"><xsl:if test="Attribute[@Section='Identification' and @location='RackView']"><xsl:value-of select="./Attribute/@URL"/></xsl:if></xsl:attribute>
																			<font color="white">
																				<xsl:value-of select="@name"/>
																			</font>
																		</a>
																	</td>
																	<td style="FONT-WEIGHT: bold; CURSOR: default; COLOR: white; BORDER-BOTTOM: #484848 2px solid; BACKGROUND-COLOR: #666666 " align="right">
																		<img style="CURSOR: pointer;" src="/mxportal/bladeime/skin/images/win_shrink.gif" border="0">
																			<xsl:attribute name="onclick"><xsl:text>toggleEnclosureVisible (&#39;</xsl:text><xsl:value-of select="@name"/><xsl:text>&#39;, this);</xsl:text></xsl:attribute>
																			<xsl:attribute name="title"><xsl:value-of select="//I18N/L10NMinimize"/></xsl:attribute>
																		</img>
																	</td>
																</tr>
																<tr>
																	<td align="left" colspan="2">
																		<div style="margin-top:-1px;padding:10px;">
																			<xsl:attribute name="id"><xsl:value-of select="@name"/></xsl:attribute>
																			<table class="window-border-table-small" cellspacing="0" cellpadding="0" border="0">
																				<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>1</xsl:text></xsl:attribute>
																				<tbody>
																					<tr>
																						<td align="middle" height="131">
																							<div style="PADDING-RIGHT: 10px; MARGIN-TOP: -1px; PADDING-LEFT: 10px; PADDING-BOTTOM: 10px; PADDING-TOP: 10px">
																								<table cellspacing="0" cellpadding="0" border="0">
																									<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>2</xsl:text></xsl:attribute>
																									<tbody>
																										<tr>
																											<xsl:call-template name="BladeEnclosure">
																												<xsl:with-param name="repeat" select="number(2)"/>
																												<xsl:with-param name="view">
																													<xsl:text>rackView</xsl:text>
																												</xsl:with-param>
																											</xsl:call-template>
																										</tr>
																									</tbody>
																								</table>
																							</div>
																						</td>
																					</tr>
																				</tbody>
																			</table>
																		</div>
																		<div style="display:none; height:10px; width:500;font-size:2px;"><!--Shankar Added a width here to prevent jumping around when min section -->
																			<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>Padding</xsl:text></xsl:attribute>
																			<xsl:attribute name="name"><xsl:value-of select="@name"/><xsl:text>Padding</xsl:text></xsl:attribute>
																		</div>
																	</td>
																</tr>
															</xsl:when>
															<xsl:when test="name(.)='PowerSupplyEnclosure'">
																<tr>
																	<td style="FONT-WEIGHT: bold; CURSOR: default; COLOR: white; BORDER-BOTTOM: #484848 2px solid; BACKGROUND-COLOR: #666666">
																		<xsl:text> </xsl:text>
																		<img height="13" width="13" align="top" border="0">
																			<xsl:attribute name="title"><xsl:value-of select="./@titleStatus"/></xsl:attribute>
																			<xsl:attribute name="src"><xsl:text>/mxportal/bladeime/skin/images/</xsl:text><xsl:value-of select="./@status"/><xsl:text>.gif</xsl:text></xsl:attribute>
																		</img>
																		<xsl:text>&#160;</xsl:text>
																		<a style="text-decoration: none">
																			<xsl:attribute name="href"><xsl:if test="Attribute[@Section='Identification' and @location='RackView']"><xsl:value-of select="./Attribute/@URL"/></xsl:if></xsl:attribute>
																			<font color="white">
																				<xsl:value-of select="@name"/>
																			</font>
																		</a>
																	</td>
																	<td style="FONT-WEIGHT: bold; CURSOR: default; COLOR: white; BORDER-BOTTOM: #484848 2px solid; BACKGROUND-COLOR: #666666" align="right">
																		<img style="CURSOR: pointer;" src="/mxportal/bladeime/skin/images/win_shrink.gif" border="0">
																			<xsl:attribute name="onclick"><xsl:text>toggleEnclosureVisible (&#39;</xsl:text><xsl:value-of select="@name"/><xsl:text>&#39;, this);</xsl:text></xsl:attribute>
																			<xsl:attribute name="title"><xsl:value-of select="//I18N/L10NMinimize"/></xsl:attribute>
																		</img>
																	</td>
																</tr>
																<tr>
																	<td align="left" colSpan="2"><!--shankar Changed this to match alignment with blade enclosures, was just align="middle" before this without col span-->
																		<div style="margin-top:-1px;padding:10px;">
																			<xsl:attribute name="id"><xsl:value-of select="@name"/></xsl:attribute>
																			<table class="window-border-table-small" cellspacing="0" cellpadding="0" border="0">
																				<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>1</xsl:text></xsl:attribute>
																				<tbody>
																					<tr>
																						<td align="middle" height="131">
																							<div style="PADDING-RIGHT: 10px; MARGIN-TOP: -1px; PADDING-LEFT: 10px; PADDING-BOTTOM: 10px; PADDING-TOP: 10px">
																								<table cellspacing="0" cellpadding="0" border="0">
																									<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>2</xsl:text></xsl:attribute>
																									<tbody>
																										<tr>
																											<xsl:call-template name="PowerSupplyEnclosure">
																												<xsl:with-param name="repeat" select="number(2)"/>
																											</xsl:call-template>
																										</tr>
																									</tbody>
																								</table>
																							</div>
																						</td>
																					</tr>
																				</tbody>
																			</table>
																		</div>
																		<div style="display:none; height:10px; width:500;font-size:2px;"><!--Shankar Added a width here to prevent jumping around when min section -->
																			<xsl:attribute name="id"><xsl:value-of select="@name"/><xsl:text>Padding</xsl:text></xsl:attribute>
																			<xsl:attribute name="name"><xsl:value-of select="@name"/><xsl:text>Padding</xsl:text></xsl:attribute>
																		</div>
																	</td>
																</tr>
															</xsl:when>
															<xsl:otherwise>
								  </xsl:otherwise>
														</xsl:choose>
													</xsl:for-each>
												</tbody>
											</table>
										</div>
									</td>
								</tr>
							</tbody>
						</table>
					<!--Shankar</td>Commenting this out to centre align the rack view-->
					</xsl:if>
					<xsl:if  test="/Rack[@Empty='true']">
						<td align="left">
						<font color="#cc0000" ><xsl:value-of select="//I18N/L10NEmptyRackMessage"/></font>
						</td>
					</xsl:if>
					<td align="right" width="20">
				</td>
				</tr>
			</table>
		<!--</font>-->
	</xsl:template>
</xsl:stylesheet>
