<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<%@ page import="com.hp.mx.portal.taskandjob.MxTaskScheduleParams"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobMessages"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String                     timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance       inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);
    MxTaskAndJobResourceBundle rb        = inst.getRB();
    MxTaskAndJobMessages       msgs      = inst.getMessages();

    // Our task schedule parameters
    MxTaskScheduleParams params = new MxTaskScheduleParams(loginBean);

    // build MxParameter array
    int    len            = inst.getParameterLen();
    String paramStrings[] = new String[len];

    for (int i = 0; i < len; i++)
    {
        paramStrings[i] = request.getParameter("PARAM_" + i);
    }

    // if the length (len) of the parameters is zero (0), don't set the value
    // in MxTaskScheduleParams; leave that internal value set to null
    if (len > 0)
    {
        params.setMxParameterStrings(paramStrings);
    }

    // Task Name
    params.setTaskName(request.getParameter("taskName"));

    // Filter Name
    params.setFilterName(request.getParameter("filterName"));

    // Schedule Type (Periodic, List Driven, etc)
    // we save "schedType" because we need it laster in this file
    String schedType = request.getParameter("scheduleType");
    params.setScheduleType(schedType);

    // Run Now, Run On Startup and Disabled flags
    params.setRunNow((request.getParameter("runNow") != null));
    params.setStartWithCMS((request.getParameter("runOnStartup") != null));
    params.setTaskDisabled((request.getParameter("disableTask") != null));

    String  intervalType     = request.getParameter("intervalType");
    boolean success          = true;
    int     saveError        = MxTaskWizardInstance.NO_SAVE_ERROR;
    String  url              = null;
    boolean expiredTimeError = false;

    // periodic schedule
    if (schedType.equalsIgnoreCase("periodical") == true)
    {
        params.setIntervalType(intervalType);
        params.setInterval(request.getParameter("interval"));
        //
        // Periodic Refinement
        //
        // If  MINUTES  setIntervalType() & setInterval()
        //
        // If  HOURS    setIntervalType() & setInterval()
        //
        // If  DAYS     setIntervalType() & setInterval() & setTimeShouldRunAt()
        if (intervalType.equalsIgnoreCase("2") == true)
        {
            success = params.setIntervalTime(request.getParameter("intervalTime"),
                                             request.getParameter("intervalAM"));
        }
        //
        // If  WEEKS    setIntervalType() & setInterval() & setTimeShouldRunAt() & setExecutionDay()
        if (intervalType.equalsIgnoreCase("3") == true)
        {
            params.setIntervalDOW(request.getParameter("intervalDOW"));
            success = params.setIntervalTime(request.getParameter("intervalTime"),
                                             request.getParameter("intervalAM"));
        }
        //
        // If  MONTHS   setIntervalType() & setInterval() & setTimeShouldRunAt()
        if (intervalType.equalsIgnoreCase("4") == true)
        {
            params.setIntervalDOM(request.getParameter("intervalDOM"));
            success = params.setIntervalTime(request.getParameter("intervalTime"),
                                             request.getParameter("intervalAM"));
        }

        //
        // We dn't check for an expired time on the above timesChecks because they
        // don't use a date (01/04/03) string; only a time
        //

        // if success == false, log error an stop checking parameters
        if (success == true)
        {
            // RUN UNTIL DATE/TIME - HERE --> Check for error
            String runUntilDate = request.getParameter("runUntilDate");

            if (runUntilDate != null)
            {
                success = params.setRunUntilDateTime(runUntilDate,
                                                     request.getParameter("runUntilTime"),
                                                     request.getParameter("runUntilAM"));

                if (success == true)
                {
                    if (params.isTimeExpired(params.getRunUntilDateTime().getTime()) == true)
                    {
                        success          = false;
                        saveError        = MxTaskWizardInstance.GENERIC_ERROR;
                        expiredTimeError = true;
                    }
                }
            }
        }

        // These are all TIME CHECKS above - we can display the same error if
        // one of them failed.
        if (success == false)
        {
            saveError = MxTaskWizardInstance.GENERIC_ERROR;

            if (expiredTimeError == true)
            {
                msgs.setMessageType(MxTaskAndJobMessages.MSG_TYPE_ERROR);
                msgs.setMessage(rb.getString("EXPIRED_DATE_ERROR"));
            }
            else
            {
                msgs.setMessageType(MxTaskAndJobMessages.MSG_TYPE_ERROR);
                msgs.setMessage(rb.getString("DATE_TIME_PARSE_ERROR"));
            }
        }
        else
        {
            // MAX RUN COUNT
            String maxRuns = request.getParameter("maxRuns");

            if (maxRuns != null)
            {
                success = params.setMaxRunCount(maxRuns);
            }

            // if success == false, display Max Run Count error message
            if (success == false)
            {
                saveError = MxTaskWizardInstance.GENERIC_ERROR;
                msgs.setMessageType(MxTaskAndJobMessages.MSG_TYPE_ERROR);
                msgs.setMessage(rb.getString("MAX_RUN_PARSE_ERROR"));
            }
        }
    }

    if (schedType.equalsIgnoreCase("once") == true)
    {
        // set the IntervalType == 5 (INTERVAL_RUNATTIME)
        params.setIntervalType(intervalType);

        success = params.setIntervalTime(request.getParameter("intervalDate"),
                                         request.getParameter("intervalTime"),
                                         request.getParameter("intervalAM"));

        if (success == true)
        {
            if (params.isTimeExpired(params.getIntervalTime().getTime()) == true)
            {
                saveError        = MxTaskWizardInstance.GENERIC_ERROR;
                success          = false;
                expiredTimeError = true;
            }
        }

        if (success == false)
        {
            saveError = MxTaskWizardInstance.GENERIC_ERROR;

            if (expiredTimeError == true)
            {
                msgs.setMessageType(MxTaskAndJobMessages.MSG_TYPE_ERROR);
                msgs.setMessage(rb.getString("EXPIRED_DATE_ERROR"));
            }
            else
            {
                msgs.setMessageType(MxTaskAndJobMessages.MSG_TYPE_ERROR);
                msgs.setMessage(rb.getString("DATE_TIME_PARSE_ERROR"));
            }
        }
    }

    // the new owner for the Task
    params.setNewOwner(request.getParameter("owner"));

    if (success == true)
    {
        // save the new Task
        saveError = inst.saveTask(params);

        if (saveError != MxTaskWizardInstance.NO_SAVE_ERROR)
        {
            success = false;
        }
    }
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript'>
            if (<%=success%> == false)
            {
                var parentDoc = findTaskWizardParent(this);
                var url = "<%=MxOptions.URL_BASE%>/taskandjob/scheduleTask.jsp" + parentDoc.buildWizardParams() + "&err=<%=saveError%>";
                location.replace(url);
            }
            else
            {
                // get the new TaskID and JobID (if also "run now") - this clears out the newly
                // created values from the taskWizardBean
                var taskID = '<%= inst.getNewTaskID() %>';
                var jobID  = '<%= inst.getNewJobID() %>';

                if (<%= params.getRunNow() %> == true)
                {
                    if (jobID == "")
                    {
                        MxPortalActionStart('VIEW_JOBS');
                    }
                    else
                    {
                        MxPortalActionStart('VIEW_JOBS', 'select=' + jobID + '&hidden=1');
                    }
                }
                else
                {
                    // display the Task List - with this Task highlighted
                    MxPortalActionStart('VIEW_TASKS', 'select=' + taskID);
                }
            }
        </script>
    </head>
</html>
